//----------------------------------------------------------------------------------------------------
// Common
//----------------------------------------------------------------------------------------------------
function fwkError(msg)
{
	alert("Telosys JavaScript Framework \nRuntime ERROR :\n" + msg ) ;
}
//----------------------------------------------------------------------------------------------------
function $(sId)
{
	if ( sId == null )
	{
		fwkError("$(id) : Parameter 'id' is null" ) ;
		return null ;
	}
	if ( typeof sId != "string" )
	{
		fwkError("$(id) : Parameter 'id' is not a string ( type = " + typeof sId + " )" ) ;
		return null ;
	}
	var obj = document.getElementById(sId) ; 
	if ( obj == null )
	{
		fwkError("$("+sId+") : Cannot found object for id '"+sId+"'" ) ;
		return null ;
	}
	return obj ;
}
//----------------------------------------------------------------------------------------------------
// Returns the object corresponding to the given argument ( object Id or already an object reference )
//----------------------------------------------------------------------------------------------------
function fwkGetObject(arg, argFuncName )
{
	var sFuncName = ( argFuncName != null ? argFuncName : "fwkGetObject" ) ;
	if ( typeof arg == "string" )
	{
		var obj = document.getElementById(arg) ; 
		if ( obj != null )
		{
			return obj ;
		}
		else
		{
			fwkError( sFuncName + "("+arg+") : Cannot found object for id '"+arg+"'" ) ;
			return null ;
		}
	}
	else if ( typeof arg == "object" )
	{
		return arg ; 
	}
	else
	{
		fwkError ( sFuncName + "() invalid argument type ! ( type = " + typeof arg + " )" ) ;
	}
	return null ;
}
//----------------------------------------------------------------------------------------------------
function fwkGetField(sId)
{
	var oField = document.getElementById(sId) ; 
	if ( oField == null )
	{
		fwkError("fwkGetField() : Cannot found object for id "+sId ) ;
	}
	return oField ;
}
//----------------------------------------------------------------------------------------------------
// CHECKED / NOT CHECKED  ( Check Box and Radio Button )
//----------------------------------------------------------------------------------------------------
function fwkSetChecked(arg, bStatus)
{
	var oField = fwkGetObject(arg, "fwkSetChecked");
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			oField.checked = bStatus ;
		}
		else
		{
			fwkError( "fwkSetChecked() : the given object is not a checkbox or a radio button ! ") ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsChecked(arg)
{
	var oField = fwkGetObject(arg, "fwkIsChecked");
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			return oField.checked ;
		}
		else
		{
			fwkError( "fwkIsChecked() : the given object is not a checkbox or a radio button ! ") ;
		}
	}
	return false  ;
}
//----------------------------------------------------------------------------------------------------
// VALUE
//----------------------------------------------------------------------------------------------------
function fwkGetValue(arg)
{
	var oField = fwkGetObject(arg, "fwkGetValue");
	if ( oField != null )
	{
		if ( oField.getValue ) 
		{
			//--- If the field has a specific "getValue" method ( set by RegisterField ) => use it
			return oField.getValue() ;
		}
		else
		{
			//--- Else (no RegisterField) => try to get the value using the "classic way"
			if ( oField.type == "checkbox" )
			{
				//alert ( "checkbox object" );
				if ( oField.checked ) 
				{
					//alert ( "checkbox CHECKED => return value " );
					return oField.value ;
				}
				/***
				else
				{
					alert ( "checkbox NOT CHECKED => return valueoff if any " );
					if ( oField.valueoff ) // Never defined in FF1, OK in IE
					{
						return oField.valueoff ;		
					}
				}
				**/
				// else : standard HTML : not checked => no value
				return null ;
			}
			else
			{		
				// if ( oField.value ) Do not use this test because value is null when the field is empty
				if ( "value" in oField ) // Check attribute by introspection 
				{
					return oField.value ;		
				}
				else
				{
					fwkError ( "fwkGetValue() : No 'value' attribute for field '" + arg + "' !") ;
				}
			}
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetValue(arg,sValue)
{
	var oField = fwkGetObject(arg, "fwkSetValue");
	if ( oField != null )
	{
		if ( oField.setValue ) 
		{
			//--- If the field has a specific "setValue" method ( set by RegisterField ) => use it
			oField.setValue(sValue) ;
		}
		else
		{
			//--- Else (no RegisterField) => try to get the value using the "classic way"
			if ( oField.type == "checkbox" || oField.type == "radio" )
			{
				fwkError ( "fwkSetValue() : Do not use 'fwkSetValue' on a 'checkbox' or 'radio' field  \n"
				+ "without a Screen Body ( because the field is not 'Registered' ).\n" 				
				+ "Use 'fwkSetChecked' instead." ) ;				
			}
			else
			{
				// if ( oField.value ) Do not use this test because value is null when the field is empty
				if ( "value" in oField ) // Check attribute by introspection 
				{
					oField.value = sValue ;
				}
				else
				{
					fwkError ( "fwkSetValue() : No 'value' attribute for field '" + arg + "' !") ;
				}
			}
		}
	}
}
//----------------------------------------------------------------------------------------------------
// NAME
//----------------------------------------------------------------------------------------------------
function fwkGetName(arg)
{
	var obj = fwkGetObject(arg, "fwkGetName");
	if ( obj != null )
	{
		if ( "name" in obj ) // Check attribute by introspection 
		{
			return obj.name ;
		}
		else
		{
			fwkError ( "fwkGetName() : No 'name' attribute for field '" + arg + "' !") ;
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// TYPE
//----------------------------------------------------------------------------------------------------
function fwkGetType(arg)
{
	var obj = fwkGetObject(arg, "fwkGetType");
	if ( obj != null )
	{
		if ( "type" in obj ) // Check attribute by introspection 
		{
			return obj.type ;
		}
		else
		{
			fwkError ( "fwkGetName() : No 'type' attribute for field '" + arg + "' !") ;
		}
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// POSITION (X,Y) 
// Return an array ( [0]->X, [1]->Y ) or null 
//----------------------------------------------------------------------------------------------------
function fwkGetXY(arg)
{
	var obj = fwkGetObject(arg, "fwkGetXY");
	if ( obj != null )
	{		
		var posX = obj.offsetLeft ;
		var posY = obj.offsetTop;
		//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		//--- If the object is nested into another one ( always at least the "BODY" tag )
		while ( obj.offsetParent ) 
		{
			obj = obj.offsetParent ;
			posX += obj.offsetLeft;
			posY += obj.offsetTop;
			//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		}
		return [ posX, posY ];
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// Returns the POSITION (X,Y) as an array ( [0]->X, [1]->Y ) or null
// The origin (0,0) is the first parent element with position="relative"
//----------------------------------------------------------------------------------------------------
function fwkGetRelativeXY(arg)
{
	var obj = fwkGetObject(arg, "fwkGetRelativeXY");
	if ( obj != null )
	{		
		var posX = obj.offsetLeft ;
		var posY = obj.offsetTop;
		//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		//--- If the object is nested into another one ( always at least the "BODY" tag )
		while ( obj.offsetParent ) 
		{
			obj = obj.offsetParent ;
			if ( obj.style.position == "relative" ) break; // Stop here (this is the XY reference)
			posX += obj.offsetLeft;
			posY += obj.offsetTop;
			//alert("Tag " + obj.tagName + " ( " + obj.offsetLeft + ", " + obj.offsetTop + " )" );
		}
		return [ posX, posY ];
	}
	return null  ;
}
//----------------------------------------------------------------------------------------------------
// Show an object ( set visible ) at the given X/Y coordinates
//----------------------------------------------------------------------------------------------------
function fwkShowXY(arg, x, y)
{
	//alert("fwkShowXY ( " + arg + ", " + x + ", " + y + ") " );
	var obj = fwkGetObject(arg, "fwkShowXY");
	if ( obj != null )
	{		
		//alert("fwkShowXY : object " + arg + " : found " );
		obj.style.visibility = "visible" ;
		obj.style.position = "absolute" ;
		if ( x != null && y != null )
		{
			obj.style.left = x + "px" ;
			obj.style.top  = y + "px" ;
		}
		else
		{
			obj.style.left = "0px" ;
			obj.style.top  = "0px" ;
			fwkError("fwkShowXY() : argument X or Y is null !");
		}
	}
}

//----------------------------------------------------------------------------------------------------
// Inner HTML
//----------------------------------------------------------------------------------------------------
function fwkGetInnerHTML(arg)
{
	var obj = fwkGetObject(arg, "fwkGetInnerHTML" );
	if ( obj != null )
	{
		if ( "innerHTML" in obj ) // Check attribute by introspection 
		{
			return obj.innerHTML ;
		}
		else
		{
			fwkError("fwkGetInnerHTML() : No 'innerHTML' attribute for this object !");
		}
	}
	return null ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetInnerHTML(arg,sNewHTML)
{
	var obj = fwkGetObject(arg, "fwkSetInnerHTML");
	if ( obj != null )
	{
		if ( "innerHTML" in obj ) // Check attribute by introspection 
		{
			obj.innerHTML = sNewHTML ;
		}
		else
		{
			fwkError("fwkSetInnerHTML() : No 'innerHTML' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkExecuteInnerScript(arg) 
{
	var element = fwkGetObject(arg, "fwkExecuteInnerScript");
	if ( element != null )
	{
		var scripts = element.getElementsByTagName("script");
		for(var i=0; i<scripts.length; i++) 
		{
			eval(scripts[i].innerHTML);
		}
	}
}

//----------------------------------------------------------------------------------------------------
// ENABLE / DISABLE 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonDisabled(oField, bDisabled)
{
	if ( oField != null )
	{
		if ( oField.id != null )
		{
			var sPictoId = oField.id + "_picto" ;
			var oPicto = document.getElementById(sPictoId);
			if ( oPicto != null )
			{
				if ( oPicto.tagName == "IMG" ) 
				{
					oPicto.style.visibility = ( bDisabled ? "hidden" : "visible" ) ;
				}
			}
			else
			{
				var sButtonId = oField.id + "_button" ;
				var oButton = document.getElementById(sButtonId);
				if ( oButton != null )
				{
					if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
					{
						oButton.disabled = bDisabled ;
					}
					else if ( oButton.tagName == "BUTTON" ) 
					{
						oButton.disabled = bDisabled ;
					}
					else if ( oButton.tagName == "IMG" ) 
					{
						oButton.style.visibility = ( bDisabled ? "hidden" : "visible" ) ;
					}
				}		
			}
		}
	}
	else
	{
		fwkError("fwkSetFieldButtonDisabled() : Field argument is null !");	
	}
}
//----------------------------------------------------------------------------------------------------
function fwkEnable(arg)
{
	var obj = fwkGetObject(arg, "fwkEnable");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			obj.disabled = false ;
			fwkSetFieldButtonDisabled(obj, false);
		}
		else
		{
			fwkError("fwkEnable() : No 'disabled' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkDisable(arg)
{
	var obj = fwkGetObject(arg, "fwkDisable");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			obj.disabled = true ;
			fwkSetFieldButtonDisabled(obj, true);
		}
		else
		{
			fwkError("fwkDisable() : No 'disabled' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsEnabled(arg)
{
	var obj = fwkGetObject(arg, "fwkIsEnabled");
	if ( obj != null )	
	{
		if ( "disabled" in obj ) // Check attribute by introspection 
		{
			return ( obj.disabled != true ? true : false ) ;
		}
		else
		{
			fwkError("fwkIsEnabled() : No 'disabled' attribute for this object !");
		}
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// VISIBILITY 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonVisibility(oField, sVisibility)
{
	if ( oField != null )
	{
		if ( oField.id != null )
		{
			var sPictoId = oField.id + "_picto" ;
			var oPicto = document.getElementById(sPictoId);
			if ( oPicto != null )
			{
				if ( oPicto.tagName == "IMG" ) 
				{
					oPicto.style.visibility = sVisibility ;
				}
			}
			else
			{
				var sButtonId = oField.id + "_button" ;
				var oButton = document.getElementById(sButtonId);
				if ( oButton != null )
				{
					if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
					else if ( oButton.tagName == "BUTTON" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
					else if ( oButton.tagName == "IMG" ) 
					{
						oButton.style.visibility = sVisibility ;
					}
				}		
			}
		}
	}
	else
	{
		fwkError("fwkSetFieldButtonVisibility() : Field argument is null !");	
	}	
}
//----------------------------------------------------------------------------------------------------
function fwkSetVisible(arg)
{
	var obj = fwkGetObject(arg, "fwkSetVisible");
	if ( obj != null )	
	{
		obj.style.visibility = "visible" ;
		fwkSetFieldButtonVisibility(obj, "visible");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkSetHidden(arg)
{
	var obj = fwkGetObject(arg, "fwkSetHidden");
	if ( obj != null )	
	{
		obj.style.visibility = "hidden" ;
		fwkSetFieldButtonVisibility(obj, "hidden");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsVisible(arg)
{
	var obj = fwkGetObject(arg, "fwkIsVisible");
	if ( obj != null )	
	{
		if ( obj.style.visibility == "visible" ) return true ;
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// READONLY
//----------------------------------------------------------------------------------------------------
function fwkSetReadonly(arg, bStatus)
{
	var obj = fwkGetObject(arg, "fwkSetReadonly");
	if ( obj != null )
	{
		if ( "readOnly" in obj ) // Check attribute by introspection 
		{
			obj.readOnly = bStatus ;
		}
		else
		{
			fwkError("fwkSetReadonly() : No 'readOnly' attribute for this object !");
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsReadonly(arg)
{
	var obj = fwkGetObject(arg, "fwkIsReadonly");
	if ( obj != null )
	{
		if ( "readOnly" in obj ) // Check attribute by introspection 
		{
			return ( obj.readOnly ? true : false ) ;
		}
		else
		{
			fwkError("fwkIsReadonly() : No 'readOnly' attribute for this object !");
		}
	}
	return false  ;
}

//----------------------------------------------------------------------------------------------------
function fwkExecInnerScript( obj )
{
	if ( obj != null )
	{
		var scripts = obj.getElementsByTagName("script");
		for(var i=0; i<scripts.length; i++) 
		{
			// Execute the content of the <script> tag
			eval(scripts[i].innerHTML); 
		}
	}
	else
	{
    	fwkError("fwkExecInnerScript : null parameter !");
	}
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows a view content in the given container ID
 * @param  String  the container id
 * @param  String  the view content to set in the 'innerHTML' of the container 
 * @return none
 */	
function fwkShowViewContent(sContainerId, viewContent)
{
    if ( viewContent != null ) 
    {
	    var oElement = document.getElementById(sContainerId);
	    if ( oElement != null )
	    {
	        oElement.innerHTML = viewContent ; // Set the content 
	        fwkExecInnerScript( oElement ); // Execute the <scritp> tags if any 
	    }
	    else
	    {
	    	fwkError("fwkShowViewContent : Container '" + sContainerId + "' not found in this screen !");
	    }
    } 
    else 
    {
        fwkError("fwkShowViewContent : view content parameter is null !" ) ;
    }
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows a view of an action response in the given container ID
 * @param  String  the container id
 * @param  Object  the response 
 * @param  String  the view name 
 * @return none
 */	
function fwkShowActionView(sContainerId, oResponse, sViewTagName)
{
    var viewContent = oResponse.getViewContent(sViewTagName) ;
    if ( viewContent != null ) 
    {
		fwkShowViewContent(sContainerId, viewContent);
    } 
    else 
    {
        fwkError ( "fwkShowActionView : No view content in the response !" ) ;
    }
}
//----------------------------------------------------------------------------------------------------
/**
 * Shows the unique view of a service response in the given container ID
 * @param  String  the container id
 * @param  Object  the service response 
 * @return none
 */	
function fwkShowServiceView(sContainerId, oResponse)
{
    var viewContent = oResponse.getServiceViewContent() ;
    if ( viewContent != null ) 
    {
		fwkShowViewContent(sContainerId, viewContent);
    } 
    else 
    {
		fwkShowViewContent(sContainerId, "");
        //fwkError ( "fwkShowServiceView : No view content in the response !" ) ;
    }
}

//----------------------------------------------------------------------
function fwkGetIFrameDocument( arg )
{
	var iframe = fwkGetObject(arg, "fwkGetIFrameDocument");
	//var iframe = document.getElementById(sId) ;
	if ( iframe != null )
	{
		if ( iframe.contentWindow != null ) // IE + FF 
		{
			return iframe.contentWindow.document;
		}
		else if ( iframe.contentDocument != null )
		{
			return iframe.contentDocument;
		}
		else if ( iframe.document != null )
		{
			return iframe.document;
		}
		else
		{
			fwkError ( "fwkGetIFrameDocument() : Cannot get frame content !" ) ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkGetParentDIV(o)
{
//log.warning("fwkGetParentDIV(..)" );
	if ( o == null ) return null ;
	while ( o.parentNode != null )
	{
		o = o.parentNode ;
		if ( o.nodeName == "DIV" ) return o ;
	}
	return null ;
}
//---------------------------------------------------------------------------
function fwkCancelEvent( evt ) // Stop the event NOW !
{
//log.error("fwkCancelEvent( evt ) ++++++++++++++ ");
	if ( evt != null )
	{
		if ( evt.srcElement != null ) // Internet Explorer 
		{
			evt.cancelBubble = true; // Stop propagation 
			evt.returnValue = false; // No default action 
		}
		else if ( evt.target ) // FireFox
		{
			evt.stopPropagation(); // Stop propagation 
			evt.preventDefault(); // No default action 
		}
	}
	else
	{
		fwkError("fwkCancelEvent() : event is null !")
	}
}
//---------------------------------------------------------------------------
/*
 sURL 
 . "http://xxxxx"
 . "new_page" : load new_page using the same path as the current page ( path/current_page -> path/new_page ) 
 . ".." : path1 of path1/path2/current_page
 . "." : path of path/current_page
 . "../.." 
 . "../new_path"
 . "/" : host root ( e.g. : "http://host:8080/" )
*/
function fwkLoadPage(sURL) 
{
	if ( sURL != null && sURL != "" )
	{
		window.location = sURL ;
		//window.location.replace(sURL) ; // same as window.location = sURL
	}
	else
	{
		fwkError ( "fwkLoadPage : URL is null or void !" ) ;
	}
}
//---------------------------------------------------------------------------
function fwkReloadPage() 
{
	window.location.reload() ;
}
//---------------------------------------------------------------------------
function fwkGetLocation() 
{
	return window.location.href ;
}
//---------------------------------------------------------------------------
function fwkSetFocus(arg) 
{
	var o = fwkGetObject(arg, "fwkSetFocus");
	if ( o != null )	
	{
		o.focus();
	}
}
//---------------------------------------------------------------------------
function fwkSubmitForm(arg) 
{
	var o = fwkGetObject(arg, "fwkSubmitForm");
	if ( o != null )	
	{
		o.submit();
	}
}
//---------------------------------------------------------------------------
function fwkResetForm(arg) 
{
	var o = fwkGetObject(arg, "fwkResetForm");
	if ( o != null )	
	{
		o.reset();
	}
}
//---------------------------------------------------------------------------
