//------------------------------------------------------------------------------
// Fields2.js
//------------------------------------------------------------------------------
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "Date" fields ( cf. RegisterFieldDate )
//----------------------------------------------------------------------
function fwkFieldDateGetValue() // Return the current field value in ISO format
{
	var sRet = null ;
	//alert("fwkFieldDateGetValue() : " + this.value );
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return null ;
	}
		
	if ( this.value == null ) 
	{
		sRet = "";
	}
	else if ( this.value.length == 0 ) 
	{
		sRet = "";
	}
	else
	{
		//--- Convert from field format to ISO format
		try {
			//--- Set the date format as the specific field format
			this.dateValue.setFormat(this.format);
			//--- Try to set the field value in the SimpleDate object
			this.dateValue.setDate(this.value);
			//--- Return the date in ISO format
			sRet = this.dateValue.format("YYYY-MM-DD");
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
	}
	return sRet ;
/**
	try {
		//--- Build a date in the field format 
		var date = new SimpleDate(this.value , this.format );
		//--- Return the date in ISO format
		date.format("YYYY-MM-DD");
		
		// Re affect the current value to check the validity
		//this.date.setDate( this.value ); 
		// Return the ISO format of the date
		//return this.date.format("YYYY-MM-DD");
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
}
//----------------------------------------------------------------------
function fwkFieldDateSetValue(sDateIso)
{
/**
	try {
		//--- Build a date in ISO format 
		var date = new SimpleDate(sDateIso, "YYYY-MM-DD");
		//--- Set the field value with its format 
		this.value = date.format( this.format );
	}
	catch (ex) {
		alert ( "ERROR : invalid date " + this.value ) ;
		return null ;
	}
**/
	var sRet = null ;
	//alert("fwkFieldDateSetValue( " + sDateIso + " )");
	if ( this.dateValue == null ) 
	{
		alert ( "ERROR on Date field : dateValue object is null ! " );
		return ;
	}
	if ( sDateIso == null ) 
	{
		this.value = "";
	}
	else if ( sDateIso.length == 0 ) 
	{
		this.value = "";
	}
	else
	{
		//--- Convert from ISO format to field format 
		try {
			//--- Set the date format as ISO format
			this.dateValue.setFormat("YYYY-MM-DD");
			//alert("fwkFieldDateSetValue : date format = " + this.dateValue.getFormat() + " )");
			//--- Try to set the date value (in ISO format)
			//this.dateValue.show();
			this.dateValue.setDate(sDateIso);
			//this.dateValue.show(); 
			//--- Re-format the date in the specific field format
			sRet = this.dateValue.format(this.format);
		}
		catch (ex) {
			alert ( "ERROR : invalid date " + this.value ) ;
			sRet = null ;
		}
		this.value = sRet ;
	}
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "CheckBox" fields ( cf. RegisterCheckBox )
//----------------------------------------------------------------------
function fwkCheckboxGetValue()
{
	if ( this.checked ) return this.valueChecked ;
	else return this.valueUnchecked ;
}
//----------------------------------------------------------------------
function fwkCheckboxSetValue(sVal)
{
	if ( sVal == this.valueChecked ) this.checked = true ;
	else this.checked = false ;
}

//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "RadioGroup" fields ( cf. RegisterRadioGroup )
//----------------------------------------------------------------------
function fwkRadioGroupGetValue()
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupGetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( oRadio.checked ) return oRadio.value ;
		}
	}
	//--- No radio selected in this group
	return null ;
}
//----------------------------------------------------------------------
function fwkRadioGroupSetValue(sVal)
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupSetValue() : Radios ["+i+"] is null ! " );
		}
		else
		{
			if ( sVal == oRadio.value ) 
			{
				oRadio.checked = true ;
			}
			else
			{
				oRadio.checked = false ;
			}
		}
	}
}
//----------------------------------------------------------------------
function fwkRadioGroupSetDisabled(bFlag)
{
	var oRadio = null ;
	//--- For each "radio" object registered in this "radio group" 
	for ( var i = 0 ; i < this.aRadios.length ; i++ )
	{
		oRadio = this.aRadios[i] ;
		if ( oRadio == null )
		{
			alert("ERROR : fwkRadioGroupSetDisabled() : Radios ["+i+"] is null ! " );
		}
		else
		{
			oRadio.disabled = bFlag ;
		}
	}
}
//----------------------------------------------------------------------
function fwkFieldSetDisabled(bFlag)
{
	//--- Disable the field
	this.disabled = bFlag ;
	//--- If the field has a picto : hide the picto
	if ( this.oPicto )
	{
		if ( bFlag == true ) // disabled
		{
			this.oPicto.style.visibility = "hidden" ;
		}
		else
		{
			this.oPicto.style.visibility = "visible" ;
		}
	}
}
//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "RichTextEditor" fields ( cf. RegisterRichTextEditor )
//----------------------------------------------------------------------
function fwkRTEGetValue()
{
	return fwkRTEGetText(this.id);
}
//----------------------------------------------------------------------
function fwkRTESetValue(sVal)
{
	fwkRTESetText(this.id, sVal )
}
//----------------------------------------------------------------------
// Standard getValue() / setValue() methods
// for "HtmlViewer" fields ( cf. RegisterHtmlViewer )
//----------------------------------------------------------------------
function fwkHtmlViewerSetValue(sVal)
{
	fwkSetInnerHTML(this.id, sVal )
}
//----------------------------------------------------------------------
