//------------------------------------------------------------------------------
// ListView_func.js
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function fwkBindListView ( oListView )
{
	if ( oListView != null )
	{
		var oTBody = fwkGetTBody ( oListView.getListId() );
		if ( oTBody != null )
		{
			oTBody.listView = oListView ;
		}
		else
		{
			alert("ERROR : fwkBindListView() : cannot get TBody ! id '" + sListID + "'" );		
		}
	}
	else
	{
		alert("ERROR : fwkBindListView() : list view argument is null !" );		
	}
}

//------------------------------------------------------------------------------
function fwkCheckListView( oListView )
{
	if ( oListView == null )
	{
		alert("ERROR : no list view instance in the TBody object ! " );				
	}
}

function fwkPrivateSelectRow( oTR, bSimpleSelect )
{
	//alert ( "TRACE : fwkPrivateSelectRow(...," + bSimpleSelect + " ) ... ");
	
	if ( oTR == null )
	{
		alert ( "ERROR : fwkSelectRow() : no argument ! ");
		return ;
	}

	var oTBody = oTR.parentNode;
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );

	var iNewRowIndex = oTR.rowIndex ;
	if ( iNewRowIndex == oListView.getSelectedRowIndex() )
	{
		//--- This row is already selected => noting to do
		return ; 
	}
	
	var bOkToContinue = true ;
	if ( bSimpleSelect )
	{
		bOkToContinue = oListView.doSelect(iNewRowIndex) ;
	}
	
	if ( bOkToContinue )
	{
		oListView.highlightRow(oTR);
	}
}

function fwkCancelEvent( evt )
{
	if ( window.event ) // Microsoft Internet Explorer
	{
		window.event.cancelBubble = true;   
	}
	else if ( evt != null ) // Mozilla, Netscape, FireFox
	{
		if ( evt.stopPropagation == null ) 
		{
			alert ( "ERROR : fwkCancelEvent : no 'stopPropagation' method in event object ! ");
		}
		else 
		{
			evt.stopPropagation();
		}
	}
}

function fwkGetParent( oObject, sNodeName )
{
	var oParent = oObject.parentNode;
	while ( oParent != null )
	{
		if ( oParent.nodeName == sNodeName )
		{
			return oParent ; // Found
		}
		oParent = oParent.parentNode;
	}
	alert ( "ERROR : Cannot found '" + sNodeName + "' parent node for '" + oObject.nodeName + "' object " );
	return null ;
}

function fwkInitNewRow( oNewTR, oTBody )
{
	//--- Get TABLE
	var oTable = fwkGetParent( oNewTR, "TABLE" );
	if ( oTable == null ) return ;
	
	//--- Get TFOOT (from TABLE)
	var oTFoot = oTable.getElementsByTagName("tfoot")[0] ;
	if ( oTFoot == null ) 
	{ 
		alert ( "ERROR : Cannot found <TFOOT> in <TABLE> " ) ; 
		return;
	}
	
	//--- Get TR (from TFOOT)
	var oTemplateTR = oTFoot.getElementsByTagName("tr")[0] ;
	if ( oTemplateTR == null ) 
	{ 
		alert ( "ERROR : Cannot found <TR> TEMPLATE in <TFOOT>  "  ) ; 
		return;
	}

	//--- Clone the TEMPLATE ROW
	var oClone = oTemplateTR.cloneNode(true); // Std DOM ( OK with IE and FF )
	//--- Replace the new row by the TEMPLATE ROW
	//oNewTR.replaceNode(oClone); // IE DOM extension ( Specific IE )
	oTBody.replaceChild(oClone, oNewTR ); // Std DOM ( OK with IE and FF )
	
	//--- Select the new Row
	fwkPrivateSelectRow( oClone, false );
}

//------------------------------------------------------------------------------
// PUBLIC (visible methods)
//------------------------------------------------------------------------------
function fwkGetTBody ( sId, argAlert )  
{
	var bAlert = true ;
	if ( arguments.length > 1 )
	{
		bAlert = argAlert ;
	}
	//--- Get the rows container ( tbody or table )
	var oElement = document.getElementById(sId);
	if ( oElement == null )
	{
		if ( bAlert ) 
		{
			alert ( "ERROR : fwkGetTBody : No element with id = '" + sId + "'"  ) ;
		}
		return null ; 
	}
	
	//--- Get the TBODY element
	var oTBody = null ;
	if ( oElement.nodeName == "TABLE" )
	{
		oTBody = oElement.getElementsByTagName("tbody")[0] ; ;
	}
	else if ( oElement.nodeName == "TBODY" )
	{
		oTBody = oElement ;
	}
	if ( oTBody == null )
	{
		alert ( "ERROR : fwkGetTBody : Element with id = '" + sId + "' is not a 'TABLE' or 'TBODY' "  ) ;
		return null ; 
	}
	return oTBody ;
}
//------------------------------------------------------------------------------
function fwkSelectRow( oTR )
{
	fwkPrivateSelectRow( oTR, true ) ;
}

//------------------------------------------------------------------------------
function fwkSelectFirstRow( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody )
	{
		if ( oTBody.rows.length > 0 ) 
		{
			fwkPrivateSelectRow( oTBody.rows[0], true ) ;
		}
	}
}

//------------------------------------------------------------------------------
function fwkInsertRow( oObject, evt )
{
	fwkCancelEvent(evt); // Cancel Event (vite Click -> Select Row)

	if ( oObject == null )
	{
		alert ( "ERROR : fwkInsertRow() : no object argument ! ");
		return ;
	}
	
	//--- Get TR
	var oTR = fwkGetParent( oObject, "TR" );
	if ( oTR == null ) return ;
	
	//--- Get TBODY
	var oTBody = fwkGetParent( oTR, "TBODY" );
	if ( oTBody == null ) return ;
	
	var iNewRowIndex = oTR.rowIndex ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );
	var bOkToContinue = oListView.doInsert(iNewRowIndex) ;
	
	if ( bOkToContinue )
	{
		//--- Insert a new row in the TBODY rows collection
		//var oNewTR = oTBody.insertRow(oTR.rowIndex);	
		var oNewTR = oTBody.insertRow(iNewRowIndex);	
		//--- Initialize the new row with the template row and select it
		fwkInitNewRow( oNewTR, oTBody );
	}
}

//------------------------------------------------------------------------------
function fwkAddRow ( sId )  
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doAdd() ;
	
	if ( bOkToContinue )
	{
		//--- Add a new row at the end of the list 
		var oNewTR = oTBody.insertRow( oTBody.rows.length ); // Ok / IE & Mozilla	
		//--- Initialize the new row with the template row and select it
		fwkInitNewRow( oNewTR, oTBody );
	}
}

//------------------------------------------------------------------------------
function fwkDeleteRow (oObject) // NB nom "deleteRow" rserv sous Mozilla 
{
	//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
	//cancelEvent inutile la ligne est supprime => pas de propagation
	if ( oObject == null )
	{
		alert ( "ERROR : fwkInsertRow() : no object argument ! ");
		return ;
	}
	
	//--- Get TR
	var oTR = fwkGetParent( oObject, "TR" );
	if ( oTR == null ) return ;

	//--- Get TBODY
	var oTBody = fwkGetParent( oTR, "TBODY" );
	if ( oTBody == null ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	
	//alert ( "rowIndex to delete : " + oTR.rowIndex );
	var iRowIndexToDelete = oTR.rowIndex ;

	//--- Current Index and Index to delete
	var bDeleteCurrentRow = false ;
	if ( iRowIndexToDelete == oListView.getSelectedRowIndex() )
	{
		bDeleteCurrentRow = true ;
	}
	
	var bOkToContinue = oListView.doDelete(iRowIndexToDelete) ;

	if ( bOkToContinue )
	{
		//--- Delete the row 
		oTBody.deleteRow(iRowIndexToDelete);
		
		//--- Select the new current row 
		if ( bDeleteCurrentRow == true )
		{
			if ( oTBody.rows.length > 0 ) // Si il reste au moins une ligne
			{
				if ( iRowIndexToDelete < oTBody.rows.length )
				{
					fwkPrivateSelectRow( oTBody.rows [ iRowIndexToDelete ], false );
				}
				else
				{
					fwkPrivateSelectRow( oTBody.rows [ oTBody.rows.length-1 ], false ) ;
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
function fwkClearList( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;

	//--- Already void => nothing to do 
	if ( oTBody.rows.length == 0 ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doClear() ;
	
	if ( bOkToContinue )
	{
		//--- Clear the "view" list
		while ( oTBody.rows.length > 0 )
		{
			oTBody.deleteRow(0);
		}	
	}
}
//------------------------------------------------------------------------------
function fwkSortList( sId, sField, sOrder )
{
//alert("fwkSortList( " + sId + ", " + sField + ", " + sOrder + " )" );

	var oTBody = fwkGetTBody ( sId );
	if ( oTBody == null ) return ;

	//--- The list is void => nothing to do 
	if ( oTBody.rows.length == 0 ) return ;
	
	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var bOkToContinue = oListView.doSort(sField, sOrder) ;
	
}

//------------------------------------------------------------------------------
function fwkGetRowCount( sId )
{
	var oTBody = fwkGetTBody ( sId );
	if ( oTBody )
	{
		return oTBody.rows.length ;
	}
	return 0 ;
}

//------------------------------------------------------------------------------
function fwkSetColValue(sId, iColIndex, sValue)
{
	var oTBody = fwkGetTBody ( sId, false ); // No alert if no tbody
	if ( oTBody == null ) return ;

	//--- Get ListView instance
	oListView = oTBody.listView ;
	fwkCheckListView( oListView );	
	var oTR = oListView.getSelectedRow() ;
	

	if ( oTR != null )
	{
		if ( iColIndex < 0 )
		{
			alert("ERROR : fwkSetColValue : invalid column index ( " + iColIndex + " ) < 0 " );
			return ;
		}
		if ( iColIndex >= oTR.cells.length )
		{
			alert("ERROR : fwkSetColValue : invalid column index ( " + iColIndex + " ) >= cells.length ( " + this._currentLineTR.cells.length + " )" );
			return ;
		}
		
		var cell = oTR.cells[iColIndex] ;
		if ( cell != null )
		{
			cell.innerHTML = sValue ;
			//cell.innerText = sValue ; // NOK : do not use
		}
		else
		{
			alert("ERROR : fwkSetColValue : cell[" + iColIndex + "] is null !");
		}
	}
}

/***
//------------------------------------------------------------------------------
// OBJECT "ListDetail"
//------------------------------------------------------------------------------
function ListView( sDivListId )
{
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowUp = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowUp ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveUp : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
	
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex > 0 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex-1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex-1]);		
		}
		else
		{
			alert("On est au dbut !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowDown = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowDown ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveRowDown : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex < this._oTBodyList.rows.length-1 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex+1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex+1]);		
		}
		else
		{
			alert("On est  la fin !");
		}
	}		
	//------------------------------------------------------------------------------	
} //--- End of object definition 
***/