//------------------------------------------------------------------------------

//--- Default style values : to be overloaded 
var FWK_LIST_ROW_SELECT_COLOR = null ;
var FWK_LIST_ROW_SELECT_CLASS = "telosys_row_selected" ;

var FWK_LIST_ROW_MOUSE_OVER_COLOR = null ;
var FWK_LIST_ROW_MOUSE_OVER_CLASS = "telosys_row_mouse_over" ;

//------------------------------------------------------------------------------
function fwkListGetTBody( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetSelectedRow" ;
	var oListDivBody = fwkGetObject(arg, sFctName );
	if ( oListDivBody != null )
	{
		//--- Get the <tbody> child tag
		var oTBody = oListDivBody.getElementsByTagName("tbody")[0] ;
		if ( oTBody == null ) 
		{ 
			fwkError ( sFctName + " : Cannot found <TBODY> in <DIV> " + oListDivBody.id ) ; 
		}
		return oTBody ;
	}
	return null ;
}
//------------------------------------------------------------------------------
function fwkListGetRowCount( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListGetRowCount" ) ;
	if ( oTBody != null ) 
	{ 
		return oTBody.rows.length ;
	}
	return 0 ;
}
//------------------------------------------------------------------------------
function fwkListGetRows( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetRows" ;
	var oTBody = fwkListGetTBody( arg, sFctName ) ;
	if ( oTBody != null ) 
	{ 
		//--- Get the ROWS array
		return oTBody.rows ;
	}
	return null;
}
//------------------------------------------------------------------------------
function fwkListGetSelectedRow( arg, sFctArg )
{
	var sFctName = sFctArg != null ? sFctArg : "fwkListGetSelectedRow" ;
	var oTBody = fwkListGetTBody( arg, sFctName ) ;
	if ( oTBody != null ) 
	{ 
		//--- Get the selected row
		return oTBody.fwkSelectedRow ;
	}
	return null;
}
//------------------------------------------------------------------------------
function fwkListSelect( arg, index ) // index : 1 to N
{
	if ( index == null )
	{
		fwkError ( "fwkListSelect : row index is null ! " ) ; 
	}
	var oRows = fwkListGetRows( arg, "fwkListSelect" );
	if ( oRows != null ) 
	{
		if ( index > 0 && index <= oRows.length )
		{
			fwkListRowSelect( oRows[index-1] ) ;					
		}
		else
		{
			fwkError ( "fwkListSelect : invalid index : " + index ) ; 
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectFirst( arg )
{
	var oRows = fwkListGetRows( arg, "fwkListSelectFirst" );
	if ( oRows != null ) 
	{
		if ( oRows.length > 0 )
		{
			fwkListRowSelect( oRows[0] ) ;					
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectLast( arg )
{
	var oRows = fwkListGetRows( arg, "fwkListSelectLast" );
	if ( oRows != null ) 
	{
		if ( oRows.length > 0 )
		{
			fwkListRowSelect( oRows[oRows.length-1] ) ;					
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectNext( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListSelectNext" ) ;
	if ( oTBody != null ) 
	{ 
		var oSelectedRow = oTBody.fwkSelectedRow ;
		if ( oSelectedRow != null )
		{		
			if ( oSelectedRow.rowIndex < oTBody.rows.length-1 )
			{
				fwkListRowSelect( oTBody.rows[oSelectedRow.rowIndex+1] );
			}
		}
	}
}
//------------------------------------------------------------------------------
function fwkListSelectPrev( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListSelectPrev" ) ;
	if ( oTBody != null ) 
	{ 
		var oSelectedRow = oTBody.fwkSelectedRow ;
		if ( oSelectedRow != null )
		{		
			if ( oSelectedRow.rowIndex > 0 )
			{
				fwkListRowSelect( oTBody.rows[oSelectedRow.rowIndex-1] );
			}
		}
	}
}
//------------------------------------------------------------------------------
function fwkListUnSelect( arg )
{
	var oTBody = fwkListGetTBody( arg, "fwkListUnSelect" ) ;
	if ( oTBody != null ) 
	{ 
		if ( oTBody.fwkSelectedRow != null )
		{
			fwkListRowUnSelect( oTBody.fwkSelectedRow );
			oTBody.fwkSelectedRow = null ;
		}
	}	
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkListRowUnSelect( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowUnSelect : no ROW argument ! ");
		return ;
	}
	if ( oTR.fwkOriginalColor != null )
	{
		oTR.style.backgroundColor = oTR.fwkOriginalColor ; // Restore original color
	}
	if ( oTR.fwkOriginalClass != null )
	{
		oTR.className = oTR.fwkOriginalClass ; // Restore original class
	}
	oTR.fwkSelected = false ;
}
//------------------------------------------------------------------------------
function fwkListRowSelect( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowSelect : no ROW argument ! ");
		return ;
	}

	var oTBody = oTR.parentNode;
	if ( oTBody == null )
	{
		fwkError ( "fwkListRowSelect : cannot get parent TBody! ");
		return ;
	}
	
	var oSelectedRow = oTBody.fwkSelectedRow ;
	if ( oSelectedRow != null )
	{
		if ( oSelectedRow.rowIndex != oTR.rowIndex )
		{
			//--- Unselect the current row
			fwkListRowUnSelect( oSelectedRow );
		}
		else
		{
			//--- This row is already selected => noting to do
			return ; 
		}
	}

	//--- Select the given row
	oTR.fwkSelected = true ;	
	oTBody.fwkSelectedRow = oTR ; // Keep the new selected row	
	
	//--- Keep the original "BgColor" or "Class"
	if ( oTR.fwkOriginalColor == null ) 
	{
		oTR.fwkOriginalColor = oTR.style.backgroundColor ; // Keep original color
	}
	if ( oTR.fwkOriginalClass == null ) 
	{
		oTR.fwkOriginalClass = oTR.className ; // Keep original class
	}
	//--- Set the new "BgColor" or "Class"
	if ( FWK_LIST_ROW_SELECT_COLOR != null )
	{
		oTR.style.backgroundColor = FWK_LIST_ROW_SELECT_COLOR ; // Set new color
	}
	if ( FWK_LIST_ROW_SELECT_CLASS != null )
	{
		oTR.className = FWK_LIST_ROW_SELECT_CLASS ;	// Set new class
	}
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkListRowMouseOver( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowMouseOver : no ROW argument ! ");
		return ;
	}

	if ( ! oTR.fwkSelected )
	{
			if ( oTR.fwkOriginalColor == null ) 
			{
				oTR.fwkOriginalColor = oTR.style.backgroundColor ; // Keep original color
			}
			if ( oTR.fwkOriginalClass == null ) 
			{
				oTR.fwkOriginalClass = oTR.className ; // Keep original class
			}
			
		//--- Set the "BgColor" 
		if ( FWK_LIST_ROW_MOUSE_OVER_COLOR != null )
		{
			oTR.style.backgroundColor = FWK_LIST_ROW_MOUSE_OVER_COLOR ;	
		}
		//--- Set the "Class" 
		if ( FWK_LIST_ROW_MOUSE_OVER_CLASS != null )
		{
			oTR.className = FWK_LIST_ROW_MOUSE_OVER_CLASS ;	
		}
	}
}
//------------------------------------------------------------------------------
function fwkListRowMouseOut( oTR )
{
	if ( oTR == null )
	{
		fwkError ( "fwkListRowMouseOut : no ROW argument ! " );
		return ;
	}
	//--- If line NOT SELECTED
	if ( ! oTR.fwkSelected )
	{
		if ( oTR.fwkOriginalColor != null )
		{
			oTR.style.backgroundColor = oTR.fwkOriginalColor ; // Restore original color
		}
		if ( oTR.fwkOriginalClass != null )
		{
			oTR.className = oTR.fwkOriginalClass ; // Restore original class
		}
	}
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function fwkAdjustHeadWidth(sIdHead, sIdBody)
{
	var oHead = document.getElementById(sIdHead);
	if ( oHead == null )
	{
		fwkError("fwkAdjustHeadWidth : Cannot found LIST HEAD with id = " + sIdHead ) ;		
		return;
	}
	var oBody = document.getElementById(sIdBody);
	if ( oBody == null )
	{
		fwkError("fwkAdjustHeadWidth : Cannot found LIST BODY with id = " + sIdHead ) ;		
		return;
	}
	//--- Adjust the head WIDTH
	oHead.style.width = oBody.clientWidth;
}
//------------------------------------------------------------------------------
function fwkScrollHead(sIdHead, oBody)
{
	var oHead = document.getElementById(sIdHead);
	if ( oHead == null )
	{
		fwkError("fwkScrollHead : Cannot found LIST HEAD with id = " + sIdHead ) ;		
		return;
	}
	oHead.scrollLeft = oBody.scrollLeft;
}
//------------------------------------------------------------------------------
