//---------------------------------------------------------------------------------
// TabSet.js ( author : Laurent Gurin )
// TabSet object : 
//  - a TabSet is composed of 1 to N tabs
//  - each tab is associated with a TabPannel
//---------------------------------------------------------------------------------
function TabSet(sClassNormal, sClassSelected )
{
	//==============================================================================
	// INSTANCE ATTRIBUTES
	//==============================================================================
	var _currentTab      = null ; // Current selected tab object ( TD tag )
	var _currentTabIndex = -1 ;   // Current selected tab index ( 0 to N )
	var _currentPanel    = null ; // Current visible panel ( DIV tag )
		
	var _tabClassNormal   = sClassNormal ;   // CSS class for a normal tab (not selected)
	var _tabClassSelected = sClassSelected ; // CSS class for a selected tab

	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================		
	this.getCurrentTabIndex = function()
	{
		return _currentTabIndex ;
	}

	this.showPanel = function  ( oPanel )
	{
		//--- Cacher la page en cours 
		if ( _currentPanel != null )
		{
			_currentPanel.style.visibility = 'hidden' ;
		}
		//--- Changer de page en cours 
		_currentPanel = oPanel ;
		//--- Afficher la page en cours 
		if ( _currentPanel != null )
		{
			_currentPanel.style.visibility = 'visible' ;
		}
	}

	this.showTab = function  ( oTab )
	{
		if ( oTab != null )
		{
			//--- Neutralise l'onglet en cours 
			if ( _currentTab != null )
			{
				_currentTab.className = _tabClassNormal ;
			}
			//--- Active l'onglet en cours 
			oTab.className = _tabClassSelected ;
			//--- Set the new current tab  
			_currentTab = oTab ;
			_currentTabIndex = oTab.tabIndex ;
		}			
	}
}
