//---------------------------------------------------------------------------------
// TabSet_func.js ( author : Laurent Gurin )
//---------------------------------------------------------------------------------

function fwkInitTab ( sTabId, iTabIndex, sPanelId, oTabSet )
{
	var oTab = document.getElementById(sTabId);
	if ( oTab == null ) 
	{
		alert ( "fwkLinkTabToPanel : tab '" + sTabId + "' not found ! " );
		return ;
	}
	//--- Set the current tabset object 
	oTab.tabSet = oTabSet ;
	//--- Set the index
	oTab.tabIndex = iTabIndex ;
	//--- Link Tab object with the given panel 
	oTab.linkedPanelId = sPanelId ;
	//alert ( sTabId + " linked to " + sPanelId ) ; 
}
	
function fwkSelectTab( tab )
{
	if ( tab == null ) 
	{
		alert( "fwkSelectTab() : tab is null !" );
		return false ;
	}
	if ( typeof tab == "string" )
	{
		return fwkSelectTabById( tab );
	}
	else
	{
		return fwkSelectTabByRef( tab );
	}
}

function fwkSelectTabById( sTabId )
{
	if ( sTabId == null ) 
	{
		alert( "fwkSelectTabById() : tab id is null !" );
		return false ;
	}
	else
	{
		var oTab = document.getElementById(sTabId);
		if ( oTab == null ) 
		{
			alert ( "ERROR : Tab  "+sTabId+" doesn't exist ( check the ID ) ! " );
			return false ;
		}
		else
		{
			return fwkSelectTabByRef(oTab);
		}	
	}
}
	
function fwkSelectTabByRef( oTab )
{
	if ( oTab == null ) 
	{
		alert ( "ERROR : Tab argument is null ! " );
		return false ;
	}
	else
	{
		if ( oTab.tabSet )
		{
			//--- Check this tab is not already selected
			if ( "tabIndex" in oTab )
			{
				if ( oTab.tabIndex == oTab.tabSet.getCurrentTabIndex() )
				{
					//--- Already selected
					return false ;
				}
			}
			else
			{
				alert ( "ERROR : Tab is not initialized (no tabIndex attribute) ! " );
				return false;
			}			
			//--- Select the new tab 
			oTab.tabSet.showTab ( oTab ) ;
			//--- If the tab is linked with a panel
			if ( oTab.linkedPanelId )
			{
				//--- Get the panel object
				if ( ! oTab.linkedPanel )
				{
					//--- Not yet initialized => search by ID
					oTab.linkedPanel = document.getElementById(oTab.linkedPanelId);
				}					
				if ( oTab.linkedPanel )
				{
					//--- Show the linked panel 
					oTab.tabSet.showPanel ( oTab.linkedPanel ) ;
				}
				else
				{
					//--- Still null => invalid ID
					alert ( "fwkSelectTabByRef : pannel '" + oTab.linkedPanelId + "' not found ! " );
					return false;							
				}	
			}			
		}
		else
		{
			alert ( "ERROR : Tab is not initialized (no tabset attribute) ! " );
			return false;
		}			
	}
	return true ;
}
