/* GLOBAL VARIABLES */
var TELOSYS_TREE_SELECTED = null;
var TELOSYS_TREE_SELECTED_MOVED = false;
/* END GLOBAL VARIABLES */

function fwkGetDragAndDropDiv() {
	var sID = "fwkTreeDragAndDrop";
	var eDiv = window[sID] ;
	if ( eDiv == null )
	{
		alert( "Not found => creation" ) ;
		eDiv = document.createElement("DIV");
		eDiv.style.position = "absolute";
		eDiv.style.backgroundColor = "red";
		eDiv.style.left = 0 ;
		eDiv.style.top  = 0 ;
		window[sID] = eDiv ;
	}
	else
	{
		alert( "Exist (no creation)" ) ;
	}
	return eDiv ;
}

// Open or close one node and fire click
function fwkTreeOpenCloseNode(target) {
	if (target.nodeName=="LI") {
		if (target.className=="closed") {
			target.className="opened";
			var uls = target.getElementsByTagName('ul');
			if (uls!=null && uls.length>0) {
				uls[0].style.display = "block";
			}
		} else if (target.className=="opened") {
			target.className="closed";
			var uls = target.getElementsByTagName('ul');
			if (uls!=null || uls.length>0) {
				uls[0].style.display = "none";
			}
		} 
		var act = target.getAttribute("action");
		if (act!=null)
			eval(act);
	}
}

// Move one node in the tree
function fwkTreeMove(liSrc, liTarget) {
	if (liSrc!=null && liTarget!=null && liSrc!=liTarget) {
		var uls = liTarget.getElementsByTagName('ul');
		if (uls==null || uls.length==0) {
			var newUlTarget = document.createElement('ul');
			newUlTarget.appendChild(liSrc);
			liTarget.appendChild(newUlTarget);
			liTarget.className="opened"
		} else {
			uls[0].appendChild(liSrc);
		}
	}
}

// MouseDown event on the tree
function fwkTreeMouseDown(evt) {
	if (!evt) 
		var evt = window.event;
	var target   = evt.target || evt.srcElement;
	if (target!=null && target.nodeName=="LI") {
		TELOSYS_TREE_SELECTED = target;
	}
}

// MouseMove event on the tree
function fwkTreeMouseMove(evt) {
	if (!evt) 
		var evt = window.event;
	if (TELOSYS_TREE_SELECTED != null) {
		//var drag = document.getElementById("fwkTreeDragAndDrop");
		var drag = fwkGetDragAndDropDiv();
		if (!TELOSYS_TREE_SELECTED_MOVED) {
			// First move after selection
			drag.appendChild(TELOSYS_TREE_SELECTED.cloneNode(true));
			TELOSYS_TREE_SELECTED_MOVED = true;
		}
		drag.style.left = evt.clientX+5;
		drag.style.top = evt.clientY+5;
		drag.style.display = "block";
	}
}

// MouseUp event on the tree
function fwkTreeMouseUp(evt) {
	if (!evt) 
		var evt = window.event;
	var target = evt.target || evt.srcElement;
	if (target!=null && TELOSYS_TREE_SELECTED!=null) {
		if (TELOSYS_TREE_SELECTED_MOVED) {
			// DROP
			//var drag = document.getElementById("fwkTreeDragAndDrop");
			var drag = fwkGetDragAndDropDiv();
			drag.removeChild(drag.lastChild);
			drag.style.display = "none";
			if (target.nodeName=="LI" && target!=TELOSYS_TREE_SELECTED) {
				if (target.className=="closed" || target.className=="opened") {
					fwkTreeMove(TELOSYS_TREE_SELECTED, target);
				} else if (target.className=="leaf") {
					target.parentNode.insertBefore(TELOSYS_TREE_SELECTED, target);
				}
			}
		} else {
			// CLICK
			fwkTreeOpenCloseNode(target);
		}
		TELOSYS_TREE_SELECTED = null;
		TELOSYS_TREE_SELECTED_MOVED = false;
	}
}

// Disable text selection
/*
function fwkTreeDisableSelection(target){
	if (typeof target.onselectstart!="undefined") //IE route
		target.onselectstart=function(){return false}
	else if (typeof target.style.MozUserSelect!="undefined") //Firefox route
		target.style.MozUserSelect="none"
	else //All other route (ie: Opera)
		target.onmousedown=function(){return false}
	target.style.cursor = "default"
}
*/

// Tree initialisation = fire events, disable text selection and init node style 
function fwkTreeInitTree(id){
	var tree = document.getElementById(id);
	// Event fired
	tree.onmousemove 	 = fwkTreeMouseMove;
	tree.onmousedown	 = fwkTreeMouseDown;
	document.onmouseup   = fwkTreeMouseUp;
	// Disable text selection
	/*
	fwkTreeDisableSelection(tree);
	*/
	// Init style class
	/*
	var lis = tree.getElementsByTagName("li");
	if (lis!=null && lis.length>0) {
		var li;
		for(var i=0; i<lis.length; i++){
			li = lis[i];
			fwkTreeUpdateStyle(li);
		}
	}
	*/
}

// Update one node style
/*
function fwkTreeUpdateStyle(li) {
	var uls = li.getElementsByTagName("ul");
	if (uls==null || uls.length==0) {
		li.className="leaf";
	} else {
		li.className="opened";
	}
}
*/