//------------------------------------------------------------------------------
// XmlTags.js
//------------------------------------------------------------------------------
// Needs : 
// - Tools : xmlString()
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// "XmlTags" object
//------------------------------------------------------------------------------
// Extensible collection indexed by "tag name" (as "Java Hashtable")
// For each tag name, hold a string with the attributes
// Example : 
// ["book"]   -> " id='3' price='12' "
// ["author"] -> " name='Zola' "
//------------------------------------------------------------------------------
function XmlTags()
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _oAttributes = new Object();  // The attributes "HashTable" (void)
	var _oChildTags = new Object();  // The child tags "HashTable" (void)
	
	var _sEOL    = TelosysConst.getRequestEndOfLine() ;
	
	//==============================================================================
	// PUBLIC METHODS 
	//==============================================================================

	this.addField = function(sTag, sAttr, sValue) // Add the field value as an attribute for this tag
	{
		var sToAdd = " " + sAttr + "=\"" + Tools.xmlString(sValue) + "\"" ;
		var sCurrent = _oAttributes[sTag] ;
		if ( sCurrent == null )
		{
			_oAttributes[sTag] = sToAdd ;
		}
		else
		{
			_oAttributes[sTag] = sCurrent + sToAdd ;
		}
	}
	
	//------------------------------------------------------------------------------
	this.addChildTag = function(sTag, sChildTagName, sChildTagContent) // Add child tag for this tag
	{
		//alert ( "addChildTag("+ sTag+"," + sChildTagName+"," + sChildTagContent +")" );
		
		var sToAdd = "<"+ sChildTagName +"><![CDATA[" + sChildTagContent + "]]></"+sChildTagName+">" ;
		
		var sCurrent = _oChildTags[sTag] ;
		if ( sCurrent == null )
		{
			_oChildTags[sTag] = sToAdd ;
		}
		else
		{
			_oChildTags[sTag] = sCurrent + _sEOL + sToAdd ;
		}
		// be sure the PK exists
		if ( _oAttributes[sTag] == null ) _oAttributes[sTag] = " " ;
	}
	
	//------------------------------------------------------------------------------
	
	this.getXmlTags = function() // Get all the tags (one line per XML tag)
	{
		var sXml = "" ;
		for ( tag in _oAttributes )
		{
			//--- <tag a="x" b="x" 
			sXml += "<" + tag + _oAttributes[tag] ;
			sChilds = _oChildTags[tag] ;
			if ( sChilds != null )
			{
				//--- "> <child1>xxx</child1> </tag>"
				sXml += ">" + sChilds + "</" + tag + ">" + _sEOL ;
			}
			else
			{			
				sXml += "/>" + _sEOL ;
			}
		}
		return sXml ;
	}
}
