//---------------------------------------------------------------------------
function fwkAfterMenuItemClick( evt ) // Stop the event NOW !
{
//log.error("fwkAfterMenuItemClick(...) ========== ");
	fwkCancelEvent( evt );
	//fwkMenuBarReset( document.getElementById(window.fwkCurrentMenuBarId) );
	fwkResetMenuBar();
}
//---------------------------------------------------------------------------
function fwkSetMenuYX(menu, origin, where)
{
	if ( menu == null ) 
	{ 
		fwkError("fwkSetMenuYX : menu parameter is null"); 
		return; 
	}
	if ( menu.x != null ) return ; // allready set 
	if ( origin == null ) 
	{ 
		fwkError("fwkSetMenuYX : origin parameter is null"); 
		return; 
	}
	
	var posX = origin.offsetLeft;
	var posY = origin.offsetTop;
	var obj = origin ;
	while ( obj.offsetParent ) 
	{
		obj = obj.offsetParent ;
		posX += obj.offsetLeft;
		posY += obj.offsetTop;
	}
	
	if ( where == "R" ) // Right
	{
		posX += origin.clientWidth ;
	}
	else if ( where == "B" ) // Below
	{
		posY += origin.clientHeight + 2;
	}
	else // Unknown position : + 20 px 
	{
		posX += 20 ;
		posY += 20 ;
	}
	menu.x = posX ;
	menu.y = posY ;
}
//---------------------------------------------------------------------------
function fwkShowMenu(menu) // menu is a DIV
{
//log.debug("fwkShowMenu(...) : " + ( menu != null ? ( menu.nodeName + " #" + menu.id ) : 'null' ) );
	if ( menu == null ) return ;
	if ( menu.bInit == null ) 
	{
//log.error("fwkShowMenu(...) : INIT "  );
		var frames = menu.getElementsByTagName("IFRAME");
		if ( frames.length > 0 )
		{
//log.debug("fwkShowMenu(...) : frame found "  );
			var f = frames[0];
			f.style.width  = menu.clientWidth + "px" ;
			f.style.height = menu.clientHeight + "px" ;
		}
		menu.bInit = true ;
	}
	
	menu.style.left = menu.x ;
	menu.style.top  = menu.y ;
	menu.style.visibility = "visible" ;
}
//---------------------------------------------------------------------------
function fwkHideMenu(menu) // menu is a DIV ( NB: recursive function => use "var" for each local variable ! )
{
//log.error("fwkHideMenu(...) : " + ( menu != null ? ( menu.nodeName + " #" + menu.id ) : 'null' ) );
	if ( menu == null ) return ;
	menu.style.visibility = "hidden" ;
	var rows = menu.getElementsByTagName("TR");
	for( var i = 0 ; i < rows.length; i++ )
	{
//log.debug("fwkHideMenu(...) : " + ( menu != null ? menu.id : 'null' ) + " ROW " + i + "/" + rows.length );
		var tr = rows[i] ;
		if ( tr.className != "off" )
		{
			tr.className = "off";
			if ( tr.submenu != null )
			{
				fwkHideMenu(tr.submenu);
			}
		}
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkSelectMenuItem() // TR event
{
//log.debug("fwkSelectMenuItem("+this.nodeName+":"+this.id+")" );
	var parentMenu = this.parentNode ; // TBody 
	if ( parentMenu != null )
	{
		var rows = parentMenu.getElementsByTagName("TR");
		for( var i = 0 ; i < rows.length; i++ )
		{
			rows[i].className = "off";
			if ( rows[i].submenu != null )
			{
				fwkHideMenu(rows[i].submenu);
			}
		}
	}
	//--- Hilight ITEM
	this.className = "on";
	
	//--- Show Sub menu if any 
	var m = this.submenu ;	
	if ( m != null )
	{
		fwkSetMenuYX(m, this, "R"); // Right
		fwkShowMenu(m);
	}	
}
//---------------------------------------------------------------------------
function fwkUnselectMenuItem() // TR event
{
	if ( this.submenu == null ) // leaf only
	{
		this.className = "off";
	}
}
//---------------------------------------------------------------------------
function fwkSelectMenuBarItem(td, menuId, menuPosition)
{
//log.warning("fwkSelectMenuBarItem(td,"+menuId+")" );
	if ( td == null ) 
	{ 
		fwkError("fwkSelectMenuBarItem : td parameter is null"); 
		return; 
	}

	//--- Get MenuBar
	if ( td.menubar == null )
	{
		td.menubar = fwkGetParentDIV(td);
	}
	var menuBar = td.menubar ;	
	if ( menuBar != null )
	{
//log.warning("fwkSelectMenuBarItem(td,"+menuId+") : menuBar != null : " + menuBar.nodeName );
		if ( menuBar.activeItem != null )
		{
			menuBar.activeItem.className = "off"; 
		}
		menuBar.activeItem = td ;
		if ( menuBar.activeMenu != null )
		{
			fwkHideMenu(menuBar.activeMenu);
			menuBar.activeMenu = null ;
		}
	}
	else
	{
		fwkError("fwkSelectMenuBarItem : cannot get menubar ( parent DIV )"); 
		return ;
	}
	
	//--- ITEM "ON"
	td.className = "on";
	
	var m = ( menuId != null ? document.getElementById(menuId) : null );
	//td.submenu = m;
	if ( m != null )
	{
		var where = ( menuPosition != null ? menuPosition : "B" ); // Below by default
		fwkSetMenuYX(m, td, where); // Right
		
		//log.warning("fwkSelectMenuBarItem(tr,"+menuId+") : ShowMenu .." );
		fwkShowMenu(m);
		//log.warning("fwkSelectMenuBarItem(tr,"+menuId+") : Set active menu .." );
		menuBar.activeMenu = m ;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
function fwkResetMenuBar(pMenuBar) // menubar is a TABLE
{
//log.info("fwkResetMenuBar(menubar)" );
	var menubar = pMenuBar ;
	if ( menubar == null ) 
	{ 
		menubar = window.fwkCurrentMenuBar ;
		if ( menubar == null ) 
		{ 
			fwkError("fwkResetMenuBar : no menubar !"); 
			return; 
		}
	}
	if ( menubar.activeMenu != null )
	{
		//log.debug("fwkResetMenuBar(menubar) : menubar.activeMenu != null : id = " + menubar.activeMenu.id );
		fwkHideMenu( menubar.activeMenu );
	}
	else
	{
		//log.debug("fwkResetMenuBar(menubar) : menubar.activeMenu is null " );
	}

	var cells = menubar.getElementsByTagName("TD");
	for( var i = 0 ; i < cells.length; i++ )
	{
		if ( cells[i].className != "off" )
		{
			cells[i].className = "off";
		}
	}
}
//---------------------------------------------------------------------------
function fwkInitMenuItem( id, submenuId )
{
	var item = document.getElementById(id);
	if ( item != null )
	{
		//--- Set event handlers
		item.onmouseover = fwkSelectMenuItem ;
		item.onmouseout  = fwkUnselectMenuItem ;
		//--- Set submenu if any
		if ( submenuId != null )
		{
			item.submenu = document.getElementById(submenuId); ;
			if ( item.submenu == null )
			{
				fwkError("fwkInitMenuItem : cannot found submenu with id = '" + submenuId + "'");
			}
		}
	}
	else
	{
		fwkError("fwkInitMenuItem : cannot found id '" + id + "'");
	}
}
//---------------------------------------------------------------------------
function fwkInitMenuBar( id )
{
	var menubar = document.getElementById(id);
	if ( menubar != null )
	{
		window.fwkCurrentMenuBarId = id ;
		window.fwkCurrentMenuBar = menubar;
	}
	else
	{
		fwkError("fwkInitMenuBar : cannot found id '" + id + "'");
	}
}
//---------------------------------------------------------------------------
