//------------------------------------------------------------------------------
// Screen.js
//------------------------------------------------------------------------------
// Needs : 
// - fwkFields.js : fwkFilter(), fwkResetFieldErrorStatus(), fwkSetFieldShallowCheckingStandardColor()
//------------------------------------------------------------------------------
// Version : 3.0 ( 25/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// "Screen" Object 
//------------------------------------------------------------------------------
function Screen(argScreenName, argAjaxUrl, argScreenId )
{
	//alert ( "CONTRUCTOR : Screen()" );
	if ( argScreenName == null ) alert ( "ERROR: Screen() constructor : 1st argument is null ( Screen Name )" ) ;
	if ( argAjaxUrl  == null ) alert ( "ERROR: Screen() constructor : 2nd argument is null ( Ajax URL )" ) ;
	if ( argScreenId == null ) argScreenId = 0 ;

	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	//--- The name of the screen
	var _sScreenName       = argScreenName ;

	//--- The URL used to send the requests
	var _sUrlBase          = argAjaxUrl ;

	//--- The ScreenContext ID in the ScreenSession
	var _iScreenId         = argScreenId ;	 

//alert ("Screen constructor : Screen Id = " + _iScreenId );

	var _oInvalidField     = null ;

	//--- The ScreenFields Array ( Filled by "RegisterField()" )
	var _aScreenFields     = new Array() ; 

	//--- The ScreenViews Array ( Filled by "RegisterView()" )
	var _aScreenViews      = new Array() ;
	
	//--- The registered screen fields serialized in XML format
	var _sSerializedFields = "" ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	
	//------------------------------------------------------------------------------
	// Serialize all the registered fields (in XML format) 
	//------------------------------------------------------------------------------
	function _serializeFields ()
	{
		//alert("_serializeFields()");

		var oXmlTags = new XmlTags();
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : serializeFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					oField = oScreenField.oField ;
					if ( oField == null )
					{
						alert("ERROR : serializeFields() : Field ["+i+"] is null ! " );
					}
					else
					{
						sFieldValue = null ;
						if ( oField.getValue )
						{
							sFieldValue = oField.getValue() ;
						}
						else
						{
							sFieldValue = oField.value ;
						}
						oXmlTags.addField(oScreenField.sXmlTag, oScreenField.sXmlAttr, sFieldValue );
					}
				}
			}
		}
//		_sSerializedFields = oXmlTags.getXmlTags() ;
//		return _sSerializedFields ;
		return oXmlTags.getXmlTags() ;
	}
	//------------------------------------------------------------------------------
	// Populate all the registered fields from the response object
	//------------------------------------------------------------------------------
	//function _populateFields ( oScreen, response )
	function _populateFields ( response )
	{
		//alert("_populateFields(response) " );
		
		var oScreenField = null ;
		var oField = null ;
		var sFieldValue = null ;
		
		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			//oScreenField = oScreen.aScreenFields[i] ;
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : _populateFields() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to an XML attributue 
				if (  oScreenField.sXmlTag != null && oScreenField.sXmlAttr != null )
				{
					oField = oScreenField.oField ;
					if ( oField == null )
					{
						alert("ERROR : _populateFields() : Field ["+i+"] is null ! " );
					}
					else
					{
						sFieldValue = response.getXmlValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr ) ;
						if ( oField.setValue ) 
						{
							oField.setValue(sFieldValue) ;
						}
						else
						{
							oField.value = sFieldValue ;
						}
						//oField.value = response.getXmlValue ( oScreenField.sXmlTag, oScreenField.sXmlAttr ) ;
					}
				}
			}
		}
	}
	//------------------------------------------------------------------------------
	// Populate all the registered view from the response object
	//------------------------------------------------------------------------------
	function _populateViews ( response )
	{
		//alert("_populateFields(response) " );		
		var oScreenView = null ;
		var oContainer  = null ;
		
		//--- For each view registered in this screen 
		for ( var i = 0 ; i < _aScreenViews.length ; i++ )
		{
			oScreenView = _aScreenViews[i] ;
			if ( oScreenView == null )
			{
				alert("ERROR : _populateViews() : ScreenViews ["+i+"] is null ! " );
			}
			else
			{
				//--- If the field is mapped to a response view tag 
				if (  oScreenView.sXmlTag != null )
				{
					oContainer = oScreenView.oField ;
					if ( oContainer == null )
					{
						alert("ERROR : _populateViews() : Container ["+i+"] is null ! " );
					}
					else
					{
						sViewContent = response.getViewContent ( oScreenView.sXmlTag ) ;
						if ( sViewContent != null ) 
						{
							//--- Set the view in the container 
							oContainer.innerHTML = sViewContent  ;
							//--- If the container has an init script => call it
							var sScript = oContainer.initScript ;
							if ( sScript != null )
							{
								//alert("initScript = '" + sScript + "'" );
								eval ( sScript ) ;
							}
						}
					}
				}
			}
		}
	}
	
	//------------------------------------------------------------------------------
	this.getScreenName = function()
	{
		return _sScreenName ;
	}
	//------------------------------------------------------------------------------
	this.getScreenId = function()
	{
		return _iScreenId ;
	}
	//------------------------------------------------------------------------------
	this.getRequestURL = function() 
	{
		return _sUrlBase ;
	}
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// METHODE : ScreenToXml
	//------------------------------------------------------------------------------
	this.ScreenToXml = function()
	{
		//alert ( "ScreenToXml()" );
		var sRet = null ;
		//--- Partie standard de l'cran
    	//if ( this.aScreenFields.length > 0 ) 
    	if ( _aScreenFields.length > 0 ) 
    	{
    		//sRet = _serializeFields(this);
    		sRet = _serializeFields();
    		//alert(sRet);
    	}
		return sRet ;
		
		/**
		//--- Partie "dtail" de l'cran (si elle existe)
		if ( this.oDetail != null ) 
		{
			this.oDetail.ScreenToXml() ;
		}
		**/
	}

	//------------------------------------------------------------------------------
	// METHODE : XmlToScreen
	//------------------------------------------------------------------------------
	this.XmlToScreen = function(response)
	{
		//alert ( "XmlToScreen()" );
		if ( response.dataNotFound() )
		{
			//alert("Data not found.");
		}
		else
		{
			//--- Partie standard de l'cran
	    	if ( _aScreenFields.length > 0 ) 
	    	{
	    		_populateFields(response);
				/**
				//--- Partie "dtail" de l'cran (si elle existe)
				if ( this.oDetail != null ) 
				{
					this.oDetail.ScreenToXml() ;
				}
				**/
	    	}
	    	if ( _aScreenViews.length > 0 ) 
	    	{
	    		_populateViews(response);
	    	}
		}		
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.RegisterView = function(sFieldId, sScreenZone, sXmlTag )
	{
		if ( sFieldId == null ) 
		{
			alert("ERROR: RegisterView : no field id !");
			return null ;
		}
		var oField = null ;
		try {
			oField = document.getElementById(sFieldId);
			if ( oField )
			{
				var oScreenField = new ScreenField(sFieldId, oField, sScreenZone, sXmlTag, null);
	    		_aScreenViews.push( oScreenField );
			}
			else
			{
				alert("ERROR: RegisterView : Object with id " + sFieldId + " not found ! " ) ;
			}
		} catch ( e ) {
			alert ( "ERROR: Exception in RegisterView()! \n" + e.message ) ;
		}
    	return oField ;
	}
	
	//------------------------------------------------------------------------------
	this.RegisterField = function(sFieldId, sScreenZone, sXmlTag, sXmlAttr )
	{
		// alert("RegisterField(" + sFieldId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		if ( sFieldId == null ) 
		{
			alert("ERROR: RegisterField : no field id !");
			return null ;
		}
		var oField = null ;
		try {
			oField = document.getElementById(sFieldId);
			if ( oField )
			{
				var oScreenField = new ScreenField(sFieldId, oField, sScreenZone, sXmlTag, sXmlAttr);
	    		_aScreenFields.push( oScreenField );
	    		//--- Is there a picto for the field ?
				var oFieldPicto = document.getElementById(sFieldId+"_picto");
				if ( oFieldPicto )
				{
					oField.oPicto = oFieldPicto ;
					oField.setDisabled = fwkFieldSetDisabled ;
				}
			}
			else
			{
				alert("ERROR: RegisterField : Object with id " + sFieldId + " not found ! " ) ;
			}
		} catch ( e ) {
			alert ( "ERROR: Exception in RegisterField()! \n" + e.message ) ;
		}
    	return oField ;
	}
	//------------------------------------------------------------------------------
	this.RegisterFieldDate = function(sId, sScreenZone, sXmlTag, sXmlAttr, sFormat )
	{
		//alert("RegisterFieldDate(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.getValue  = fwkFieldDateGetValue ;
				obj.setValue  = fwkFieldDateSetValue ;
				obj.format    = sFormat ;
				obj.dateValue = new SimpleDate(null, sFormat);
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterFieldDate : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterHidden = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterComboBox = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterListBox = function(sId, sScreenZone, sXmlTag, sXmlAttr )
	{
		this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
	}
	//------------------------------------------------------------------------------
	this.RegisterCheckBox = function(sId, sScreenZone, sXmlTag, sXmlAttr, sValOn, sValOff )
	{
		//alert("RegisterCheckBox(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				obj.valueChecked   = sValOn ;
				obj.valueUnchecked = sValOff ;
				obj.getValue = fwkCheckboxGetValue ;
				obj.setValue = fwkCheckboxSetValue ;
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterCheckBox : \n" + ex.message ) ;
		}
	}
	//------------------------------------------------------------------------------
	this.RegisterRadioGroup = function(sId, sScreenZone, sXmlTag, sXmlAttr, aRadioIds )
	{
		//alert("RegisterRadioGroup(" + sId +"," + sScreenZone + "," + sXmlTag + "," + sXmlAttr + "," + aRadioIds + ")...");
		try {			
			var obj = this.RegisterField (sId, sScreenZone, sXmlTag, sXmlAttr ) ;
			if ( obj )
			{
				//--- Build the "Radio" objects array 
				var aRadios = new Array();
				var oRadio = null ;
				var iRadio = 0 ;
				for ( var i = 0 ; i < aRadioIds.length ; i++ )
				{
					oRadio = document.getElementById( aRadioIds[i] ) ;
					if ( oRadio != null )
					{
						aRadios[iRadio++] = oRadio ;
					}
					else
					{
						alert ( "ERROR: Radio object not found !  id = " + aRadioIds[i] );
					}
				}
				obj.aRadios = aRadios ;
				//--- Set new methods 
				obj.getValue = fwkRadioGroupGetValue ;
				obj.setValue = fwkRadioGroupSetValue ;			
				obj.setDisabled = fwkRadioGroupSetDisabled ;
			}
		}
		catch (ex) {
			alert ( "ERROR in RegisterRadioGroup : \n" + ex.message ) ;
		}
	}
			
	//------------------------------------------------------------------------------
	// Clear a specific field passed by reference (object)
	//------------------------------------------------------------------------------
	this.ClearField = function ( oField ) // RET : void 
	{
		//var sType = oField.getAttribute("type") ;
		var sType = oField.type ;
		switch ( sType )
		{
			case "text" :
			case "file" : 
			case "password" : 
			case "textarea" : 
				oField.value = "" ;
				/**
				// fwkResetFieldErrorStatus(oField); #TODO ????
				try {
					// Option par dfaut (si elle existe)
					if ( oField.fwkDefaultValue != null ) // Par valeur
					{
						oField.value = oField.fwkDefaultValue ;
					}
  				} catch ( ex ) { 
					oField.value = "" ;
  				} 
  				**/
				break ;
					
			case "select-one" : 
			case "select-multiple" :
				oField.selectedIndex = -1 ; // Aucune ligne slectionne (OK / IE & Firefox)
				/**
				try {
					// Option par dfaut (si elle existe)
					if ( oField.fwkDefaultValue != null )	   // Par valeur
					{
						oField.value = oField.fwkDefaultValue ;
					}
					else if ( oField.fwkDefaultIndex != null ) // Par index
					{
						oField.selectedIndex = oField.fwkDefaultIndex ;
					}
  				} catch ( ex ) { 
	  				oField.selectedIndex = -1 ; 
  				} 
  				**/
				break ;

			case "checkbox" : 
			case "radio" :
				oField.checked = false ;
				break ;
		}
		
		if ( sType == null )
		{
			// alert ( "Type is null" );
			// if type is null => it's a radio buttons container 
			var elements = oField.getElementsByTagName("input") ; 
			if ( elements != null )
			{
				for ( var i=0 ; i < elements.length ; i++ )
				{
					//alert ( "element["+i+"] : type = " + elements[i].type );
					if ( elements[i].type == "radio" )
					{
						elements[i].checked = false  ;					
					}
				}			
			}
			/**
			else
			{
					alert ( "no elements <input>" );
			}
			**/
		}
	}
	//------------------------------------------------------------------------------
	// Enable / Disable a field
	//------------------------------------------------------------------------------
	this.setFieldDisabled = function ( oField, bFlag ) // RET : void 
	{
		if ( oField.setDisabled ) 
		{
			//--- Specific disabled function for this field
			oField.setDisabled(bFlag) ;
		}
		else
		{
			oField.disabled = bFlag ;
			//fwkSetFieldButtonDisabled(sId, true);
		}
	}
	//------------------------------------------------------------------------------
	// Clear the entire screen or a specific zone 
	// sZone arg can be null 
	//------------------------------------------------------------------------------
	this.Clear = function ( sZone ) // RET : void 
	{
		//alert("Clear() : sZone = " + sZone );
		var oScreenField = null ;
		var oField = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : Clear() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				oField = oScreenField.oField ;
				if ( oField == null )
				{
					alert("ERROR : Clear() : Field ["+i+"] is null ! " );
				}
				else
				{
					if ( sZone == null )
					{
						//alert("Clear() : field " + i + " - field.type = " + oField.type );
						this.ClearField(oField);
					}
					else 
					{
						if ( oScreenField.sZone == sZone )
						{
							this.ClearField(oField);
						}
					}
				}			
			}
		}	
	}
	//------------------------------------------------------------------------------
	// Enable the entire screen or a specific zone 
	// sZone arg can be null 
	//------------------------------------------------------------------------------
	this.Enable = function ( sZone ) // RET : void 
	{
		//var bFlag = false ;
		this.setDisabled ( false, sZone ) // RET : void 		
	}
	this.Disable = function ( sZone ) // RET : void 
	{
		//var bFlag = true ;
		this.setDisabled ( true, sZone ) // RET : void 		
	}
	this.setDisabled = function ( bFlagDisabled, sZone ) // RET : void 
	{
		//alert("Clear() : sZone = " + sZone );
		var oScreenField = null ;
		var oField = null ;

		//--- For each field registered in this screen 
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			oScreenField = _aScreenFields[i] ;
			if ( oScreenField == null )
			{
				alert("ERROR : Clear() : ScreenField ["+i+"] is null ! " );
			}
			else
			{
				oField = oScreenField.oField ;
				if ( oField == null )
				{
					alert("ERROR : Clear() : Field ["+i+"] is null ! " );
				}
				else
				{
					if ( sZone == null )
					{
						//alert("Clear() : field " + i + " - field.type = " + oField.type );
						this.setFieldDisabled(oField, bFlagDisabled );
					}
					else 
					{
						if ( oScreenField.sZone == sZone )
						{
							this.setFieldDisabled(oField, bFlagDisabled );
						}
					}
				}			
			}
		}	
	}
		
	//------------------------------------------------------------------------------
	// METHODE : Desc
	//------------------------------------------------------------------------------
	this.Desc = function()
	{
		alert ( "SCREEN OBJECT : \n" +
				"\n . Screen-Name = " + _sScreenName + 
				"\n . Screen-Id (Popup Level) = " + _iScreenId +
				"\n . UrlBase = " + _sUrlBase + 
				"\n . " + _aScreenFields.length + " field(s) " );
	}

	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	// METHODE : Traitements standards pour l'vnement "window.onLoad" 
	//------------------------------------------------------------------------------
	this.OnLoad = function () // RET : void
	{
		this.New();
		this.printMessage();
	}


	//------------------------------------------------------------------------------
	this.Exit = function()
	{
		//--- On essaye de fermer l'cran
		try {
			this.close();
		}
		catch (e) {}

		//--- Si l'cran n'a pas t ferm on rinitialise l'cran
		this.New();
		this.printMessage();
	}
	//------------------------------------------------------------------------------
	this.close = function()
	{
		//--- Ecran popup
		if ( _iScreenId > 0 )
		{
			//--- On sort de l'cran
			window.close();
		}
		//--- Premier champ de l'cran
		else 
		{
			try
			{
				//--- On ouvre la page d'accueil
				document.location.href = PageAccueil;
			} catch (e) {}
		}
	}
	//------------------------------------------------------------------------------

	//==============================================================================
	//  GESTION DES CHAMPS ( KeyFields et DataFields ) : Disable / Clear / Check
	//==============================================================================

	//------------------------------------------------------------------------------
	// Fonction de vrification d'UN champ
	//------------------------------------------------------------------------------
	this.CheckField = function ( oField ) // RET : boolean : true = OK / false = NOK 
	{
		//--- Champ NOT NULL -------------------------------------------------------
		if ( oField.getAttribute("fwkNotNull") )
		{
			// alert ( "Check field ( id = " +oField.id+ " ) : attribute fwkNotNull found." ) ;
			switch ( oField.getAttribute("type") )
			{
				case "text" :       // Tag "input type=text "
				case "file" :
				case "password" :
				case "textarea" :   // Tag "textarea "
				case "select-one" : // Tag "select"
				// case "checkbox" :  // Not Null n'a pas de sens pour une "Check Box"
				// case "radio" :     // Not Null n'a pas de sens pour un  "Radio Button"
					if ( oField.value == null || oField.value == "" ) 
					{
						_oInvalidField = oField ;
						var memoColor = oField.style.backgroundColor ;
						oField.style.backgroundColor = 'orange' ;
						alert ( "The field "+oField.name+ " ( id = " +oField.id+ " ) is required " );
						oField.style.backgroundColor = memoColor ;
						return false ;
					}
					break ;
			}
		}
		//--- Champ dans l'tat VALEUR INCORRECTE ---------------------------------- 
		// if ( oField.style.backgroundColor == 'red' )  // Modif Ver 2.6
		if ( fwkIsFieldOnError(oField) || fwkIsFieldOnShallowCheckingError(oField) ) // Ver 2.6
		{
			_oInvalidField = oField ;
			//alert ( "There is an invalid field (at least) !" );
			return false ;
		}
		return true ;
	}


	//------------------------------------------------------------------------------
	// Fonction de vrification de l'ensemble des champs
	// ( La sortie du champ ventuellement en cours de saisie est force 
	// au niveau de la gestion des touches de fonctions )
	//------------------------------------------------------------------------------
	this.CheckAllFields = function () // RET : boolean : true = OK / false = NOK
	{
		//for ( var i = 0 ; i < this.aScreenFields.length ; i++ )
		for ( var i = 0 ; i < _aScreenFields.length ; i++ )
		{
			//if ( this.CheckField(this.aScreenFields[i]) == false ) return false ;
			if ( this.CheckField(_aScreenFields[i]) == false ) return false ;
		}

		//--- A ce stade tous les champs sont OK 
		_oInvalidField = null ;
		return true ; 
	}

	//==============================================================================
	//  ACTIONS UTILISATEUR 
	//==============================================================================

	//------------------------------------------------------------------------------
	// Triggers : A SURCHARGER SI NECESSAIRE
	//------------------------------------------------------------------------------
	this.beforeSelect = function () { return true ; }
	this.afterSelect  = function () { return ; }
	this.beforeUpdate = function () { return true ; }
	this.afterUpdate  = function () { return ; }
	this.beforeInsert = function () { return true ; }
	this.afterInsert  = function () { return ; }
	this.beforeDelete = function () { return true ; }
	this.afterDelete  = function () { return ; }

}




