package org.objectweb.telosys.admin;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 
 */

public class ConsoleJavaInfo extends Console
{

    //-----------------------------------------------------------------------------
    protected static void printSystemProperty( PrintWriter out, String sProp, String sTxt )
    {
        String s = ( sTxt != null ) ? " ( " + sTxt + " ) " : "" ;
        printTR(out, sProp + s,  System.getProperty(sProp, "(unknown)") );
    }
    //-----------------------------------------------------------------------------
    protected static void print( HttpServletRequest request, HttpServletResponse response ) throws IOException
    {
        PrintWriter out = response.getWriter();
        response.setContentType(CONTENT_TYPE_TEXT_HTML);
        
        out.println("<b><u> Main system properties : </u></b>");
        openTable( out );
        printSystemProperty( out, "java.version", null );
        printSystemProperty( out, "java.vendor", null );
        printSystemProperty( out, "java.home", null );
        printSystemProperty( out, "java.compiler", "JIT compiler to use" );
        printSystemProperty( out, "java.class.path", "CLASSPATH env. variable" ); 
        printSystemProperty( out, "java.class.version", "Java API version" );
        
        printSystemProperty( out, "os.name", null );
        printSystemProperty( out, "os.version", null );
        printSystemProperty( out, "os.arch", null );
        
        printSystemProperty( out, "user.name", null );
        printSystemProperty( out, "user.home", "home directory" );
        printSystemProperty( out, "user.dir", "working directory" );
        printSystemProperty( out, "user.language", "two-letter language code" );
        printSystemProperty( out, "user.region", "two-letter country code" );
        printSystemProperty( out, "user.timezone", null );

        printSystemProperty( out, "path.separator", null );
        printSystemProperty( out, "file.separator", null );
        printSystemProperty( out, "line.separator", null );
        
        closeTable( out );
        
        out.println("<hr>");
        
        out.println("<b><u> Runtime ( JVM environment ) : </u></b>");
        Runtime rt = Runtime.getRuntime();
        
        openTable( out );
        printTR(out, "Free memory ( amount of free memory in the JVM )",  rt.freeMemory()+ " bytes" );
        printTR(out, "Total memory ( total amount of memory in the JVM ) ",  rt.totalMemory()+ " bytes"  );
        printTR(out, "Max memory ( maximum amount of memory that the JVM will attempt to use )",  rt.maxMemory()+ " bytes"  );
        printTR(out, "Number of processors available to the JVM",  rt.availableProcessors()+ " processor(s)"  );
        closeTable( out );
        
        
        printBack(out, request);
    }
}