package org.objectweb.telosys.admin;

import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 *  
 */

public class ConsoleSessions extends Console
{

    //-----------------------------------------------------------------------------
    private static void printNoSession(PrintWriter out)
    {
        out.println ( " No session currently active." );
    }
    //-----------------------------------------------------------------------------
    private static void printTable(PrintWriter out, Hashtable list )
    {
        out.println ( list.size() + " session(s) currently active : <br><br>" );
        HttpSession session = null ;
        openTable(out);
        out.print("<tr>");
        out.print("<td> ID </td>");
        out.print("<td> Creation Time </td>");
        out.print("<td> Last Accessed Time </td>");
        out.println("</tr>");
        for ( Enumeration e = list.elements() ; e.hasMoreElements() ; )
        {
            out.print("<tr>");
            session = (HttpSession) e.nextElement();
            out.print("<td>" + session.getId() + "</td>");
            out.print("<td>" + session.getCreationTime() + "</td>");
            out.print("<td>" + session.getLastAccessedTime() + "</td>");
            out.println("</tr>");
            //session.getMaxInactiveInterval()
        }
        closeTable(out);
    }
    //-----------------------------------------------------------------------------
    protected static void print(PrintWriter out, HttpServletRequest request)
    {
        out.println("<b><u> Http sessions currently active : </u></b>");
        out.println("<br><br>");

        Hashtable list = SessionListener.getSessions();
        if ( list != null )
        {
            if ( list.size() > 0 )
            {
                printTable(out, list );
            }
            else
            {
                printNoSession(out);
            }
        }
        else
        {
            printNoSession(out);
        }

        printBack(out, request);
    }
}