package org.objectweb.telosys.admin;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 
 */

public class ConsoleWebAppConf extends Console
{

    //-----------------------------------------------------------------------------
    protected static void print( HttpServletRequest request, HttpServletResponse response, ConsoleServlet servlet ) throws IOException
    {
        PrintWriter out = response.getWriter();
        response.setContentType(CONTENT_TYPE_TEXT_HTML);
        
        ServletContext servletContext = servlet.getServletContext();
        if (servletContext != null)
        {
            printServletContext(out, servletContext);
            printServletContextParameters(out, servletContext);
        }
        else
        {
            out.println("<b><u> ERROR : Cannot get Servlet Context ! </u></b>");
        }
        printBack(out, request);
    }
    
    //-----------------------------------------------------------------------------
    private static void printServletContext( PrintWriter out, ServletContext servletContext  )
    {
        out.println("<b><u> Servlet context : </u></b>");
        
        openTable( out );
        
        printTR(out, "Server Info",  servletContext.getServerInfo() );
        printTR(out, "Version",      servletContext.getMajorVersion() + "." + servletContext.getMinorVersion() );
        printTR(out, "Context Name", servletContext.getServletContextName() );
        printTR(out, "Real Path",    servletContext.getRealPath("/") );
        
        closeTable( out );
    }
    //-----------------------------------------------------------------------------
    private static void printServletContextParameters( PrintWriter out, ServletContext servletContext  )
    {
        out.println("<b><u> Servlet context init parameters ( from 'web.xml' ) : </u></b>");
        Enumeration e = servletContext.getInitParameterNames();
        if ( e != null )
        {
            openTable( out );
            while ( e.hasMoreElements() )
            {
                Object o = e.nextElement();
                if ( o != null )
                {
                    String sName = o.toString();
                    String sValue = servletContext.getInitParameter(sName);
                    printTR(out, sName, sValue);
                }
            }
            closeTable( out );
        }
        else
        {
            out.println("<i> No init parameters</i>");
        }
    }
}