package org.objectweb.telosys.admin;

import java.util.Hashtable;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

import org.objectweb.telosys.common.TelosysClassLogger;

/**
 * 
 * @author Laurent GUERIN
 *
 */
public class SessionListener implements HttpSessionListener {

    private static final TelosysClassLogger log = new TelosysClassLogger(SessionListener.class);

    private static Hashtable htSessions = new Hashtable();
    
    static {
        log.info("Session listener class loaded.");
    } 
    
    /**
     * 
     */
    public SessionListener()
    {
        super();
        log.info("Session listener instance created.");
    }
    
    
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpSessionListener#sessionCreated(javax.servlet.http.HttpSessionEvent)
	 */
	public void sessionCreated(HttpSessionEvent sessionEvent) 
	{
        log.trace("session created");
		HttpSession session = sessionEvent.getSession();
		if ( session != null )
		{
			htSessions.put(session.getId(), session);
		}
		else
		{
		    log.error("session created : cannot get session from event !");
		}
	}

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpSessionListener#sessionDestroyed(javax.servlet.http.HttpSessionEvent)
	 */
	public void sessionDestroyed(HttpSessionEvent sessionEvent) {
		
        log.trace("session destroyed");
		HttpSession session = sessionEvent.getSession();
		if ( session != null )
		{
			htSessions.remove(session.getId());
		}
		else
		{
		    log.error("session destroyed : cannot get session from event !");
		}
	}
	
	/**
	 * Returns the list of the current active sessions 
	 * @return
	 */
	public final static Hashtable getSessions()
	{
	    return htSessions ;
	}
	
}
