package org.objectweb.telosys.auth;

import java.io.Serializable;

/**
 * Application user interface <br>
 * Describe the methods needed for specific application user class
 * 
 * @author Laurent GUERIN
 *  
 */
public interface IAppUser extends Serializable
{
    /**
     * @return the first page (welcome page) for this user
     */
    public String getFirstPage(); 

    /**
     * @return the user's language ( "en", "fr", ... )
     */
    public String getLanguage(); 
    
    /**
     * @return the user's role for the current application
     */
    public String getRole(); 
    
    

}