package org.objectweb.telosys.auth;

import java.util.Properties;

import org.objectweb.telosys.common.Telosys;

/**
 * Authentication layer manager ( initialization and configuration ) 
 * 
 * @author Laurent GUERIN
 *  
 */
public final class TelosysAUTH
{
    //--- Realm Name for "basic HTTP" authentication
    private static String $sRealmName = "";

    //--- Default First Page
    private static String $sFirstPage = null;

    //-----------------------------------------------------------------------------
    private static boolean initWithProperties(Properties prop)
    {
        boolean bRet = true;

        //--- Realm Name for "basic HTTP" authentication
        $sRealmName = prop.getProperty("RealmName");
//        if ($sRealmName == null)
//        {
//            Telosys.info("TelosysAUTH - init : Realm name not found ");
//            bRet = false;
//        }
        Telosys.info("TelosysAUTH - init : Realm name = " + $sRealmName ); // v 1.0.0

        //--- Default First Page
        $sFirstPage = prop.getProperty("FirstPage");
//        if ($sFirstPage == null)
//        {
//            Telosys.error("TelosysAUTH - init : First page not found ");
//            bRet = false;
//        }
        Telosys.info("TelosysAUTH - init : First page = " + $sFirstPage ); // v 1.0.0

        return bRet;
    }

    //-----------------------------------------------------------------------------
    // PUBLIC METHODS
    //-----------------------------------------------------------------------------
    public static boolean init()
    {
        Telosys.info("TelosysAUTH : INIT using Telosys properties ...");
        //--- Get the Telosys properties ...
        Properties prop = Telosys.getProperties();
        if (prop != null)
        {
            initWithProperties(prop);
            return true ;
        }
        else
        {
            Telosys.error("TelosysAUTH.init() : cannot get Telosys properties !");
            return false;
        }
    }

    //-----------------------------------------------------------------------------

    //-----------------------------------------------------------------------------
    // PUBLIC GETTERS
    //-----------------------------------------------------------------------------
    /**
     * Returns the default first page (where to go after authentication)<br>
     * It comes from the Telosys properties and can be null.
     * @return
     */
    public static String getFirstPage()
    {
        return $sFirstPage;
    }

    /**
     * Returns the "realm name" useful for basic http authentication<br>
     * It comes from the Telosys properties and can be null.
     * @return 
     */
    public static String getRealmName()
    {
        return $sRealmName;
    }
    //-----------------------------------------------------------------------------
}