package org.objectweb.telosys.common.data;

import java.io.Serializable;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * 
 * @author Laurent GUERIN
 * Generic TreeNodeList : list of TreeNodes
 *  
 */
public class TreeNodeList implements Serializable
{
    private LinkedList _list = new LinkedList();
    
    //----------------------------------------------------------------------------------------
    // Contructor(s)
    //----------------------------------------------------------------------------------------    
    public TreeNodeList ()
    {
        super();
    }
    
    //----------------------------------------------------------------------------------------
    // Child nodes management
    //----------------------------------------------------------------------------------------    
    /**
     * Appends a child node
     * @param node
     * @return
     */
    /* package */ boolean add( TreeNode node ) 
    {
        return _list.add(node);
    }

    //-----------------------------------------------------------------------------
    /**
     * Returns an iterator over the elements in this list in proper sequence
     * 
     * @return the iterator
     */
    public Iterator iterator()
    {
        return _list.iterator();
    }

    //-----------------------------------------------------------------------------
    /**
     * Returns the number of elements in this list.
     * 
     * @return
     */
    public int size()
    {
        return _list.size();
    }

    //-----------------------------------------------------------------------------
    /**
     * Returns 'true' if this list contains no elements
     * 
     * @return
     */
    public boolean isEmpty()
    {
        return _list.isEmpty();
    }

    //-----------------------------------------------------------------------------
    public TreeNode get(int index)
    {
        if (_list.isEmpty())
        {
            return null;
        }
        else
        {
            return (TreeNode) _list.get(index);
        }
    }

    //----------------------------------------------------------------------------------------    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() 
    {
        return "TreeNodeList [" + _list.size() + " node(s)" +"]";
    }
    
}
