package org.objectweb.telosys.common.data.old;

import java.util.LinkedList;

import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Aurelien COUERON
 * Node bean to fill <menuitems> 
 */
public class MenuItemNode  extends TelosysObject
{
    private String _sKey;
    private String _sLabel;
    private String _sLink;
    private String _sImg;
    private String _sCl;
    private String _sStyle;
    private LinkedList _listChildren;
    
    // Constructor for head
    public MenuItemNode (LinkedList children) {
        super();
        _listChildren = children;
    }
    
    //  Constructor for node
    public MenuItemNode (String key, String label, String link, String img, String cl, String style, LinkedList children) {
        super();
        _sKey = key;
        _sLabel = label;
        _sLink = link;
        _sImg = img;
        _sCl = cl;
        _sStyle = style;
        _listChildren = children;
    }
    
    // Constructor for leaf
    public MenuItemNode (String key, String label, String link, String img, String cl, String style) {
        super();
        _sKey = key;
        _sLabel = label;
        _sLink = link;
        _sImg = img;
        _sCl = cl;
        _sStyle = style;
    }
    
    /**
     * @return the img
     */
    public String getImg()
    {
        return _sImg;
    }
    
    /**
     * @return the label
     */
    public String getLabel()
    {
        return _sLabel;
    }
    /**
     * @return the link
     */
    public String getLink()
    {
        return _sLink;
    }
    /**
     * @return the cl
     */
    public String getCl()
    {
        return _sCl;
    }

    /**
     * @return the key
     */
    public String getKey()
    {
        return _sKey;
    }
    
    /**
     * @return the children
     */
    public LinkedList getChildren()
    {
        return _listChildren;
    }
    
    /**
     * @return the _sStyle
     */
    public String getStyle()
    {
        return _sStyle;
    }
    
    public void setChildren(LinkedList children)
    {
        this._listChildren = children;
    }    
///**
//* @param img the img to set
//*/
//public void setImg(String img)
//{
// this._sImg = img;
//}
//  /**
//  * @param label the label to set
//  */
// public void setLabel(String label)
// {
//     this._sLabel = label;
// }
//
//  /**
//  * @param link the link to set
//  */
// public void setLink(String link)
// {
//     this._sLink = link;
// }
//  /**
//  * @param cl the cl to set
//  */
// public void setStyleClass(String styleClass)
// {
//     this._sCl = styleClass;
// }
//  /**
//  * @param key the key to set
//  */
// public void setKey(String key)
// {
//     this._sKey = key;
// }
//  /**
//  * @param children the children to set
//  */
// 
//  /**
//  * @param style the _sStyle to set
//  */
// public void setStyle(String style)
// {
//     _sStyle = style;
// }
    
    /**
     * ToString
     */
    public String toString() {
        return _sKey+"|"+_sLabel+"|"+_sImg+"|"+_sLink+"|"+_sCl+"|"+_sStyle+"|"+_listChildren.size();
    }
    
}
