package org.objectweb.telosys.common.val;

/**
 * This class wraps a value of the primitive type 'boolean' in an object. 
 * The current value can be changed with the 'setValue' method.
 * 
 * @author Laurent Guerin
 */
public class BooleanValue implements ISingleValue
{
    private boolean _value = false ;
        
    //-----------------------------------------------------------------------------------
    
    /**
     * Default constructor, the initial value is 'false'.
     */
    public BooleanValue () 
    {
        _value = false ;
    }
    
    /**
     * Constructor with initial value
     * @param v initial value 
     */
    public BooleanValue ( boolean v ) 
    {
        _value = v;
    }
    
    //-----------------------------------------------------------------------------------

    public void setValue(boolean v)
    {
        _value = v;
    }
    
    public boolean getValue()
    {
        return ( _value ) ;
    }
    
    //-----------------------------------------------------------------------------------
    
    public String toString()
    {
        return "" + _value ;
    }
    
}
