package org.objectweb.telosys.common.val;

/**
 * This class wraps a value of the primitive type 'double' in an object. 
 * The current value can be changed with the 'setValue' method.
 * 
 * @author Laurent Guerin
 */
public class DoubleValue implements ISingleValue
{
    private double _value = 0.0 ;
        
    //-----------------------------------------------------------------------------------
    
    /**
     * Default constructor, the initial value is '0.0'.
     */
    public DoubleValue () 
    {
        _value = 0.0 ;
    }
    
    /**
     * Constructor with initial value
     * @param v initial value 
     */
    public DoubleValue ( double v ) 
    {
        _value = v;
    }
    
    //-----------------------------------------------------------------------------------

    public void setValue(double v)
    {
        _value = v;
    }
    
    public double getValue()
    {
        return ( _value ) ;
    }
    
    //-----------------------------------------------------------------------------------
    
    public String toString()
    {
        return "" + _value ;
    }
    
}
