package org.objectweb.telosys.common.val;

/**
 * This class wraps a value of the primitive type 'float' in an object. 
 * The current value can be changed with the 'setValue' method.
 * 
 * @author Laurent Guerin
 */
public class FloatValue implements ISingleValue
{
    private float _value = 0 ;
        
    //-----------------------------------------------------------------------------------
    
    /**
     * Default constructor, the initial value is '0'.
     */
    public FloatValue () 
    {
        _value = 0 ;
    }
    
    /**
     * Constructor with initial value
     * @param v initial value 
     */
    public FloatValue ( float v ) 
    {
        _value = v;
    }
    
    //-----------------------------------------------------------------------------------

    public void setValue(float v)
    {
        _value = v;
    }
    
    public float getValue()
    {
        return ( _value ) ;
    }
    
    //-----------------------------------------------------------------------------------
    
    public String toString()
    {
        return "" + _value ;
    }
    
}
