package org.objectweb.telosys.common.val;

/**
 * This class wraps a value of the primitive type 'int' in an object. 
 * The current value can be changed with the 'setValue' method.
 * 
 * @author Laurent Guerin
 */
public class IntValue implements ISingleValue
{
    private int _value = 0 ;
        
    //-----------------------------------------------------------------------------------
    
    /**
     * Default constructor, the initial value is '0'.
     */
    public IntValue () 
    {
        _value = 0 ;
    }
    
    /**
     * Constructor with initial value
     * @param v initial value 
     */
    public IntValue ( int v ) 
    {
        _value = v;
    }
    
    //-----------------------------------------------------------------------------------

    public void setValue(int v)
    {
        _value = v;
    }
    
    public int getValue()
    {
        return ( _value ) ;
    }
    
    //-----------------------------------------------------------------------------------
    
    public String toString()
    {
        return "" + _value ;
    }
    
}
