package org.objectweb.telosys.common.val;

/**
 * This class wraps a value of the primitive type 'long' in an object. 
 * The current value can be changed with the 'setValue' method.
 * 
 * @author Laurent Guerin
 */
public class LongValue implements ISingleValue
{
    private long _value = 0 ;
        
    //-----------------------------------------------------------------------------------
    
    /**
     * Default constructor, the initial value is '0'.
     */
    public LongValue () 
    {
        _value = 0 ;
    }
    
    /**
     * Constructor with initial value
     * @param v initial value 
     */
    public LongValue ( long v ) 
    {
        _value = v;
    }
    
    //-----------------------------------------------------------------------------------

    public void setValue(long v)
    {
        _value = v;
    }
    
    public long getValue()
    {
        return ( _value ) ;
    }
    
    //-----------------------------------------------------------------------------------
    
    public String toString()
    {
        return "" + _value ;
    }
    
}
