package org.objectweb.telosys.dal.dao;

import java.sql.Connection;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 *  
 */
public class DummyDatabaseSession extends TelosysObject implements DatabaseSession
{
    
// Suppr / v 1.0.2
//    private final static DummyDatabaseSession $dummyDbSession = new DummyDatabaseSession();
//    
//    public final static DummyDatabaseSession getInstance()
//    {
//        return $dummyDbSession ;
//    }
    
    /**
     * Constructor for a "dummy database session"<br>
     * (without a real database connection)
     */
    public DummyDatabaseSession()
    {
        super();
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#getId()
     */
    public long getId() // since v 1.0.2
    {
        return 0L ;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#isDummy()
     */
    public boolean isDummy()
    {
        return true;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#getDatabaseId()
     */
    public int getDatabaseId()
    {
        return -1;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#getConnection()
     */
    public Connection getConnection()
    {
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#commit()
     */
    public void commit() throws TelosysException
    {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#rollback()
     */
    public void rollback() throws TelosysException
    {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.dal.dao.DatabaseSession#close()
     */
    public void close() throws TelosysException
    {
    }

    public String toString() 
    {
        return "DummyDatabaseSession";
    }
}