package org.objectweb.telosys.dal.dao;


/**
 * @author Laurent GUERIN
 * 
 */
public interface ListQuery
{
    /**
     * Return the SQL request "select ... from ..."
     * @return
     */
    public String getSqlSelect();

    /**
     * Return the SQL request "delete from ..."
     * @return
     */
    public String getSqlDelete();

    /**
     * Return the SQL request "select count(*) from ..."
     * @return
     */
    public String getSqlCount();

    //---------------------------------------------------------------------------
    
    /**
     * Set the value of a parameter 
     * @param iIndex index of the parameter to set ( 1 to N ) 
     * @param oValue value of the parameter
     */
    public void setParameter(int iIndex, Object oValue);

    /**
     * Set the value of a parameter 
     * @param iIndex index of the parameter to set ( 1 to N ) 
     * @param shValue value of the parameter
     */
    public void setParameter(int iIndex, short shValue);
    
    /**
     * Set the value of a parameter 
     * @param iIndex index of the parameter to set ( 1 to N ) 
     * @param iValue value of the parameter
     */
    public void setParameter(int iIndex, int iValue);

    /**
     * Set the value of a parameter 
     * @param iIndex index of the parameter to set ( 1 to N ) 
     * @param lValue value of the parameter
     */
    public void setParameter(int iIndex, long lValue);
    
    //---------------------------------------------------------------------------
    /**
     * Returns the number of parameters for the query
     * @return 
     */
    public int getParamCount();

    //---------------------------------------------------------------------------
    
    /**
     * Get the value of a parameter 
     * @param iIndex index of the parameter ( 1 to N ) 
     * @return the value
     */
    public Object getParameter(int iIndex);

//    /**
//     * Return the query parameters as an array <br> 
//     * ( the first useful parameter is at index 1 )
//     * @return
//     */
//    public Object[] getParametersArray();

    /** 
     * Return the query parameters as a String
     * @return
     */
    public String getParametersString();

}