package org.objectweb.telosys.dal.rest;

import java.io.PrintWriter;

/**
 * TEXT response renderer
 * 
 * @author Laurent GUERIN
 * @since 1.0.0
 */
public class DAORendererText implements DAORenderer
{
    private PrintWriter pw = null ;
    
    /**
     * @param pw
     */
    public DAORendererText(PrintWriter pw)
    {
        super();
        this.pw = pw;
    }
    
    public void printResponse( DAOResponse response )
    {
        pw.println("Action = " + response.getAction() );
        pw.println("Return Code = " + response.getRetCode() );
        if ( response.isFound() ) pw.println("FOUND" );
        if ( response.isNotFound() ) pw.println("NOT FOUND" );
        Object bean = response.getResultObject();
        if ( bean != null )
        {
            pw.println("Record Bean : " + bean );
        }
    }

    public void printError( Throwable t )
	{
	    pw.println( "ERROR : " );
	    pw.println( t.getMessage() );
	}
    
}
