package org.objectweb.telosys.dal.rest;

/**
 * @author Laurent GUERIN
 * @since 1.0.0
 */
/* package */ class DAOResponse
{
    private Class   _daoClass = null ;
    
    private String  _sAction  = null ;
    
    private Boolean _bRetCode = null ;
    
    private Long    _lRetCode = null ;
    
    private Object  _oResult  = null ;

    private Boolean _bFound   = null ;

        
    public DAOResponse(Class cl, String action, boolean b )
    {
        _daoClass = cl ;
        _sAction = action;
        _bRetCode = new Boolean(b);
    }
    
    public DAOResponse(Class cl, String action, Long l )
    {
        _daoClass = cl ;
        _sAction = action;
        _lRetCode = l;
    }
    
    public DAOResponse(Class cl, String action, int i )
    {
        _daoClass = cl ;
        _sAction = action;
        _lRetCode = new Long(i);
    }
    
    public DAOResponse(Class cl, String action, int i, Object bean )
    {
        _daoClass = cl ;
        _sAction = action;
        _lRetCode = new Long(i);
        _oResult = bean ;
    }
    
    public DAOResponse(Class cl, String action, int i, Object bean, boolean found )
    {
        _daoClass = cl ;
        _sAction = action;
        _lRetCode = new Long(i);
        if ( found ) {
            _oResult = bean ;
        }
        _bFound = new Boolean(found); ;
    }
    

    public Class getDAOClass()
    {
        return _daoClass ;
    }

    public String getDAOClassName()
    {
        return ( _daoClass != null ? _daoClass.getName() : "null" ) ;
    }
        
    public String getAction()
    {
        return _sAction;
    }
    
    public String getRetCode()
    {
        String s = "null" ;
        if ( _bRetCode != null )
        {
            s = "" + _bRetCode.booleanValue();  
        }
        if ( _lRetCode != null )
        {
            s = "" + _lRetCode.longValue();  
        }
        return s ;
    }
    
    public Boolean getBoolRetCode()
    {
        return _bRetCode;
    }
    
    public Long getLongRetCode()
    {
        return _lRetCode;
    }
    
    public Object getResultObject()
    {
        return _oResult;
    }
    
    public boolean isFound()
    {
        if ( _bFound != null ) return _bFound.booleanValue() ;
        return false ;
    }
    public boolean isNotFound()
    {
        if ( _bFound != null ) return ( ! _bFound.booleanValue() ) ;
        return false ;
    }
    
    
    public String toString()
    {
        String s = _oResult != null ? _oResult.getClass().getName() : "null" ;
        return  _sAction + " : return code = " + getRetCode() + " ( result : " + s + " )" ;
    }
}
