package org.objectweb.telosys.dal.sql;

import java.sql.Connection;

/**
 * @author Laurent GUERIN
 *  
 */
public interface ConnectionProvider 
{
    public final static int NO_PROVIDER = 0 ;
    public final static int FACTORY     = 1 ;
    public final static int POOL        = 2 ;
    public final static int DATASOURCE  = 3 ;
    public final static int CUSTOMCLASS = 4 ; // v 1.0.1
    
    /**
     * Returns the name of the ConnectionProvider (from 'dbconfig' file)
     * @return
     */
    public String getName() ;
    
    /**
     * Returns a standard JDBC Connection 
     * @return
     * @throws Exception
     */
    public Connection getConnection() throws Exception;
    
    
    /**
     * Returns the type of ConnectionProvider : FACTORY, POOL, DATASOURCE, CUSTOMCLASS <br>
     * @return
     * @since 1.0.0
     */
    public int getType() ;
    

}