package org.objectweb.telosys.dal.tools;

import java.util.Date;

import org.objectweb.telosys.common.TelosysClassLogger;

/**
 * Technical thread designed to check all the connections presents in the pool.
 *  
 * @author Laurent GUERIN
 * @since v 1.0.2
 */
public class ConnectionPoolThread extends Thread //implements Runnable
{
    private static final TelosysClassLogger log = new TelosysClassLogger(ConnectionPoolThread.class);

    private long _sleepDuration = 60 ; // Default duration : 60 seconds
        
    /**
     * Thread constructor
     * @param sleepDuration : the thread's sleep duration between 2 actions
     */
    public ConnectionPoolThread(long sleepDuration)
    {
        super();
        this.setName(this.getClass().getName());
        this._sleepDuration = sleepDuration;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Runnable#run()
     */
    public void run()
    {
        System.out.println("run ... " + new Date() );
        try
        {
            while ( true ) 
            {
                Thread.sleep( 1000 * _sleepDuration );
                action();
            } 
            
        } catch (InterruptedException e) // thrown by the context listener when it stops
        {
            log.info("Thread interrupted");
            //throw new TelosysRuntimeException("Thread interrupted", e);
        }
    }

    private void action()
    {
        // TODO : implements the action
        System.out.println( this.toString() + "do action - date = " + new Date() );
    }
    
//    public static void main(String[] args)
//    {
//        try
//        {
//            ConnectionPoolThread thread = new ConnectionPoolThread(10);
//            //thread.setDaemon(true);
//            thread.start();
//            System.out.println("Thread " + thread.toString() + " started.");
//        } catch (Throwable t)
//        {
//            System.out.println("Throwable exception : " + t.toString() + " - Message = " + t.getMessage());    
//            t.printStackTrace();
//        }
//    }
    
}
