package org.objectweb.telosys.rpl;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.uil.renderer.Renderers;

/**
 * View generated by a screen action mapped with a container widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ScreenRequestView extends TelosysObject
{
    private String _sName     = null;

    private String _sRenderer = null;

    public ScreenRequestView()
    {

    }

    //    public ScreenRequestView(String sName, String sRendererPath)
    //    {
    //        super();
    //        if (sName == null)
    //        {
    //            throw new TelosysRuntimeException("ScreenView constructor : name is null ");
    //        }
    //        if (sRendererPath == null)
    //        {
    //            throw new TelosysRuntimeException("ScreenView constructor : renderer path is null ");
    //        }
    //        _sName = sName;
    //        _sRendererPath = sRendererPath;
    //    }

    //------------------------------------------------------------------------------------------
    /**
     * Returns the name of the view
     * 
     * @return
     */
    public String getName()
    {
        return _sName;
    }

    /**
     * Set the name of the view
     * 
     * @param s
     */
    public void setName(String s)
    {
        _sName = s;
    }

    //------------------------------------------------------------------------------------------
    /**
     * Returns the renderer used to generate the view
     * 
     * @return
     */
    public String getRenderer()
    {
        return _sRenderer;
    }

    /**
     * Set the renderer to use to generate the view
     * 
     * @param s
     */
    public void setRenderer(String s)
    {
        _sRenderer = s;
    }

    //------------------------------------------------------------------------------------------
    /**
     * Generates the view using the associated renderer
     * 
     * @param httpRequest
     * @param httpResponse
     */
    public void generate(HttpServletRequest httpRequest, HttpServletResponse httpResponse)
    {
        Renderers.generate(_sRenderer, httpRequest, httpResponse);
//        if (httpRequest == null)
//        {
//            throw new TelosysRuntimeException("httpRequest is null ");
//        }
//        if (httpResponse == null)
//        {
//            throw new TelosysRuntimeException("httpResponse is null ");
//        }

//        trace("generate() : getRequestDispatcher(" + _sRenderer + ")");
        
//        RequestDispatcher rd = httpRequest.getRequestDispatcher(_sRenderer);
//        if (rd != null)
//        {
//            //                //--- 1) Set the RENDERER BEAN in the Request
//            //                httpRequest.setAttribute( TelosysConst.RENDERER_BEAN, element.getInstance() );
//            //--- 1) Set the renderer name in the request
//            httpRequest.setAttribute( TelosysConst.CURRENT_RENDERER, _sRenderer );
//            //--- 2) Call the RENDERER (via "include")
//            try
//            {
//                trace("generate() : rd.include(..,..)");
//                rd.include(httpRequest, httpResponse);
//            } catch (ServletException e)
//            {
//                throw new TelosysRuntimeException("generate(): ServletException ", e);
//            } catch (IOException e)
//            {
//                throw new TelosysRuntimeException("generate(): IOException ", e);
//            }
//            //                //--- 3) Remove the RENDERER BEAN from the Request
//            //                httpRequest.removeAttribute( TelosysConst.RENDERER_BEAN );
//            //--- 3) Remove the renderer name from the Request
//            httpRequest.removeAttribute( TelosysConst.CURRENT_RENDERER );
//        }
//        else
//        {
//            throw new TelosysRuntimeException("render(): cannot get RequestDispatcher for path '" + _sRenderer + "'");
//        }
    }
    
    //-----------------------------------------------------------------------------------------------
    public String toString()
    {
        return "name='" + _sName + "' renderer='" + _sRenderer +"'" ; 
    }
}