package org.objectweb.telosys.rpl.xml;

import java.io.PrintWriter;

/**
 * Interface to give XML mapping capabilities to a Java object. <br>
 * It provides bidirectional mapping :<br>
 * from XML to java object <br>
 * from Java object to XML <br>
 * 
 * @author Laurent GUERIN
 *  
 */
public interface IXmlWrapper
{
    /**
     * Returns the class of the bean managed by the XML mapper
     * @return the class
     */
    public Class getBeanClass();

    /**
     * Creates an new instance of the b managed by the XML mapper 
     * @return bean instance
     */
    public Object createBean();

    /**
     * Set the given field value in the object field corresponding to the given field name.
     * @param bean : the bean to update
     * @param sFieldName : the name of the field in the XML flow 
     * @param sFieldValue : the value of the field
     */
    public void setXmlFieldValue(Object bean, String sFieldName, String sFieldValue);
     
    /**
     * Print the given bean as XML tag on the given output
     * @param out
     * @param bean
     * @param sTagName
     */
    public void toXml(PrintWriter out, Object bean, String sTagName );

}