package org.objectweb.telosys.rpl.xml.mapper;

import java.io.PrintWriter;

import org.objectweb.telosys.common.val.DateValue;
import org.objectweb.telosys.rpl.xml.IXmlWrapper;
import org.objectweb.telosys.rpl.xml.XmlWrapperAncestor;

/**
 * @author TELOSYS GENERATOR
 *
 */
public class DateValueMapper extends XmlWrapperAncestor implements IXmlWrapper
{
    /*
     * Default constructor
     */
    public DateValueMapper()
    {
        super(DateValue.class);
    }
    
	//-----------------------------------------------------------------------------------
    /* 
     * Interface Implementation
     * @see org.objectweb.telosys.rpl.xml.IXmlWrapper
     */
    public Object createBean()
    {
        return new DateValue() ; 
    }

	//-----------------------------------------------------------------------------------
	/* 
	 * Interface Implementation
	 * @see org.telosys.xml.IXmlWrapper
	 * Set the values received in XML format
	 * ( the "XML entities" are processed by the parser => no conversion needed )
	 */
    public void setXmlFieldValue(Object oBean, String sName, String sValue)
    {
        if (oBean != null)
        {
            if (oBean instanceof DateValue)
            {
                DateValue vo = (DateValue) oBean;
				if (sName.equals( "value" ))
				{
			    	vo.setValue( getDateISO(sName,sValue) );
					return;
				}
                //--- Unknown attribute
                throwException("unknown attribute '" + sName + "' in setXmlFieldValue(" + sName + "," + sValue + ")");
            }
            else
            {
                throwException("bean class = '" + oBean.getClass().getName() + "' ( DateValue expected )");
            }
        }
        else
        {
            throwException("bean is null");
        }
	}

	//-----------------------------------------------------------------------------------
	/*
	 * Interface Implementation
	 * @see org.telosys.xml.IXmlWrapper
	 * Serialized the bean in XML format
	 */
	public void toXml(PrintWriter out, Object oBean, String sTagName)
	{
        if (oBean != null)
        {
            if (oBean instanceof DateValue)
            {
                DateValue vo = (DateValue) oBean ;                
				out.print("<" + sTagName + " ");
				out.print( "value=\"" + attributeString( vo.getValue() ) + "\" ");
				out.println("/>");
			}
            else
            {
                throwException("bean class = '" + oBean.getClass().getName() + "' ( DateValue expected )");
            }
		}
		else
		{
			out.print("<!-- " + sTagName + " = null -->");
		}
	}
	//-----------------------------------------------------------------------------------
}

