package org.objectweb.telosys.screen.core;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenRequestParameters;
import org.objectweb.telosys.rpl.ScreenResponse;
import org.objectweb.telosys.screen.env.ScreenSession;

/**
 * @author Laurent GUERIN
 *
 */
public interface ScreenActions
{
    //--- Events 
    //public void eventCreate(ScreenContext screenContext, ScreenRequestParameters params) throws TelosysException ;
    public void eventCreate(ScreenContext screenContext, ScreenRequestParameters params, ScreenSession screenSession) throws TelosysException ;
    
    //public void eventReuse(ScreenContext screenContext, ScreenRequestParameters params) throws TelosysException ;
    public void eventReuse(ScreenContext screenContext, ScreenRequestParameters params, ScreenSession screenSession) throws TelosysException ;
    
    //--- Basic actions 
    public void actionSet(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionGet(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionClear(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    //--- Persistence actions 
    public void actionLoad(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionSave(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionSaveCurrent(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionInsert(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionUpdate(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionDelete(ScreenContext screen, ScreenRequest request, ScreenResponse response ) throws TelosysException ;

    public void actionDeleteCurrent(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    //--- List management 
    public void actionListSelect(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionListInsert(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionListAdd(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionListRemove(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionListClear(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionListSort(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    //--- Specific 'procedure call'
    public void actionExec(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException;


}
