package org.objectweb.telosys.screen.core;

import org.objectweb.telosys.dal.dao.DatabaseSession;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenResponse;

/**
 * @author Laurent GUERIN
 *
 */
public interface ScreenTriggers
{
    //--- SET 
    public boolean beforeSet(ScreenData dataToSet, ScreenContext screen, ScreenRequest request, ScreenResponse response );

    public boolean afterSet(ScreenData dataSet, ScreenContext screen, ScreenRequest request, ScreenResponse response );

    //--- GET 
    public boolean beforeGet( ScreenContext screen, ScreenRequest request, ScreenResponse response );

    public boolean afterGet( ScreenContext screen, ScreenRequest request, ScreenResponse response );
    
    //--- CLEAR 
    public boolean beforeClear( ScreenContext screen, ScreenRequest request, ScreenResponse response );

    public boolean afterClear( ScreenContext screen, ScreenRequest request, ScreenResponse response );
    
    
    //--- LOAD 
    public boolean beforeLoad(ScreenData dataForLoad, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    public boolean afterLoad(ScreenData dataLoaded, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    //--- SAVE 
    public boolean beforeSave(ScreenData dataToSave, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    public boolean afterSave(ScreenData dataSaved, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    //--- INSERT 
    public boolean beforeInsert(ScreenData dataToInsert, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    public boolean afterInsert(ScreenData dataInserted, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    //--- UPDATE 
    public boolean beforeUpdate(ScreenData dataToUpdate, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    public boolean afterUpdate(ScreenData dataUpdated, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    //--- DELETE 
    public boolean beforeDelete(ScreenData dataToDelete, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

    public boolean afterDelete(ScreenData dataDeleted, ScreenContext screen, ScreenRequest request, ScreenResponse response, DatabaseSession session);

}
