
package org.objectweb.telosys.screen.core;

import javax.servlet.ServletContext;

import org.objectweb.telosys.screen.env.ScreenApplication;
import org.objectweb.telosys.screen.env.ScreenApplicationManager;

/**
 *
 * Standard ancestor class for ScreenProcedures implementation.<br>
 * Abstract class designed to be specialized for each screen.<br>
 * 
 * @author Laurent GUERIN
 * @since 1.0.0
 * 
 */
public abstract class StandardScreenProcedures implements ScreenProcedures
{
    //----------------------------------------------------------------------------------------------
    /**
     * Returns the ScreenApplication object
     * @return
     */
    protected ScreenApplication getScreenApplication() 
    {
        return ScreenApplicationManager.getScreenApplication();
    }
    
    //----------------------------------------------------------------------------------------------
    /**
     * Returns the ServletContext object
     * @return
     */
    protected ServletContext getServletContext() 
    {
        return ScreenApplicationManager.getServletContext();
    }
    
    //----------------------------------------------------------------------------------------------
}
