package org.objectweb.telosys.service;

import org.objectweb.telosys.common.TelosysException;


/**
 * @author Laurent GUERIN
 *
 */
public interface IServiceProvider  
{
    /**
     * Return an instance of the service identified by its name
     * @param sScreenName
     * @return the service instance
     * @throws TelosysException
     */
    public ScreenService getService ( String sScreenName ) throws TelosysException ;
    
    /**
     * Return the key used to store the service result in the ScreenSession 
     * @param sServiceName
     * @return the key (can be null if no result storage)
     * @throws TelosysException
     */
    public String getSessionKey(String sServiceName) throws TelosysException ;

}
