package org.objectweb.telosys.service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.common.TelosysConst;
import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.uil.renderer.Renderers;

/**
 * @author Laurent GUERIN
 *
 */

public class ServiceRenderer extends TelosysObject
{
    private String _sRenderer = null ;
    private HttpServletRequest _httpRequest = null ;
    private HttpServletResponse _httpResponse = null ;
    
    public ServiceRenderer( String sRenderer, HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws TelosysException
    {
        _sRenderer = sRenderer ;
        _httpRequest = httpRequest ;
        _httpResponse = httpResponse ;
        if ( sRenderer == null )
        {
            throw new TelosysException("ServiceRenderer constructor : renderer is null ");
        }
        if ( httpRequest == null )
        {
            throw new TelosysException("ServiceRenderer constructor : httpRequest is null ");
        }
        if ( httpResponse == null )
        {
            throw new TelosysException("ServiceRenderer constructor : httpResponse is null ");
        }
    }
    
    public String getPath()
    {
        return _sRenderer ;
    }
    
    public void render( ServiceResponse serviceResponse ) throws TelosysException
    {        
        if (_sRenderer != null && _httpRequest != null )
        {
            //--- 1) Set the RENDERER BEAN in the Request
            _httpRequest.setAttribute( TelosysConst.RENDERER_BEAN, serviceResponse.getResult() );
            
            //--- 2) Generate the RENDERER (via "include")
            Renderers.generate(_sRenderer, _httpRequest, _httpResponse);

//            //--- 2) Call the RENDERER (via "include")            
//            trace("render() : getRequestDispatcher(" + _sRenderer + ")");
//            RequestDispatcher rd = _httpRequest.getRequestDispatcher(_sRenderer);
//            trace("render() : rd.include(..,..)");
//            try
//            {
//                rd.include(_httpRequest, _httpResponse);
//            } catch (ServletException e)
//            {
//                throw new TelosysException("ServiceRenderer.render(): ServletException ", e);
//            } catch (IOException e)
//            {
//                throw new TelosysException("ServiceRenderer.render(): IOException ", e);
//            }
        }
    }
}
