package org.objectweb.telosys.service;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 *
 */

public class ServiceResultHolder extends TelosysObject
{
    private Object  _oResult = null ;

    private String  _sRenderer = null ;
    
    public ServiceResultHolder( ScreenService service, ServiceResponse response ) throws TelosysException
    {
        if ( service == null )
        {
            throw new TelosysException("ServiceStateHolder constructor : service is null ");
        }
        if ( response == null )
        {
            throw new TelosysException("ServiceStateHolder constructor : response is null ");
        }
        _oResult = response.getResult() ;
        _sRenderer = service.getRenderer() ;
    }
    
    public Object getResult() 
    {
        trace("getResult() : " + ( _oResult != null ? "found" : "not found" ) );
        return _oResult ;
    }
    
    public String getRenderer() 
    {
        trace("getRenderer() : " + _sRenderer );
        return _sRenderer ;
    }
}
