package org.objectweb.telosys.uil;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.common.TelosysServlet;

/**
 * Standard servlet for void content ( for example for iframe src in "https" ) 
 * 
 * @author Laurent GUERIN
 *
 */
public class VoidServlet extends TelosysServlet // extends HttpServlet
{
    //----------------------------------------------------------------------------------
    // CONSTANTS
    //----------------------------------------------------------------------------------
    private static final int    TEXT          = 1 ;
    private static final int    HTML          = 2 ;
    
    private static final String TEXT_CONTENT_TYPE = "text/plain; charset=UTF-8";
    private static final String HTML_CONTENT_TYPE = "text/html; charset=UTF-8";

    //----------------------------------------------------------------------------------

    /* (non-Javadoc)
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doGet(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws ServletException, IOException
    {
        trace("doGet()...");
        process(httpRequest, httpResponse);
    }

    /* (non-Javadoc)
     * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doPost(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws ServletException, IOException
    {
        trace("doPost()...");
        process(httpRequest, httpResponse);
    }
    
    /**
     * Standard servlet processing 
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    private void process(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        int iType = TEXT ;
        
        String sType = request.getParameter("type");
        if ( sType != null )
        {
            if ( sType.equalsIgnoreCase("html") )
            {
                iType = HTML ;
            }
        }
        
        if ( iType == HTML )
        {
            response.setContentType(HTML_CONTENT_TYPE);
            PrintWriter out = response.getWriter();
            out.println("<!DOCTYPE HTML PUBLIC \"-//w3c//dtd html 4.0 transitional//en\">");
            out.println("<html>");
            out.println("<head><title></title></head>");
            out.println("<body></body>");
            out.println("</html>");
            out.close();
        }
        else
        {
            response.setContentType(TEXT_CONTENT_TYPE);
        }

    }
}