package org.objectweb.telosys.uil.i18n;

/**
 * The interface for translations dictionaries 
 * 
 * @author Laurent GUERIN
 *
 */
public interface Translator
{
    /**
     * Returns the translated text for the given key and the given language 
     * @param sKey the tag attribute key ( e.g. : "MyTagId.txt")
     * @param sLanguage the language ( e.g. : "fr", "en", "it", ... )
     * @return the translated text, or null if there's no translation for the given key
     */
    public String translate(String sKey, String sLanguage);
    
    /**
     * Returns the dictionary size ( translator entries count )
     * @return
     */
    public int size();
    
    /**
     * Returns true if this translator is empty ( contains no keys to translate )
     * @return
     */
    public boolean isEmpty();
}
