package org.objectweb.telosys.uil.screenmap;

import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 * 
 */
public class ScreenDefRootDir extends TelosysObject
{
    // <rootdir><template>
    private String   _sTemplateRootDir = "/screen/template";

    // <rootdir><body>
    private String   _sBodyRootDir     = "/screen";

    // <rootdir><css>
    private String   _sCssRootDir      = "/screen/css";

    // <rootdir><images>
    private String   _sImagesRootDir   = "/screen/images";

    // <rootdir><script>
    private String   _sScriptRootDir   = "/screen/script";

    // <rootdir><page>
    private String   _sPageRootDir     = "/page";

    //---------------------------------------------------------------------------

    //---------------------------------------------------------------------------
    private String buildURL(String sFile, String sRootDir)
    {
        if (sFile != null)
        {
            if (sFile.indexOf('/') < 0) // No "/" in the File Name
            {
                return sRootDir + "/" + sFile;
            }
            else
            {
                return sFile;
            }
        }
        else
        {
            return null;
        }
    }

    //---------------------------------------------------------------------------
    // TEMPLATE
    //---------------------------------------------------------------------------
    /* package */ void setTemplateRootDir(String s)
    {
        _sTemplateRootDir = s ;
    }
    //---------------------------------------------------------------------------
    public String getTemplateRootDir()
    {
        return _sTemplateRootDir ;
    }
    //---------------------------------------------------------------------------
    public String getTemplatePath(String sFile)
    {
        return buildURL(sFile, _sTemplateRootDir);
    }

    //---------------------------------------------------------------------------
    // SCREEN BODY
    //---------------------------------------------------------------------------
    /* package */ void setBodyRootDir(String s)
    {
        _sBodyRootDir = s;
    }
    //---------------------------------------------------------------------------
    public String getBodyRootDir()
    {
        return _sBodyRootDir;
    }
    //---------------------------------------------------------------------------
    public String getBodyPath(String sFile)
    {
        return buildURL(sFile, _sBodyRootDir);
    }

    //---------------------------------------------------------------------------
    // PAGE
    //---------------------------------------------------------------------------
    /* package */ void setPageRootDir(String s)
    {
        _sPageRootDir = s;
    }
    //---------------------------------------------------------------------------
    public String getPageRootDir()
    {
        return _sPageRootDir;
    }
    //---------------------------------------------------------------------------
    public String getPagePath(String sFile)
    {
        return buildURL(sFile, _sPageRootDir);
    }

    //---------------------------------------------------------------------------
    // CSS
    //---------------------------------------------------------------------------
    /* package */ void setCssRootDir(String s)
    {
        _sCssRootDir = s ;
    }
    //---------------------------------------------------------------------------
    public String getCssRootDir()
    {
        return _sCssRootDir;
    }
    //---------------------------------------------------------------------------
    public String getCssPath(String sFile)
    {
        return buildURL(sFile, _sCssRootDir);
    }

    //---------------------------------------------------------------------------
    // IMAGES
    //---------------------------------------------------------------------------
    /* package */ void setImagesRootDir(String s)
    {
        _sImagesRootDir = s;
    }
    //---------------------------------------------------------------------------
    public String getImagesRootDir()
    {
        return _sImagesRootDir;
    }
    //---------------------------------------------------------------------------
    public String getImagePath(String sFile)
    {
        return buildURL(sFile, _sImagesRootDir);
    }

    //---------------------------------------------------------------------------
    // SCRIPT
    //---------------------------------------------------------------------------
    /* package */ void setScriptRootDir(String s)
    {
        _sScriptRootDir = s;
    }
    //---------------------------------------------------------------------------
    public String getScriptRootDir()
    {
        return _sScriptRootDir;
    }
    //---------------------------------------------------------------------------
    public String getScriptPath(String sFile)
    {
        return buildURL(sFile, _sScriptRootDir);
    }

    //---------------------------------------------------------------------------

}