package org.objectweb.telosys.uil.taglib;



/**
 * @author Laurent GUERIN
 *  
 */
public class ListColumns 
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------
    //private Vector  _vectColumns = new Vector() ;

    private int[] _columns = new int[1024] ;
    
    private int _iCurrent = 0 ;
    
    private int _iCount = 0 ;
    
    public ListColumns()
    {
        super();
        
    }

    //----------------------------------------------------------------
    public void resetAll()
    {
        for ( int i = 0 ; i < _columns.length ; i++ )
        {
            _columns[i] = 0 ;
        }
        _iCount = 0 ;
        _iCurrent = 0 ;
    }
    //----------------------------------------------------------------
    public void resetCurrent()
    {
        _iCurrent = 0 ;
    }
    //----------------------------------------------------------------
    /**
     * Switch the current cell to the next position
     */
    public void next()
    {
        _iCurrent++ ;
    }
    //----------------------------------------------------------------
    public int getCurrent()
    {
        return _iCurrent ;
    }
    
    //----------------------------------------------------------------
    public int getCount()
    {
        return _iCount ;
    }
    
    //----------------------------------------------------------------
    /**
     * Set the width for the current Cell
     * @param width
     */
    public void setWidth(int width)
    {
        if ( _iCurrent < _columns.length )
        {
            _columns[_iCurrent] = width ;            
        }
        if ( _iCount < _iCurrent )
        {
            _iCount = _iCurrent ;            
        }
    }

    //----------------------------------------------------------------
    /**
     * Get the width of the current Cell
     * @return
     */
    public int getWidth()
    {
        if ( _iCurrent < _columns.length )
        {
            return _columns[_iCurrent];
        }
        return 0 ;
    }
    //----------------------------------------------------------------
    public int getWidth(int i)
    {
        if ( i >= 0 && i < _iCount && i < _columns.length )
        {
            return _columns[i];
        }
        return 0 ;
    }

    //----------------------------------------------------------------
    public int getTotalWidth()
    {
        int total = 0 ;
        for ( int i = 0 ; i < _iCount ; i++ )
        {
            total = total + _columns[i];
        }
        return total ;
    }
    
}