package org.objectweb.telosys.uil.taglib.todo;

import javax.servlet.http.HttpServletRequest;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.screen.core.ScreenContext;
import org.objectweb.telosys.screen.env.ScreenContextManager;
import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 *  
 */
public class TagUseScreenContext extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sName = null;

    private String _sId   = null;

    public void setName(String v) // Attribute "name"
    {
        _sName = v;
    }

    public void setId(String v) // Attribute "id"
    {
        _sId = v;
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        //JspWriter out = pageContext.getOut();
        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();

        ScreenMap screenMap = getScreenMap();
        
        //--- Screen Name
        if (_sName == null)
        {
            if (screenMap == null)
            {
                tagLibError("useScreenContext : name attribute is null and ScreenMap not found !");
                return (SKIP_BODY);
            }
            else
            {
                _sName = screenMap.getName() ;
            }
        }
        
        //--- Screen Context Id
        int iId = 0 ;
        if (_sId == null)
        {
            if (screenMap == null)
            {
                //--- Use the default screen context Id 
                iId = 0 ;
            }
            else
            {
                iId = screenMap.getScreenContextId() ;
            }
        }
        else
        {
            try
            {
                iId = Integer.parseInt(_sId);
            } catch (NumberFormatException e1)
            {
                tagLibError("useScreenContext : NumberFormatException => check id parameter ");
                return (SKIP_BODY);
            }
        }

        try
        {
            //--- use screen context ( use existing context or open if not found )
            ScreenContext screenContext = ScreenContextManager.useScreenContext(request, _sName, iId);
            String sMsg = "Screen Context ready : " + " name = " + screenContext.getScreenName() 
            		+ ", id = " + iId ;
            		// + ", class = " + screenContext.getScreenClassName();
            tagLibMessage(sMsg);
        } catch (TelosysException e)
        {
            tagLibError("useScreenContext : TelosysException : " + e.getMessage());
        }

        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}