package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.common.TelosysConst;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 * 
 */
public class AjaxRedirect extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sQueryString = null;

    public void setQuerystring(String v) 
    {
        _sQueryString = v; 
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        //JspWriter out = pageContext.getOut();

        String sURI = null ;
        String sQry = null ;
        
        HttpServletRequest request = TagCommons.getHttpServletRequest(pageContext);
        if ( request != null )
        {
            sURI = request.getRequestURI(); 
        }
        
        if ( _sQueryString != null )
        {
            if ( _sQueryString.trim().equalsIgnoreCase("true") ) // Use Query String if any 
            {
                sQry = request.getQueryString();
            }
        }
        
        //--- Build the redirection URI with or without Query String
        String sRedirect = sURI;
        if ( sQry != null )
        {
            if ( sQry.trim().length() > 0 )
            {
                sRedirect = sURI + "?" + sQry.trim() ;
            }
        }
        
        //--- Set the HTTP Header 
        HttpServletResponse response = TagCommons.getHttpServletResponse(pageContext);
        response.setHeader(TelosysConst.TELOSYS_REDIRECT, sRedirect );
        
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}