package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 *  
 */
public class ImportCSS extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sPath = null;

    public void setPath(String v)
    {
        _sPath = v;
    }

    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        if (_sPath != null)
        {
            genTagLink(out, _sPath);
        }
        else
        {
            genCurrentScreenCSS(out);
        }
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
    private void genCurrentScreenCSS(JspWriter out)
    {
        //--- Get the CSS path from the current ScreenMap
        ScreenMap screenMap = getScreenMap();
        if (screenMap != null)
        {
            String sPath = screenMap.getCssPath();
            if (sPath == null)
            {
                tagLibMessage("No CSS for this screen");
            }
            else
            {
                genTagLink(out, sPath);
            }
        }
        else
        {
            tagLibMessage("No Screenmap (no current screen) : cannot get CSS path ");
        }
    }

    //----------------------------------------------------------------
    private void genTagLink(JspWriter out, String sPath)
    {
        print(out, "<link rel=\"stylesheet\" type=\"text/css\" href=\"" + getFullHttpURL(sPath) + "\" />");
    }
}