package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenDefConfig;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class ImportCSSFramework extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    // none

    //----------------------------------------------------------------
    // 
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        //--- Get the server path from config
        ScreenDefConfig config = getConfig(); 
        if (config != null)
        {
            String sPath = config.getFrameworkCSSFile();
            if (sPath == null)
            {
                tagLibError("Cannot get Telosys CSS Path ");
                return (SKIP_BODY);
            }
            generateScriptFileTag(out, sPath);
        }
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
    private void generateScriptFileTag(JspWriter out, String sPath)
    {
        String sFullURL = TagCommons.getFullHttpURL(pageContext, sPath);
        print(out, "<link rel=\"stylesheet\" type=\"text/css\" href=\"" + sFullURL + "\" />");
    }
    //----------------------------------------------------------------
}
