package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 *  
 */
public class ImportJS extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sPath = null;

    public void setPath(String v)
    {
        _sPath = v;
    }

    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        if (_sPath != null)
        {
            genTagScript(out, _sPath);
        }
        else
        {
            genCurrentScreenScript(out);
        }
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
    private void genCurrentScreenScript(JspWriter out)
    {
        //--- Get the CSS path from the current ScreenMap
        ScreenMap screenMap = getScreenMap();
        if (screenMap != null)
        {
            String sPath = screenMap.getScriptPath();
            if (sPath == null)
            {
                tagLibMessage("No JavaScript for this screen");
            }
            else
            {
                genTagScript(out, sPath);
            }
        }
        else
        {
            tagLibMessage("No Screenmap (no current screen) : cannot get Javascript path ");
        }
    }

    //----------------------------------------------------------------
    private void genTagScript(JspWriter out, String sPath)
    {
        print(out, "<script type=\"text/javaScript\" src=\"" + getFullHttpURL(sPath) + "\" ></script>");
    }

}