package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenDefConfig;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class ImportJSFramework extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    // none

    //----------------------------------------------------------------
    // 
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        ScreenDefConfig config = getConfig(); 
        if (config == null)
        {
            return (SKIP_BODY);
        }
        String sPath = config.getFrameworkJavascriptFile();

        if (sPath == null)
        {
            tagLibError("Cannot get Telosys Framework Path ");
            return (SKIP_BODY);
        }

        generateScriptFileTag(out, sPath);

        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
    private void generateScriptFileTag(JspWriter out, String sPath)
    {
        String sFullURL = TagCommons.getFullHttpURL(pageContext, sPath);
        println(out, "<script type=\"text/javaScript\" src=\"" + sFullURL + "\" ></script>");        
    }
    //----------------------------------------------------------------
}