package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.util.NumUtil;

/**
 * @author Laurent GUERIN
 *  
 */
public class Index extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String             _sFormat = null ;

    private String             _sBase = null ;

    public void setFormat(String v)
    {
        this._sFormat = v ; // keep as is            
    }

    public void setBase(String v)
    {
        this._sBase = v;
    }

    private int getBase()
    {
        int iBase = 0;
        if (_sBase != null)
        {
            try
            {
                iBase = Integer.parseInt(_sBase);
            } catch (NumberFormatException ex)
            {
                iBase = 0;
            }
        }
        return iBase;
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        int iIndex = Page.getIterationIndex(pageContext);
        int iBase = getBase();
        iIndex = iIndex + iBase; // Alter the index with the given base

        if ( _sFormat != null )
        {
            print(out, NumUtil.formatInt(iIndex, _sFormat) );
        }
        else
        {
            print(out, ""+iIndex); // No format
        }            
        
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
}