package org.objectweb.telosys.uil.taglib.util;

import java.util.Iterator;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Finder;
import org.objectweb.telosys.uil.taglib.LoopManager;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.util.StrUtil;

/**
 * @author Laurent GUERIN
 *  
 */
public class Iterate extends CommonTagSupport 
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String   _sList    = null;

    private String   _sScope   = null;

    private String   _sIndexbase = null;
    
    private String   _sLoopName  = "iterate"; // v 1.0.1
    
    private String   _sItemName  = null ; // v 1.0.1

    //----------------------------------------------------------------
    public void setList(String v)
    {
        this._sList = v;
    }

    //----------------------------------------------------------------
    public void setScope(String v)
    {
        this._sScope = v;
    }

    //----------------------------------------------------------------
    public void setIndexbase(String v)
    {
        this._sIndexbase = v;
    }
    
    //----------------------------------------------------------------
    public void setLoopname(String v) // v 1.0.1
    {
        this._sLoopName = v;
    }
    //----------------------------------------------------------------
    public void setItemname(String v) // v 1.0.1
    {
        _sItemName = v;
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        //Page.setLoopManager(pageContext, null); // if NULL => remove 
        // v 1.0.1 : do not remove the default LoopManager
        
        if (_sList != null)
        {
            Iterator iter = Finder.findIterator(pageContext, _sList, _sScope);
            //--- Init a loop manager ( with the ITERATOR )
            if ( iter != null )
            {
                int iIndexBase = 0 ;
                if ( _sIndexbase != null )
                {
                    iIndexBase = StrUtil.getInt(_sIndexbase, 0);
                }
                LoopManager loopManager = new LoopManager ( pageContext, iter, iIndexBase );   
                //--- If specific item variable name
                if ( _sItemName != null ) // v 1.0.1
                {
                    loopManager.setItemName( _sItemName ); // v 1.0.1
                }
                
                //--- Set the loop manager in the current page context
                // Page.setLoopManager(pageContext, loopManager);
                Page.setLoopManager(pageContext, _sLoopName, loopManager); // v 1.0.1 use a LoopManager name
                if ( loopManager.first() )
                {
                    return EVAL_BODY_INCLUDE;
                }
            }
            else                
            {
                tagLibMessage("ITERATE : Cannot find iterator ");
            }
        }
        else
        {
            tagLibMessage("ITERATE : No list attribute");
        }
        
        return SKIP_BODY;        
    }

    //----------------------------------------------------------------
    public int doAfterBody()
    {
        //--- Retrieve the LOOP MANAGER
        // LoopManager loopManager = Page.getLoopManager(pageContext) ;   
        LoopManager loopManager = Page.getLoopManager(pageContext, _sLoopName ) ;   // v 1.0.1 use a LoopManager name
        //--- If there's a NEXT ITEM in the loop
        if ( loopManager != null )
        {
            if ( loopManager.next() )
            {
                //--- Another iteration ...
                return EVAL_BODY_AGAIN;
            }
        }

        //--- It's the end ( no other iteration ) 
        return SKIP_BODY;                       
    }
    //----------------------------------------------------------------
}