package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.CurrentBean;
import org.objectweb.telosys.uil.taglib.Finder;
import org.objectweb.telosys.uil.taglib.TagVarSetter;
import org.objectweb.telosys.util.ObjUtil;
import org.objectweb.telosys.util.VarSetter;

/**
 * @author Laurent GUERIN
 *  
 */
public class Out extends CommonTagSupport
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sV       = null; // v 0.9.9
    
    private String _sData    = null;

    private String _sScope   = null;

    private String _sCol     = null;

    private String _sDefault = null;

    private String _sFormat  = null;

    //----------------------------------------------------------------
    public void setV(String v) // v 0.9.9
    {
        if (v != null)
        {
            this._sV = v.trim();
        }
        else
        {
            this._sV = null;
        }
    }

    //----------------------------------------------------------------
    public void setData(String v)
    {
        if (v != null)
        {
            this._sData = v.trim();
        }
        else
        {
            this._sData = null;
        }
    }

    //----------------------------------------------------------------
    public void setScope(String v)
    {
        if (v != null)
        {
            _sScope = v.trim();
        }
        else
        {
            _sScope = null;
        }
    }

    //----------------------------------------------------------------
    public void setCol(String v)
    {
        if (v != null)
        {
            this._sCol = v.trim();
        }
        else
        {
            this._sCol = null;
        }
    }

    //----------------------------------------------------------------
    public void setDefault(String v)
    {
        this._sDefault = v; // keep as is
    }

    //----------------------------------------------------------------
    public void setFormat(String v)
    {
        this._sFormat = v; // keep as is
    }

    //----------------------------------------------------------------

    //----------------------------------------------------------------
    private void printObjectValue(JspWriter out, Object oValue)
    {
        if (oValue != null)
        {
            if (_sFormat != null)
            {
                //--- Format the value
                print(out, ObjUtil.format(oValue, _sFormat) );
            }
            else
            {
                //--- No format => value as is
                print(out, oValue.toString()); 
            }
        }
        else
        {
            if (_sDefault != null)
            {
                print(out, _sDefault);
            }
            else
            {
                print(out, "");
            }
        }
    }
    //----------------------------------------------------------------


    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        if (_sV != null) // v 0.9.9
        {
            VarSetter varSetter = new TagVarSetter( pageContext ); 
            String s = varSetter.replaceVar(_sV);
            if ( s != null )
            {
                print(out, s); 
            }
            else
            {
                print(out, ( _sDefault != null ? _sDefault : "" ) );
            }
        }
        else if (_sData != null)
        {
            //--- Print the attribute value of the given data attribute "bean.attr", ".attr"
            printObjectValue(out, Finder.findAttributeValue(pageContext, _sData, _sScope) );
        }
        else if (_sCol != null)
        {
            //--- Print the column value of the "current bean"
            printObjectValue(out, CurrentBean.getColumn(pageContext, _sCol) );
        }
        else
        {
            print(out, "(?)");
        }

        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
}