package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class Text extends CommonTagSupport
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sKey = null;

    private String _sTxt = null;

    //----------------------------------------------------------------
    // "txt" attribute
    //----------------------------------------------------------------
    /**
     * Set the "txt" attribute value
     * 
     * @param v
     */
    public void setTxt(String v)
    {
        _sTxt = v;
    }

    /**
     * Returns the "txt" attribute value with translation if necessary
     * 
     * @return
     */
    public String getTxt()
    {
        return TagCommons.getTranslatedTxt(_sTxt, _sKey, pageContext);

        //        //--- Apply the symbolic variables replacement
        //        return replaceSymbolicVar(sText);
    }

    //----------------------------------------------------------------
    // "key" attribute
    //----------------------------------------------------------------
    public void setKey(String v)
    {
        _sKey = v;
        if (v != null)
        {
            _sKey = v.trim();
        }
    }

    public String getKey()
    {
        return _sKey;
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        String sTxt = getTxt();
        if (sTxt != null)
        {
            print(out, sTxt);
        }
        else
        {
            print(out, "(?)");
        }

        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
}