package org.objectweb.telosys.uil.taglib.util;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.CurrentBean;
import org.objectweb.telosys.uil.taglib.Finder;

/**
 * @author Laurent GUERIN
 *  
 */
public class With extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String             _sBean = null ;

    private String             _sScope = null ;

    private String             _sWithout = null ;

    //----------------------------------------------------------------
    public void setBean(String v)
    {
        this._sBean = v;
    }

    public void setScope(String v)
    {
        this._sScope = v;
    }

    public void setWithout(String v)
    {
        this._sWithout = v;
    }

    //----------------------------------------------------------------
    
    private boolean setCurrentBean()
    {
        if (_sBean == null)
        {
            tagLibMessage("Error : no bean attribute");
            return false;
        }
        else
        {
            Object oBean = Finder.findObject(pageContext, _sBean, _sScope);            
            if (oBean != null)
            {
                //--- Found => set as current bean
                //Page.setCurrentBean(pageContext, oBean); // v 0.9.9
                CurrentBean.setBean(pageContext, oBean); // v 0.9.9
                return true;
            }
            else
            {
                //--- Not found => no current bean
                //Page.clearCurrentBean(pageContext); // v 0.9.9
                CurrentBean.clearBean(pageContext); // v 0.9.9
                tagLibMessage("Cannot get bean ('" + _sBean + "' not found)");
                return false;
            }
        }
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public int doStartTag()
    {
// v 0.9.9
//        setCurrentBean();
//        return (EVAL_BODY_INCLUDE);

        //--- v 0.9.9
        if (setCurrentBean())
        {
            //--- Bean found and set as "current bean" ( "with bean" status )
            return EVAL_BODY_INCLUDE;
        }
        else
        {
            //--- Bean not found ( "without bean" status ) 
            if ( _sWithout != null )
            {
                if ( _sWithout.trim().equalsIgnoreCase("process") )
                {
                    // Bean not found, but without="process" => process anyway
                    return EVAL_BODY_INCLUDE;
                }
            }
        }
        // Other cases => DO NOT PROCESS
        return SKIP_BODY;            
    }

    //----------------------------------------------------------------
    public int doEndTag()
    {
        //Page.clearCurrentBean(pageContext); // v 0.9.9
        CurrentBean.clearBean(pageContext); // v 0.9.9
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
//    //----------------------------------------------------------------
//    public int doAfterBody()
//    {
//        System.out.println("Iterate : doAfterBody() ");
//        if (nextItem())
//        {
//            return EVAL_BODY_AGAIN;
//        }
//        return SKIP_BODY;
//    }
//    //----------------------------------------------------------------
}