package org.objectweb.telosys.uil.taglib.util;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Finder;

/**
 * @author Laurent GUERIN
 *  
 */
public class Without extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String             _sBean = null ;

    private String             _sScope = null ;

    public void setBean(String v)
    {
        this._sBean = v;
    }

    public void setScope(String v)
    {
        this._sScope = v;
    }

    //----------------------------------------------------------------
    
    private boolean isBeanExist()
    {
        if (_sBean != null)
        {
            Object oBean = Finder.findObject(pageContext, _sBean, _sScope);
            if (oBean != null)
            {
                //--- Found 
                return true;
            }
        }
        else
        {
            tagLibMessage("Error : no bean attribute");
        }
        //--- Not found 
        return false;
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public int doStartTag()
    {
        if ( isBeanExist() )
        {
            //--- Bean exist = NOT "without bean" => DO NOT eval body
            return SKIP_BODY;            
        }
        else
        {
            //--- No bean = "without bean" => eval body
            return EVAL_BODY_INCLUDE;
        }
    }
    //----------------------------------------------------------------
    public int doEndTag()
    {
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}