package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ButtonHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ButtonXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Button extends GenericTag
{
    protected static final String TAG_NAME = "button";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new ButtonHTML();

    private final static IWidget  $xulGen  = new ButtonXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
//    private String                _sTxt    = "xxx";

    private String                _sImgSrc = null;            // Image ( with full source path )

    private String                _sImg    = null;            // Image ( in context standard path )

    private String                _sImgPos = "left";

    private String                _sAlign  = "middle";

    private String                _sSpacer = "4";

    private String                _sType  = null ; // v 0.9.9 ( "submit", "reset", "button" )

//    private String                _sName  = null ; // v 0.9.9 ( for SUBMIT ) in GenericTag

    private String                _sValue = null ; // v 0.9.9 ( for SUBMIT )
    
    /**
     * Constructor
     */
    public Button()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setType(String v) // v 0.9.9
    {
        _sType = v;
    }

    public String getType() // v 0.9.9
    {
        return replaceSymbolicVar(_sType);        
    }

    //----------------------------------------------------------------
    public void setValue(String v) // v 0.9.9
    {
        _sValue = v;
    }

    public String getValue() // v 0.9.9
    {
        return replaceSymbolicVar(_sValue);        
    }

    //----------------------------------------------------------------
    public void setImgsrc(String v)
    {
        _sImgSrc = v;
    }

    //----------------------------------------------------------------
    public void setImg(String v)
    {
        _sImg = v;
    }

    public String getFullImageSrc()
    {
        if (notVoid(_sImgSrc))
        {
            return _sImgSrc.trim();
        }
        else if (notVoid(_sImg))
        {
            return super.getFullImageSrc(_sImg);
        }
        else
        {
            return null;
        }
    }

    //----------------------------------------------------------------
    public void setImgpos(String v)
    {
        _sImgPos = v;
    }

    public String getImgpos()
    {
        return _sImgPos;
    }

    //----------------------------------------------------------------
    public void setSpacer(String v)
    {
        _sSpacer = v;
    }

    public void setSpacer(int v)
    {
        _sSpacer = "" + v;
    }

    public String getSpacer()
    {
        return _sSpacer;
    }

    //----------------------------------------------------------------
    public void setAlign(String v)
    {
        _sAlign = v;
    }
    public String getAlign()
    {
        if ( _sAlign != null )
        {
            return _sAlign.trim() ;            
        }
        else
        {
            return "middle" ;
        }
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}