package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ComboBoxHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ComboBoxXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class ComboBox extends GenericPostbackTag implements ItemsContainer 
{
    private static final String TAG_NAME = "combobox";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen  = new ComboBoxHTML();

    private final static IWidget  $xulGen   = new ComboBoxXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public ComboBox()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
//  moved in super class ( v 0.9.8 )
//    public String getValue() // Overrides the standard method to use POSTBACK
//    {
//        trace("getValue()...");
//        String sValue = getValueWithPostback();
//        trace("getValue() : return " + sValue );
//        return sValue;
//    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();        
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();        
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}