package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ContainerHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ContainerXUL;


/**
 * @author Laurent GUERIN
 *  
 */
public class Container extends GenericTag
{
    private static final String  TAG_NAME = "container";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new ContainerHTML();

    private final static IWidget $xulGen  = new ContainerXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    
    private String               _sView      = null;

    private String               _sRenderer      = null;

    private String               _sOnPopulate    = null;

    /**
     * Constructor
     */
    public Container()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }
    
    //----------------------------------------------------------------
    public void setView(String v)
    {
        _sView = v;
    }

    public String getView()
    {
        return _sView;
    }

    //----------------------------------------------------------------
    public void setRenderer(String v)
    {
        _sRenderer = v;
    }

    public String getRenderer()
    {
        return _sRenderer;
    }

    //----------------------------------------------------------------
    public void setOnpopulate(String v)
    {
        _sOnPopulate = v;
    }

    public String getOnpopulate()
    {
        return _sOnPopulate;
    }

    //----------------------------------------------------------------
    // Open TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Close TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
