package org.objectweb.telosys.uil.taglib.widget;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class Debug extends TagSupport
{
    //----------------------------------------------------------------
    // Constants
    //----------------------------------------------------------------
    private static final String TAG_NAME = "debug";

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String              _sAction = null;

    /**
     * Set "action" attribute
     * 
     * @param v
     */
    public void setAction(String v)
    {
        _sAction = v;
    }

    //----------------------------------------------------------------
    // Tag processing
    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        try
        {
            out.println("<!-- debug (" + _sAction + ") : ");
            if (_sAction.equalsIgnoreCase("list_variables"))
            {
                //--- List the declared variables
                Variables variables = Variables.getVariables(pageContext, false);
                if (variables != null)
                {
                    variables.print(out);
                }
                else
                {
                    out.println(" ( no current Variables instance )");
                }
            }
            if (_sAction.equalsIgnoreCase("list_defaults"))
            {
                //--- List the default attributes values
                TagScreenEnv screenEnv = TagCommons.getScreenEnv(pageContext);
                if (screenEnv != null)
                {
                    screenEnv.printDefaults(out);
                }
                else
                {
                    TagCommons.printError(pageContext, "DEBUG - ERROR : Cannot get TagScreenEnv !");
                }
            }
            out.println("-->");
        } catch (IOException ioex)
        {
            ioex.printStackTrace();
        }
        return (SKIP_BODY);
    }
}