package org.objectweb.telosys.uil.taglib.widget;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class Default extends TagSupport
{
    private static final String TAG_NAME   = "default";

    private String              _sTag      = null;

    //--- The attributes accepting default values
    private String              _sCl       = null;

    private String              _sStyle    = null;

    private String              _sDisabled = null;

    private String              _sReadonly = null;

    private String              _sZone     = null;

    public void setTag(String v)
    {
        _sTag = v;
    }

    public void setCl(String v)
    {
        _sCl = v;
    }

    public void setStyle(String v)
    {
        _sStyle = v;
    }

//    public void setDisabled(boolean v)
//    {
//        _sDisabled = "" + v;
//    }

    public void setDisabled(String v)
    {
        _sDisabled = v;
    }

    public void setReadonly(boolean v)
    {
        _sReadonly = "" + v;
    }

    public void setReadonly(String v)
    {
        _sReadonly = v;
    }

    public void setZone(String v)
    {
        _sZone = v;
    }

    private void trace(JspWriter out, String s)
    {
        try
        {
            out.println("<!-- default : " + s + " -->");
        } catch (IOException e)
        {
            // Nothing to do
        }
    }

    public int doStartTag()
    {
        if (_sTag != null)
        {
            JspWriter out = pageContext.getOut();

            TagScreenEnv screenEnv = TagCommons.getScreenEnv(pageContext);
//            if (_sCl != null)
//            {
//                screenEnv.setDefaultAttributeValue(_sTag, "cl", _sCl);
//                trace(out, "cl = '" + _sCl + "'");
//            }
            processAttribute(out, screenEnv, "cl", _sCl );
            
//            if (_sStyle != null)
//            {
//                screenEnv.setDefaultAttributeValue(_sTag, "style", _sStyle);
//                trace(out, "style = '" + _sStyle + "'");
//            }
            processAttribute(out, screenEnv, "style", _sStyle );
//            if (_sDisabled != null)
//            {
//                screenEnv.setDefaultAttributeValue(_sTag, "disabled", _sDisabled);
//                trace(out, "disabled = '" + _sDisabled + "'");
//            }
            processAttribute(out, screenEnv, "disabled", _sDisabled );
            
//            if (_sReadonly != null)
//            {
//                screenEnv.setDefaultAttributeValue(_sTag, "readonly", _sReadonly);
//                trace(out, "readonly = '" + _sReadonly + "'");
//            }
            processAttribute(out, screenEnv, "readonly", _sReadonly );
//            if (_sZone != null)
//            {
//                if ( _sZone.length() == 0 )
//                {
//                    screenEnv.resetDefaultAttributeValue(_sTag, "zone") ;
//                }
//                else
//                {
//                    screenEnv.setDefaultAttributeValue(_sTag, "zone", _sZone);
//                    trace(out, "zone = '" + _sZone + "'");                
//                }
//            }
            processAttribute(out, screenEnv, "zone", _sZone );
        }
        return (SKIP_BODY);
    }
    
    public void processAttribute( JspWriter out, TagScreenEnv screenEnv, String sAttributeName, String sDefaultValue )
    {
        if ( sDefaultValue != null)
        {
            if ( sDefaultValue.length() == 0 )
            {
                //--- Reset the standard behavior ( Remove the default value if any )
                screenEnv.resetDefaultAttributeValue(_sTag, sAttributeName) ;
                trace(out, "RESET : " + _sTag + "." + sAttributeName );                
            }
            else
            {
                //--- Set the default value 
                screenEnv.setDefaultAttributeValue(_sTag, sAttributeName, sDefaultValue);
                trace(out, "SET DEFAUT VALUE : " + _sTag + "." + sAttributeName + " = '" + sDefaultValue + "'");                
            }
        }
        // else : not set in the current tag use => nothing to do 
    }
}