package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.HiddenHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.HiddenXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Hidden extends GenericTag
{
    private static final String  TAG_NAME = "hidden";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new HiddenHTML();

    private final static IWidget $xulGen  = new HiddenXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String               _sValue  = null;

    //----------------------------------------------------------------
    /**
     * Constructor
     */
    public Hidden()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setValue(String v)
    {
        _sValue = v;
    }
    public String getValue()
    {
        //return _sValue ;
        //--- Use the current tag value and try to replace the "symbolic var names" if any
        return replaceSymbolicVar(_sValue); // v 0.9.9
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();        
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}