/*
 * Created on 27 juin 2005
 *
 */
package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.TagCommons;
import org.objectweb.telosys.uil.taglib.widget.html.LinkHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.LinkXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Link extends GenericTag
{
    private static final String TAG_NAME = "link";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new LinkHTML();

    private final static IWidget $xulGen  = new LinkXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

//    private String              _sTxt     = null;

    private String              _sHref    = null;

    private String              _sCres    = null;

    private String              _sTarget  = null;

    /**
     * Constructor
     */
    public Link()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
//    public void setTxt(String v) 
//    {
//        _sTxt = v;
//    }
    public String getTxtOrRef() // New in v 0.9.8
    {
        //String sTxt = _sTxt ;
        String sTxt = getTxt()  ;
        if ( sTxt == null ) // still null ?
        {
            //sTxt = _sHref ;
            sTxt = getHref() ; // v 0.9.9
        }
        if ( sTxt == null ) // still null ?
        {
            //sTxt = _sCres ;
            sTxt = getCres() ; // v 0.9.9
        }
        return sTxt ;
    }

    //----------------------------------------------------------------
    public void setHref(String v) 
    {
        _sHref = v;
    }
    public String getHref() 
    {
        //return _sHref;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sHref);  // v 0.9.9
        
    }

    //----------------------------------------------------------------
    public void setCres(String v) 
    {
        _sCres = v;
    }
    public String getCres() 
    {
        //return _sCres;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sCres);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setTarget(String v) 
    {
        _sTarget = v;
    }
    public String getTarget() 
    {
        //return _sTarget;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sTarget);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        //return (SKIP_BODY);
        return (EVAL_BODY_INCLUDE); // v 0.9.9
    }
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
    public String getFullContextRef()
    {
        String s = getCres(); // v 0.9.9
        if (s != null)
        {
            String sCref = s.trim();
            //--- Remove the starting "/" if any
            if ( sCref.startsWith("/") )
            {
                sCref = sCref.substring(1);
            }
            return TagCommons.getRootContextURL(pageContext) + "/" + sCref;
        }
        else
        {
            return "";
        }
    }
}