/*
 * Created on 27 juin 2005
 *
 */
package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.http.HttpServletRequest;

import org.objectweb.telosys.uil.taglib.widget.html.LinkScreenHTML;
import org.objectweb.telosys.util.web.ScreenURI;

/**
 * @author Laurent GUERIN
 *  
 */
public class LinkScreen extends GenericTag
{
    private static final String TAG_NAME = "link_screen";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new LinkScreenHTML();

    private final static IWidget $xulGen  = null ; // new LinkScreenXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String              _sScreenName    = null;

    private String              _sScreenType    = null;

    private String              _sContextId     = null;
    
    private String              _sContextName   = null;
    
    private String              _sContextAction = null;
    
    private String              _sParams        = null;
    

    private String              _sTarget        = null;

    /**
     * Constructor
     */
    public LinkScreen()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setScreenname(String v) 
    {
        _sScreenName = v;
    }
    public String getScreenname() 
    {
        //return _sScreenName;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sScreenName);  // v 0.9.9
        
    }

    //----------------------------------------------------------------
    public void setScreentype(String v) 
    {
        _sScreenType = v;
    }
    public String getScreentype() 
    {
        //return _sScreenType;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sScreenType);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setContextname(String v) 
    {
        _sContextName = v;
    }
    public String getContextname() 
    {
        //return _sContextName;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sContextName);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setContextid(String v) 
    {
        _sContextId = v;
    }
    public String getContextid() 
    {
        //return _sContextId;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sContextId);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setContextaction(String v) 
    {
        _sContextAction = v;
    }
    public String getContextaction() 
    {
        //return _sContextAction;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sContextAction);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setParams(String v) 
    {
        _sParams = v;
    }
    public String getParams() 
    {
        //return _sParams;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sParams);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public void setTarget(String v) 
    {
        _sTarget = v;
    }
    public String getTarget() 
    {
        //return _sTarget;
        //--- Apply the symbolic variables replacement  
        return replaceSymbolicVar(_sTarget);  // v 0.9.9
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        // return (SKIP_BODY);
//        // v 0.9.9 : EVAL_BODY_INCLUDE if no text
//        if ( getTxt() != null )
//        {
//            //--- The TEXT has been used as TAG CONTENT => Stop here
//            return (SKIP_BODY);
//        }
//        else
//        {
//            //--- No TEXT => Eval the included code if any 
//            return (EVAL_BODY_INCLUDE);
//        }        
        // Always eval body
        return (EVAL_BODY_INCLUDE); // v 0.9.9

    }

    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
    //----------------------------------------------------------------
    public String getLinkURL()
    {
//        return TagCommons.getScreenMapURL(pageContext, _sScreenName, _sScreenType, _sContextId, _sContextName, 
//                _sContextAction, _sParams); 
        
//        ScreenURI uri = new ScreenURI(_sScreenName, _sScreenType, _sContextId, _sContextName, 
//                _sContextAction, _sParams);
        ScreenURI uri = new ScreenURI(getScreenname(), getScreentype(), getContextid(), getContextname(), 
                getContextaction(), getParams()); // v 0.9.9
        HttpServletRequest req = ( HttpServletRequest ) pageContext.getRequest() ;
        return uri.getFullURL(req) ;
        
    }
}