package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ListRowHTML;

/**
 * @author Laurent GUERIN
 *  
 */
public class ListRow extends GenericTag
{
    protected static final String TAG_NAME = "listrow";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new ListRowHTML();

    private final static IWidget  $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String                _sOverfying  = "true";

    private String                _sSelectable  = "true";

    private String                _sOnSelection  = null ;

    /**
     * Constructor
     */
    public ListRow()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }
    
    //----------------------------------------------------------------
    public void setOverflying(String v)
    {
        _sOverfying = ( v != null ? v.trim() : null ) ; 
    }
    public void setOverflying(boolean bFlag)
    {
        _sOverfying = (bFlag == true ? "true" : "false" ) ;
    }
    public String getOverflying()
    {
        return _sOverfying ;
    }
    public boolean isOverflying()
    {
        if (_sOverfying != null)
        {
            if (_sOverfying.equalsIgnoreCase("true"))
            {
                return true;
            }
        }
        return false;        
    }
    
    //----------------------------------------------------------------
    public void setSelectable(String v)
    {
        _sSelectable = ( v != null ? v.trim() : null ) ; 
    }
    public void setSelectable(boolean bFlag)
    {
        _sSelectable = (bFlag == true ? "true" : "false" ) ;
    }
    public String getSelectable()
    {
        return _sSelectable ;
    }
    public boolean isSelectable()
    {
        if (_sSelectable != null)
        {
            if (_sSelectable.equalsIgnoreCase("true"))
            {
                return true;
            }
        }
        return false;        
    }
    //----------------------------------------------------------------
    public void setOnelection(String v)
    {
        _sOnSelection = v ; 
    }
    public String getOnselection()
    {
        return _sOnSelection ;
    }
    
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
//        applyDefaults();
//        Page.initTabIndex(pageContext);        
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
//        reset();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
