package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.data.MenuItems;
import org.objectweb.telosys.uil.taglib.widget.html.MenuBoxHTML;

/**
 * @author Laurent GUERIN
 *  
 */
public class MenuBoxTAG extends GenericTag
{
    private static final String  TAG_NAME = "menubox";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new MenuBoxHTML();

    private final static IWidget $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public MenuBoxTAG()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
        setIdGeneration(true); // Automatic ID generation (if ID not set by user)        
    }

    //----------------------------------------------------------------
    public MenuItems getMenuItems()
    {
        return Page.getCurrentMenuItems(this.getPageContext());
    }
    
    //----------------------------------------------------------------
// Set in "telosys.css"
//    private void applyDefaults()
//    {
//        if ( this.getWidth() == null )
//        {
//            this.setWidth(260);
//        }
//    }
    //----------------------------------------------------------------
    // Open TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        //applyDefaults();
        // No output generation at this level, but startTag() must be called for tag init
        startTag(NO_OUTPUT);
        
        //MenuBox menu = new MenuBox( this.getId(), this.getCl(), this.getStyle(), this.getWidth() );
        //--- New "Menu Items List" for inner "menuitem" tags  
        MenuItems menuItems = new MenuItems();
        Page.setCurrentMenuItems(this.getPageContext(), menuItems);
        
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Close TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag(); // Generate ALL The MENUBOX

        //--- Remove the "Menu Items List"   
        Page.setCurrentMenuItems(this.getPageContext(), null);
        
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
}
