package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.data.MenuItem;
import org.objectweb.telosys.uil.taglib.widget.data.MenuItems;

/**
 * @author Laurent GUERIN
 *  
 */
public class MenuItemTAG extends GenericTag
{
    private static final String  TAG_NAME = "menuitem";

    //----------------------------------------------------------------
    // TAG generators : NO TAG GENERATORS ( just use to store item in memory )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = null;

    private final static IWidget $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    private String              _sImg     = null;            // Image ( in context standard path )

    private String              _sHref    = null;

    private String              _sCres    = null;

    private String              _sScreen  = null;
    
    private String              _sParam   = null;
    
    private String              _sMenubox = null;
    
    private String              _sSeparator = null ;
    
    /**
     * Constructor
     */
    public MenuItemTAG()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
        setIdGeneration(true); // Automatic ID generation (if ID not set by user)        
    }

    //----------------------------------------------------------------
    public void setImg(String v)
    {
        _sImg = v;
    }
    public String getImg() 
    {
        return _sImg;
    }
    
    //----------------------------------------------------------------
    public void setHref(String v) 
    {
        _sHref = v;
    }
    public String getHref() 
    {
        return _sHref;
    }

    //----------------------------------------------------------------
    public void setCres(String v) 
    {
        _sCres = v;
    }
    public String getCres() 
    {
        return _sCres;
    }

    //----------------------------------------------------------------
    public void setScreen(String v) 
    {
        _sScreen = v;
    }
    public String getScreen() 
    {
        return _sScreen;
    }

    //----------------------------------------------------------------
    public void setParam(String v) 
    {
        _sParam = v;
    }
    public String getParam() 
    {
        return _sParam;
    }

    //----------------------------------------------------------------
    public void setMenubox(String v) 
    {
        _sMenubox = v;
    }
    public String getMenubox() 
    {
        return _sMenubox;
    }

    //----------------------------------------------------------------
    public void setSeparator(String v) 
    {
        _sSeparator = v;
    }
    public String getSeparator() 
    {
        return _sSeparator ;
    }
    public void setSeparator(boolean bFlag)
    {
        _sSeparator = (bFlag == true ? "true" : "false" ) ;
    }
    public boolean isSeparator() 
    {
        if ( _sSeparator != null )
        {
            return _sSeparator.trim().toLowerCase().equals("true");
        }
        return false ;
    }


    //----------------------------------------------------------------
//    private MenuBoxTAG getParentMenuBox()
//    {
//        Tag tagParent = this.getParent();
//        if (tagParent != null)
//        {
//            if (tagParent instanceof MenuBoxTAG )
//            {
//                return (MenuBoxTAG) tagParent;
//            }
//        }
//        return null;
//    }

    //----------------------------------------------------------------
    // Open TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        // No output generation at this level, but startTag() must be called for tag init
        startTag(NO_OUTPUT);
        
        //--- Add a new item in the menu items list ...
        MenuItem item = null ;
        if ( this.isSeparator() )
        {
            item = new MenuItem();
        }
        else
        {
            item = new MenuItem( this.getId(), this.getImg(), this.getTxt() );
            item.setOnclick( this.getEvent(Event.ON_CLICK));
            item.setCres(this.getCres());
            item.setHref(this.getHref());
            item.setScreen(this.getScreen());
            item.setParam(this.getParam());
            item.setMenuBoxId(this.getMenubox());
        }
        
        MenuItems menuItems = Page.getCurrentMenuItems(this.getPageContext());
        if ( menuItems != null )
        {
            menuItems.addItem(item);
        }
        else
        {
            error("Page.getCurrentMenuItems() returns NULL ");
        }
        
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
    // Close TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        // No output generation at the tag level
        // endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
    //----------------------------------------------------------------
}
