package org.objectweb.telosys.uil.taglib.widget;

import java.util.LinkedList;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.html.RadioGroupHTML;

/**
 * @author Laurent GUERIN
 *  
 */
public class RadioGroup extends GenericPostbackTag implements ItemsContainer 
{
    private static final String  TAG_NAME = "radiogroup";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget htmlGen  = new RadioGroupHTML();

    private final static IWidget xulGen   = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public RadioGroup()
    {
        super(TAG_NAME, htmlGen, xulGen);
    }

    //----------------------------------------------------------------
//  moved in super class ( v 0.9.8 )
//    public String getValue() // Overrides the standard method to use POSTBACK
//    {
//        trace("getValue()...");
//        String sValue = getValueWithPostback();
//        trace("getValue() : return " + sValue );
//        return sValue;
//    }
    
    /**
     * Returns the nested radio items Ids of the current radio group<br>
     * To be used at the end (because it is populated on the fly, by each radio item tag)  
     * @return
     */
    public LinkedList getRadioItemsId() 
    {
        return Page.getRadioItems(pageContext, this.getId() ) ;
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
        Page.clearRadioItems( pageContext, this.getId() ) ;
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}