package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.SpinEditHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.SpinEditXUL;

/**
 * @author Aurelien COUERON
 *  
 */
public class SpinEdit extends GenericPostbackTag // GenericTag
{
    private static final String  TAG_NAME       = "spinedit";


    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen       = new SpinEditHTML();

    private final static IWidget $xulGen        = new SpinEditXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String               _sMaxLength    = null;

    private String               _sSize         = null;

    private String               _sStep         = "1";

    private String               _sDigit       	= "0";

    private String               _sMin          = null;

    private String               _sMax          = null;

    /**
     * Constructor
     */
    public SpinEdit()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setSize(String v)
    {
        _sSize = v;
    }

    public void setSize(int v)
    {
        _sSize = "" + v;
    }

    public String getSize()
    {
        return _sSize;
    }

    //----------------------------------------------------------------
    public void setMaxlength(String v)
    {
        _sMaxLength = v;
    }

    public void setMaxlength(int v)
    {
        _sMaxLength = "" + v;
    }

    public String getMaxlength()
    {
        return _sMaxLength;
    }

    //----------------------------------------------------------------
    public void setStep(String v)
    {
        _sStep = v;
    }

    public void setStep(int v)
    {
        _sStep = "" + v;
    }

    public String getStep()
    {
        return _sStep;
    }

    //----------------------------------------------------------------
    public void setDigit(String v)
    {
        _sDigit = v;
    }

    public void setDigit(int v)
    {
        _sDigit = "" + v;
    }

    public String getDigit()
    {
        return _sDigit;
    }
    
    //----------------------------------------------------------------
    public void setMin(String v)
    {
        _sMin = v;
    }

    public void setMin(int v)
    {
        _sMin = "" + v;
    }

    public void setMin(double v)
    {
        _sMin = "" + v;
    }

    public String getMin()
    {
        return _sMin;
    }

    //----------------------------------------------------------------
    public void setMax(String v)
    {
        _sMax = v;
    }

    public void setMax(int v)
    {
        _sMax = "" + v;
    }

    public void setMax(double v)
    {
        _sMax = "" + v;
    }

    public String getMax()
    {
        return _sMax;
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }

    //----------------------------------------------------------------
    public String getOnKeyPressEvent()
    {
        return "return fwkFilter(event,this,'NUM:+-')" ;
    }
    //----------------------------------------------------------------
    public String getOnBlurEvent()
    {
        //String sCanBeNull = (_bRequired == true ? "false" : "true");
        String sCanBeNull = "true" ;

        //String sFormat = (_sFormat == null ? "null" : "'" + _sFormat + "'"); // null or 'format'
        String sFormat = "null" ; // null or 'format'
        
        String sMin = (_sMin == null ? "null" : _sMin);
        String sMax = (_sMax == null ? "null" : _sMax);
        return "fwkCheckField(this," + sCanBeNull + ",'NUM'," + sMin + "," + sMax + "," + sFormat + ")";
    }
}