package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.html.TabBoxHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.TabBoxXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class TabBox extends GenericTag
{
    protected static final String TAG_NAME = "tabbox";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new TabBoxHTML();

    private final static IWidget  $xulGen  = new TabBoxXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    //private String                _sAlign    = null ;

    /**
     * Constructor
     */
    public TabBox()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }
    
    //----------------------------------------------------------------
//    public void setAlign(String v) 
//    {
//        _sAlign = v;
//    }
//    public String getAlign() 
//    {
//        return _sAlign ;
//    }
    
    //----------------------------------------------------------------
    public String getSelectedTabId()
    {
        return Page.getSelectedTabId(pageContext);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        Page.clearSelectedTabId(pageContext);
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
        Page.clearSelectedTabId(pageContext);
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}