package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.Finder;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.data.TreeViewNode;


/**
 * @author Aurelien COUERON
 *  
 */
public class TreeNodes extends GenericTag 
{
    private static final String TAG_NAME = "treenodes";

    //----------------------------------------------------------------
    // TAG generators : NO TAG GENERATORS ( just use to set the tree in memory )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen  = null;

    private final static IWidget  $xulGen   = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    
    private String              _sScope   = null ;

    //----------------------------------------------------------------
//    /**
//     * Constructor
//     */
//    public TreeNodes(String sTagName)
//    {
//        super(sTagName, null, null);
//    }
    
    /**
     * Constructor
     */
    public TreeNodes()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setScope(String v)
    {
        _sScope = v;
    }
    public String getScope()
    {
        return _sScope ;
    }

    //----------------------------------------------------------------
    // Opening TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        // No output generation at the tag level, but startTag() must be called for tag init
        startTag(NO_OUTPUT);
        
        //out.println("<!-- TreeNodes : data='" + sData + "' scope='" + sScope + "' -->");
        
        TreeViewNode rootNode = getTree( this.getPageContext(), this.getData(), this.getScope() ) ;
        if ( rootNode != null ) 
        {
            //out.println("<!-- TreeNodes : tree found : HTML generation -->");
            //--- Set the "root node"  
            Page.setRootNode(this.getPageContext(), rootNode);
        }
        else
        {
            //out.println("<!-- TreeNodes : tree not found -->");
        }
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Closing TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        // No output generation at the tag level
        // endTag();
        
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
    //----------------------------------------------------------------
    private TreeViewNode getTree( PageContext pageContext, String sDataName, String sScope ) 
    {
        Object obj = Finder.findObject(pageContext, sDataName, sScope);
        if ( obj instanceof TreeViewNode )
        {
            return (TreeViewNode) obj;
        }
        return null ;
    }
}