package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.TreeViewHTML;

/**
 * @author Aurelien COUERON
 *  
 */
public class TreeView extends GenericTag
{
    private static final String  TAG_NAME = "treeview";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new TreeViewHTML();

    private final static IWidget $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    
    private String               _sDnd       = "yes";

    /**
     * Constructor
     */
    public TreeView()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
        setIdGeneration(true); // Automatic ID generation (if ID not set by user)        
    }

    //----------------------------------------------------------------
    public void setDnd(String v)
    {
        _sDnd = v != null ? v.trim() : v ;
    }

    public String getDnd()
    {
        return _sDnd;
    }

    //----------------------------------------------------------------
    // Opening TAG 
    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Closing TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
}
