package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.tagext.TagSupport;

import org.objectweb.telosys.uil.taglib.TagCommons;



/**
 * @author T. Poingt, L. Guerin
 * 
 */
public class Unset extends TagSupport
{
    private String              _sVarName  = null ;
    
    private String              _sScope    = null ;
    

    /**
     * Set "var" attribute
     * 
     * @param v
     */
    public void setVar(String v)
    {
        _sVarName = v;
    }

    /**
     * Set "scope" attribute
     * 
     * @param v
     */
    public void setScope(String v)
    {
        _sScope = v;
    }

    //----------------------------------------------------------------
    // Tag processing
    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        if ( _sVarName != null )
        {
            if ( _sScope != null )
            {
                // SCOPE SPECIFIED
                // Remove the variable from "page", "request", "session" or "application" scope
                int iScope = TagCommons.getScope( _sScope );
    	        pageContext.removeAttribute( _sVarName, iScope );
            }
            else
            {
                // NO SCOPE => use Telosys Variables
	            Variables variables = Variables.getVariables(pageContext, false);
	            if ( variables != null )
	            {
	                variables.unset( _sVarName ) ;
	            }
            }
        }
        else
        {
            TagCommons.printError(pageContext, "UNSET : Variable name is null !");            
        }
        return (SKIP_BODY);
    }

}