package org.objectweb.telosys.uil.taglib.widget.data;

import java.util.Iterator;
import java.util.LinkedList;

/**
 * List of "MenuItem" objects
 * @author Laurent GUERIN
 * 
 */
public class MenuItems 
{
    //--- The list  
    private LinkedList _items = new LinkedList() ; // list of "MenuItem" objects 

    //----------------------------------------------------------------------------------------
    // Constructors
    //----------------------------------------------------------------------------------------
    /**
     * Constructor
     */
    public MenuItems () 
    {
        super();
    }
    
    //----------------------------------------------------------------------------------------
    // Items management
    //----------------------------------------------------------------------------------------    
    public LinkedList getItems() 
    {
        return _items;
    }
    
    //----------------------------------------------------------------------------------------
    public boolean isEmpty() 
    {
        return _items.isEmpty() ;
    }

    //----------------------------------------------------------------------------------------
    public int size() 
    {
        return _items.size() ;
    }

    //----------------------------------------------------------------------------------------
    public Iterator iterator() 
    {
        return _items.iterator() ;
    }

    //----------------------------------------------------------------------------------------    
    /**
     * Appends an item in the menu
     * @param item
     * @return
     */
    public boolean addItem( MenuItem item ) 
    {
        return _items.add(item);
    }
    
    //----------------------------------------------------------------------------------------    
    /**
     * Appends a separator
     * @return
     */
    public boolean addSeparator() 
    {
        return _items.add(new MenuItem());
    }
    
//    //----------------------------------------------------------------------------------------    
//    /* (non-Javadoc)
//     * @see java.lang.Object#toString()
//     */
//    public String toString() 
//    {
//        int iChildrenCount = ( _items != null ? _items.size() : 0 ) ;
//        String sChilNodes = ( iChildrenCount > 0 ? iChildrenCount + " child node(s) " : "no child nodes" );
//        return "MenuNode [type:"+_iType +"|id:" +_sId +"|cl:"+_sCl + "|style:" +_sStyle
//        +"|img:"+_sImg +"|txt:"+_sTxt + "|onclick:"+_sOnClick + "|"+sChilNodes + "]";
//    }
    
}
