package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;


/**
 * HTML generation for ColorPicker DIV
 * 
 * @author Laurent GUERIN
 *  
 */
public class ColorPickerHTML 
{
    private String [] _palette1 = { 
            "#000000", "#333333", "#666666", "#999999", "#CCCCCC", "#FFFFFF", 
            "#FF0000", "#00FF00", "#0000FF", "#FFFF00", "#00FFFF", "#FF00FF"
            } ;
    
    private String [][][] _paletteColors = null ;
    
    //-------------------------------------------------------------------------------
    /**
     * 
     */
    public ColorPickerHTML()
    {
        super();
        
        //--- Build the palette 
        String palette [][][] = new String [6][6][6] ; 
        
        String a[] = {"00", "33", "66", "99", "CC", "FF" };
        
        for ( int i = 0 ; i < 6 ; i++ )
        {
            for ( int j = 0 ; j < 6 ; j++ )
            {
                for ( int k = 0 ; k < 6 ; k++ )
                {
                    palette [i][j][k] = "#" + a[i]+a[k]+a[j];
                }
            }            
        }
        _paletteColors = palette ;
    }
    
    //-------------------------------------------------------------------------------
    private void printColor1( JspWriter out, String sColorPickerVar, String sCode ) throws IOException
    {
        String s = "<tr>"+
        "<td bgcolor=\"" + sCode + "\" " + 
        "onMouseOver=\"" + sColorPickerVar + ".preview('"+ sCode + "')\" " + 
        "onmousedown=\"" + sColorPickerVar + ".select('"+ sCode + "')\" " + 
        "height=\"12\" width=\"20\"></td>"+
        "</tr> " ;
        out.println ( s ) ;
    }
    
    //-------------------------------------------------------------------------------
    private void printPalette1( JspWriter out, String sColorPickerVar ) throws IOException
    {
        //  style=\"cursor: hand;\" 
        out.println ("<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"#000000\" >" );
        for ( int i=0 ; i < _palette1.length ; i++ )
        {
            printColor1( out, sColorPickerVar, _palette1[i] );
        }
        out.println ("</table>" );
    }

    //-------------------------------------------------------------------------------
    private void printFields( JspWriter out, String sColorPickerVar, String sFieldId1, String sFieldId2 ) throws IOException
    {
        //  style=\"cursor: hand;\" 
        out.println ("<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\" style=\"margin-bottom:2px;\" >" );
        out.println ("<tr>" );
        out.println ("<td><input id=\"" + sFieldId1 + "\" type=\"text\" readonly=\"readonly\" "+
                "style=\"background-color:#FFFFFF; border: 1px solid black; height:24px; width:100px\" ></td>" );
        out.println ("<td style=\"width:2px\">&nbsp;</td>");
        out.println ("<td><input id=\"" + sFieldId2 + "\" type=\"text\" readonly=\"readonly\" "+
        "style=\"background-color:#FFFFFF; border: 1px solid black; height:24px; width:68px\" ></td>" );
        out.println ("<td width=\"100%\"></td>");
        out.println ("<td><input type=\"button\" value=\"X\" style=\" height:24px; width:24px;\" " +
                "onclick=\"" + sColorPickerVar + ".close()\" ></td>" );
        out.println ("</tr>" );
        out.println ("</table>" );
    }
    
    //-------------------------------------------------------------------------------
    private void printColor2( JspWriter out, String sColorPickerVar, String sCode ) throws IOException
    {
        String s = "<td bgcolor=\"" + sCode + "\" " + 
        "onMouseOver=\"" + sColorPickerVar + ".preview('"+ sCode + "')\" " + 
        "onmousedown=\"" + sColorPickerVar + ".select('"+ sCode + "')\" " + 
        "height=\"10\" width=\"10\"></td> " ;
        
        out.println ( s ) ;
    }
    //-------------------------------------------------------------------------------
    private void printPalette2( JspWriter out, String sColorPickerVar ) throws IOException
    {
        out.println ("<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"#000000\" >" );
        for ( int iRow = 0 ; iRow < 6 ; iRow++ ) // 6 Lines ( 3 squares )
        {
            out.println ( "<tr>" ) ;                
		    for ( int iSquare = 0 ; iSquare < 3 ; iSquare++ )
		    {
		        int x = 0 ;
                for ( int i = 0 ; i < 6 ; i++ )
                {
                    printColor2( out, sColorPickerVar, _paletteColors [iSquare][x][iRow] );
                    x++;
                }
            }
		    out.println ( "</tr>" ) ;                
        }
        for ( int iRow = 0 ; iRow < 6 ; iRow++ ) // 6 Lines ( 3 next squares )
        {
            out.println ( "<tr>" ) ;                
		    for ( int iSquare = 3 ; iSquare < 6 ; iSquare++ )
		    {
		        int x = 0 ;
                for ( int i = 0 ; i < 6 ; i++ )
                {
                    printColor2( out, sColorPickerVar, _paletteColors [iSquare][x][iRow] );
                    x++;
                }
            }
		    out.println ( "</tr>" ) ;                
        }
        out.println ( "</table>" ) ;
    }
    
    //-------------------------------------------------------------------------------
    public void print( JspWriter out, String sEditorId, String sColorPickerVar ) throws IOException
    {
        String sColorPickerDivId = "fwk" + sEditorId + "CP" ;
        String sFieldColorId     = "fwk" + sEditorId + "CPF1" ;
        String sFieldCodeId      = "fwk" + sEditorId + "CPF2" ;
        
        String sPosition = "position:absolute; top:128px; left:200px;" ; // TODO 
        
        out.println ("<div id=\"" + sColorPickerDivId + "\" " +
                "style=\"" + sPosition + 
                " border:2px solid #666666; background-color:#DDDDDD;visibility:hidden \" >" ) ;
        
        out.println ("<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" ><tr>");
        
        //--- Print LEFT COL 
        out.println ("<td>");
        printPalette1(out, sColorPickerVar) ;
        out.println ("</td>");
        
        //--- Print RIGHT COL 
        out.println ("<td>");
        printFields(out, sColorPickerVar, sFieldColorId, sFieldCodeId ) ;
        printPalette2(out, sColorPickerVar) ;
        out.println ("</td>");
        
        out.println ("</tr></table>");

        out.println ("</div>");
        
        //--- ColorPicker object creation 
        out.println ("<script language=\"JavaScript\" type=\"text/javascript\">" );
        out.println ("var "+sColorPickerVar+" = new ColorPicker('"+sEditorId+"','"+sColorPickerDivId+"','"+sFieldColorId+"','"+sFieldCodeId+"');" );
        out.println ("</script>" );
    }
    
}