package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.ComboBox;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for ComboBox widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ComboBoxHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ComboBox tag = (ComboBox) genericTag;

        //--- Open the tag
        out.print("<select " + getIdAttr(tag) + " " + getClassAttr(tag) + " " + getStyleAttr(tag) + " " + getTitleAttr(tag) + " " + getTabindexAttr(tag) + " ");

        if (tag.getName() != null)
        {
            out.print(" name=\"" + tag.getName() + "\"");
        }

        if (tag.getDisabledAsBoolean())
        {
            out.print(" disabled=\"disabled\" ");
        }

        //--- Events set for this tag
        tag.printEvents(out);
        out.print(" >");
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //--- Close the tag
        out.print("</select>");
        ComboBox tag = (ComboBox) genericTag;
        //--- Register the current field via Javascript ...
        registerField(tag);
    }
    //----------------------------------------------------------------
    private void registerField(ComboBox tag) 
    {
        if (needRegister(tag))
        {
            String sFirstArgs = firstArgsToRegister(tag);
            String sJavascript = "RegisterComboBox(" + sFirstArgs + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }
    //----------------------------------------------------------------
}