package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.Container;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for Container widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ContainerHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Container tag = (Container) genericTag;

        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");        
        //out.print(getSpecificStyleAttr(tag) + " "); // v 1.0.2
        out.print(getContainerStyleAttr(tag) + " "); // v 1.0.2
        out.print(getTitleAttr(tag) + " ");
        out.println(" >");        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Container tag = (Container) genericTag;
        
        out.println( "</div>");
        
        //--- Generate the script to set the specific "onpopulate" event
        if  ( tag.getOnpopulate() != null )
        {            
			out.println("<script type=\"text/javascript\" >");
			out.println("var telosysTempVar = document.getElementById(\"" + tag.getId() + "\" );" );
			out.println("if ( telosysTempVar != null ) {");
			out.println(" telosysTempVar.onpopulate =\"" + tag.getOnpopulate() + "\" ; " );
			out.println("} else {");
			out.println(" alert ( \"ERROR : Cannot found container '" + tag.getId() + "' \" );" );
			out.println("}");
			out.println("</script>");
        }
        
        //--- Register the current view container via Javascript ...
        registerView(tag);
    }
    //----------------------------------------------------------------
    //----------------------------------------------------------------
// v 1.0.2
//    private String getSpecificStyleAttr(Container tag)
//    {        
//        if (tag.isPositionAbsolute())
//        {
//            return getStyleAttrWithPosition(tag);
//        }
//        else
//        {
//            //--- Style set by user + Width/Height + force "relative position"
//            String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidthHeight(tag) + "position:relative;" ;
//            return " style=\"" + sStyle + "\" " ;            
//        }
//    }
    //----------------------------------------------------------------
    private void registerView(Container tag) 
    {
        if ( tag.hasId() && ( tag.hasZone() || ( tag.getView() != null ) ) )
        {
            String sJavascript = "RegisterView(" + buildArgumentsList(tag) + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }    
    //----------------------------------------------------------------
    private String buildArgumentsList(Container tag)
    {
        //--- 1 : Tag ID
        String sId = "\"" + tag.getId() + "\"";

        //--- 2 : Zone name
        String sZone = "null";
        if (tag.hasZone())
        {
            sZone = tag.getZone();
            if (sZone != null)
            {
                sZone = "\"" + sZone.trim() + "\"";
            }
        }

        //--- 3 : View name 
        String sView = tag.getView();
        if ( sView != null )
        {
            sView = "\"" + sView.trim() + "\"";
        }
        else
        {
            sView = "null";
        }
        
        //--- 4 : Renderer 
        String sRenderer = tag.getRenderer();
        if ( sRenderer != null )
        {
            sRenderer = "\"" + sRenderer.trim() + "\"";
        }
        else
        {
            sRenderer = "null";
        }
        
        return sId + ", " + sZone + ", " + sView + ", " + sRenderer ;
    }    
}