package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.GroupBox;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for GroupBox widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class GroupBoxHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        GroupBox tag = (GroupBox) genericTag;
        String sTxt = tag.getTxt();

        out.print("<fieldset ");
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getStyleAttr(tag) + " ");
        out.print(getTitleAttr(tag) + " ");
        //out.print(getTabindexAttr(tag) + " ");
        out.println(" >");
        
        //--- Legend if any
        if (sTxt != null)
        {
            out.print("<legend>" + sTxt + "</legend>");            
        }
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.print( "</fieldset>");
    }
    //----------------------------------------------------------------
}