package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.HtmlViewer;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for HtmlViewer widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class HtmlViewerHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        HtmlViewer tag = (HtmlViewer) genericTag;

        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");        
        out.print(getContainerStyleAttr(tag) + " "); //out.print(getStyleAttr(tag) + " ");
        out.print(getTitleAttr(tag) + " ");
        out.println(" >");        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        HtmlViewer tag = (HtmlViewer) genericTag;
        
        out.println( "</div>");
        
//        //--- Generate the script to set the specific "onpopulate" event
//        if  ( tag.getOnpopulate() != null )
//        {            
//			out.println("<script type=\"text/javascript\" >");
//			out.println("var telosysTempVar = document.getElementById(\"" + tag.getId() + "\" );" );
//			out.println("if ( telosysTempVar != null ) {");
//			out.println(" telosysTempVar.onpopulate =\"" + tag.getOnpopulate() + "\" ; " );
//			out.println("} else {");
//			out.println(" alert ( \"ERROR : Cannot found container '" + tag.getId() + "' \" );" );
//			out.println("}");
//			out.println("</script>");
//        }
        
        //--- Register via Javascript ...
        if (needRegister(tag))
        {
            String sFirstArgs = firstArgsToRegister(tag);
            String sJavascript = "RegisterHtmlViewer(" + sFirstArgs + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }
    //----------------------------------------------------------------
    //----------------------------------------------------------------
//    private String getSpecificStyleAttr(HtmlViewer tag)
//    {        
//        if (tag.isPositionAbsolute())
//        {
//            return getStyleAttrWithPosition(tag);
//        }
//        else
//        {
//            //--- Style set by user + Width/Height + force "relative position"
//            String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidthHeight(tag) + "position:relative;" ;
//            return " style=\"" + sStyle + "\" " ;            
//        }
//    }
}