package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.LinkScreen;

/**
 * HTML generation for Link widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class LinkScreenHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        LinkScreen tag = (LinkScreen) genericTag ;

        String sLinkURL = tag.getLinkURL() ;
        String sTarget = tag.getTarget() ;
        String sTxt = tag.getTxt();

        out.print("<a ");
        out.print( getIdAttr(tag)+ " " );
        out.print( getClassAttr(tag)+" " );
        out.print( getStyleAttr(tag)+" " );
        out.print( getTitleAttr(tag)+" " );
        out.print( getTabindexAttr(tag)+" " );
        
        out.print(" href=\"" + sLinkURL + "\"");
        
        if ( sTarget != null )
        {
            out.print(" target=\"" + sTarget + "\"");  
            // ie: _blank, _self, _top, _parent
        }
        
        //--- Events set by user
        tag.printEvents(out);
        
        out.print(">");
        
        // v 0.9.9  : EVAL BODY if no txt
//        if ( sTxt == null )
//        {
//            sTxt = sLinkURL ;
//        }
//        out.print( sTxt );
//        out.print("</a>");        
//        out.println("");
        
        if ( sTxt != null ) // Only if TXT ( if no txt => EVAL BODY => endTag )
        {
            out.print( sTxt ); // No END-OF-LINE
        }
        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //--- Close the <A> tag
        out.print("</a>");
    }
}