package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.ListColumns;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ListCell;
import org.objectweb.telosys.util.StrUtil;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListCellHTML extends GenericHTML implements IWidget
{
    
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ListCell tag = (ListCell) genericTag;
        
        PageContext pageContext = tag.getPageContext();
        //boolean bInListBody   = Page.inListBody(pageContext);
        boolean bInListHeader = Page.inListHeader(pageContext);
        
        //--- NEXT CELL
        ListColumns cols = Page.getListColumns(pageContext);
        if ( cols != null )
        {
            //System.out.println("  - CELL : cols found , current = " + cols.getCurrent() );
            cols.next();            
        }
            
        int iWidth = StrUtil.getInt ( tag.getWidth(), 0 ) ;
        if ( iWidth == 0 )
        {
            //--- Set default Width 
            iWidth = 50 ;
            //--- If we are in the "BODY" => Try to get the "HEADER CELL WIDTH" 
            //if ( bInListBody )
            if ( ! bInListHeader )
            {
                //System.out.println("  - CELL : in BODY ");
    	        if ( cols != null )
    	        {
    	            iWidth = cols.getWidth();            
    	            //System.out.println("  - CELL : get Width " + iWidth + "current = " + cols.getCurrent());
    	        }
            }
        }

        //--- If we are in the "HEADER" => Keep the column width for the BODY 
        //if ( Page.inListHeader(pageContext) )
        if ( bInListHeader )
        {
            //System.out.println("  - CELL : in HEAD ");
	        if ( cols != null )
	        {
	            //System.out.println("  - CELL : set Width " + iWidth);
	            cols.setWidth(iWidth);            
	        }
        }
        //--- Style attribute
        String sStyle = getStyleFragUserStyle(tag) + "width:" + iWidth + "px;" ;

        //--- Tag <td ... >
        String sDefaultClass = null ; 
//        if ( bInListHeader )  sDefaultClass = "telosys_cell_head" ; 
//        if ( bInListBody )    sDefaultClass = "telosys_cell_body" ; 
        // v 1.0.1
        if ( bInListHeader ) sDefaultClass = "telosys_cell_head" ; 
        else                 sDefaultClass = "telosys_cell_body" ; 
        
        out.print("<td "                 
                + getIdAttr(tag)+ " "
                + getClassAttr(tag, sDefaultClass)+" "
                + "style=\"" + sStyle + "\" " );
        
        String s = null ;
        //--- ALIGN
        if ( ( s = tag.getAlign() ) != null )
        {
            out.print("align=\"" + s + "\" " );                           
        }
        //--- COLSPAN
        if ( ( s = tag.getColspan() ) != null )
        {
            out.print("colspan=\"" + s + "\" " );                           
        }
        //--- ROWSPAN
        if ( ( s = tag.getRowspan() ) != null )
        {
            out.print("rowspan=\"" + s + "\" " );                           
        }
        
        //--- Events set for this tag
        //tag.printEvents(out);
        //tag.printEvents(out, varSetter); // v 0.9.8
        tag.printEvents(out); // v 0.9.8 --> Intgr dans GenericTag
        out.print(" >");        
        
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println("</td>");
    }
    //----------------------------------------------------------------
}