package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.ListDiv;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.List;

/**
 * HTML generation for Panel widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListHTML extends GenericHTML implements IWidget
{
    //private final static int DEFAULT_WIDTH = 300;
    
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        List tag = (List) genericTag;

        //--- Get an ID and WIDTH for the main DIV
        String sId = tag.getId(); // AUTO GENERATE ( => Not null )
        
//        String sWidth = tag.getWidth();
//        int iWidth = DEFAULT_WIDTH ;        
//        if ( sWidth != null )
//        {
//            iWidth = StrUtil.getInt(sWidth.trim(), DEFAULT_WIDTH);
//        }        
        int iWidth = tag.getWidthInt();
        
        //--- Create a DIV MANAGEMENT object and store it for future use
        ListDiv listDiv = new ListDiv(sId, iWidth);
        Page.setListDiv(tag.getPageContext(), listDiv);
        
        out.print( "<div " );
        out.print( "id=\"" + sId + "\" " );
        //String s = "width:" + sWidth + "px;" + getStyleFragPosition(tag) ; // "width:...px" 
        String s = getStyleFragPosition(tag) ; //  X/Y position if any  
        if ( s != null )
        {
            if ( s.length() > 0 )
            {
                out.print( "style=\"" + s + "\" " );                
            }            
        }
        
        //--- Events set for this tag        
        tag.printEvents(out); // v 0.9.8
        
        out.println(">");
        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println( "</div>");
        
        //--- Generate JavaScript to ajust the HEAD Width ?
        ListDiv listDiv = Page.getListDiv(genericTag.getPageContext());
        if ( listDiv != null )
        {
            int iWidth = listDiv.getWidthBody();
            if ( iWidth != TagConst.WIDTH_NULL && iWidth > 0 )
            {
                out.println( "<script type=\"text/javaScript\" >");
                out.println( "fwkAdjustHeadWidth('"+listDiv.getIdHead()+"', '" + listDiv.getIdBody() +"');");        
                out.println( "</script>");                            
            }
            else
            {
                out.println( "");            
                out.println( "<!-- BODY Width = " + iWidth + " : no scroll, no width adjustment -->");                                        
            }
            //--- v 1.0.1 : remove to avoid reuse in an other list
            Page.setListDiv(genericTag.getPageContext(), null); // v 1.0.1
        }
        else
        {
            out.println( "");            
            out.println( "<!-- ERROR : Cannot get ListDiv from pageContext -->");                        
        }
    }
    //----------------------------------------------------------------
}