package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.ListColumns;
import org.objectweb.telosys.uil.taglib.ListDiv;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ListHead;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListHeadHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ListHead tag = (ListHead) genericTag;
        PageContext pageContext = tag.getPageContext();

        Page.setListHeader(pageContext, true);
        ListColumns cols = Page.getListColumns(pageContext);
        if ( cols != null )
        {
            cols.resetAll();            
        }

        //--- ID and WIDTH 
        String sId = tag.getId() ;
        int iWidth = tag.getWidthInt() ; 
        ListDiv listDiv = Page.getListDiv(tag.getPageContext());
        if ( listDiv != null )
        {
            if ( sId == null ) // No id for this tag => use the default id
            {
                sId = listDiv.getIdHead() ;                
            }
            else
            {
                //--- id is set for this tag => keep it for the future
                listDiv.setIdHead(sId);
            }
            if ( iWidth == TagConst.WIDTH_NULL )
            {
                iWidth = listDiv.getWidthHead();                
            }
        }

        String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidth(iWidth) + "overflow: hidden;";

        //--- Tag <div ... >
        out.print("<div "
	        + getIdAttr(sId) + " "
	        + getClassAttr(tag, "telosys_list_head" ) + " "
	        + getStyleAttr(sStyle) + " "
        	+ ">");
        
        //--- Tags <table ... > + <tbody> 
        out.print("<table cellspacing=\"0\" style=\"table-layout:fixed; width:1%; \" >");
        out.print("<tbody>");        
        out.println("");        
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //ListHead tag = (ListHead) genericTag;
        
        //TODO : no useless ( align left is sufficient )
//        if ( scroll == true )
//        {
//            out.println("<td>&nbsp;</td>");             
//        }

        //--- Close all tags
        out.print("</tbody>");
        out.print("</table>");
        out.print("</div>");        
        out.println("");
        
        PageContext pageContext = genericTag.getPageContext();
        Page.setListHeader(pageContext, false);

    }
    //----------------------------------------------------------------
}