package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.ListColumns;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.Event;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ListRow;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListRowHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ListRow tag = (ListRow) genericTag;

        PageContext pageContext = tag.getPageContext();
        //boolean bInListBody   = Page.inListBody(pageContext);
        boolean bInListHeader = Page.inListHeader(pageContext);

        //--- Create a "Variables Setter" for the current page context
        //VarSetter varSetter = new TagVarSetter( pageContext );
        
        //--- Reset the current cell to the begining 
        ListColumns cols = Page.getListColumns( pageContext );
        if ( cols != null )
        {
            //System.out.println("ROW : LisyBodyHTML - RESET ");
            cols.resetCurrent();            
        }
        
        //--- Tag <tr ... >
        String sDefaultClass = null ; 
//        if ( bInListHeader )  sDefaultClass = null ; 
//        if ( bInListBody )    sDefaultClass = "telosys_row_body" ; 
        // v 1.0.1
        if ( bInListHeader ) sDefaultClass = null ; 
        else                 sDefaultClass = "telosys_row_body" ; 
        
        out.print("<tr "                 
                + getIdAttr(tag)+ " "
                + getClassAttr(tag,sDefaultClass)+" "
                + getStyleAttr(tag)+" " );
        
        //--- Events for this tag   
        //if ( bInListBody )
        if ( ! bInListHeader ) // v 1.0.1
        {            
            //--- onmouseover + onmouseout
            String sOnMouseOver = tag.getEvent(Event.ON_MOUSE_OVER) ;
            String sOnMouseOut  = tag.getEvent(Event.ON_MOUSE_OUT) ;
            if ( tag.isOverflying() )
            {            
		        if ( sOnMouseOver == null && sOnMouseOut == null )
		        {
		            //--- Nothing defined by user => standard "overflying" behavior
		            sOnMouseOver = "fwkListRowMouseOver(this)";
		            sOnMouseOut  = "fwkListRowMouseOut(this)";		            
		        }
	            //--- ELSE : Something defined by user => don't touch !
            }
//            tag.printEvent(out, Event.ON_MOUSE_OVER, sOnMouseOver, varSetter); // print if not null
//            tag.printEvent(out, Event.ON_MOUSE_OUT,  sOnMouseOut,  varSetter); // print if not null
            tag.printEvent(out, Event.ON_MOUSE_OVER, sOnMouseOver); // print if not null
            tag.printEvent(out, Event.ON_MOUSE_OUT,  sOnMouseOut); // print if not null

            //--- onclick
            String sOnClick = tag.getEvent(Event.ON_CLICK) ;
            if ( tag.isSelectable() )
            {
    	        if ( sOnClick != null )
    	        {
    	            sOnClick = "fwkListRowSelect(this);" + sOnClick;
    	        }
    	        else
    	        {
    	            sOnClick = "fwkListRowSelect(this);" ;
    	        }
            }            
//	        tag.printEvent(out, Event.ON_CLICK, sOnClick, varSetter); // print if not null
	        tag.printEvent(out, Event.ON_CLICK, sOnClick); // print if not null
	        
            //--- other events ...
//            tag.printEvent(out, Event.ON_DBL_CLICK,  varSetter);
//            tag.printEvent(out, Event.ON_MOUSE_DOWN, varSetter);
//            tag.printEvent(out, Event.ON_MOUSE_UP,   varSetter);
            tag.printEvent(out, Event.ON_DBL_CLICK  );
            tag.printEvent(out, Event.ON_MOUSE_DOWN );
            tag.printEvent(out, Event.ON_MOUSE_UP   );
        }
        else
        {
            //--- Generate all the events set 
//            tag.printEvents(out, varSetter);             
            tag.printEvents(out);             
        }
        out.print(" >");        
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println("</tr>");
    }
    //----------------------------------------------------------------
}