package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ScreenBody;

/**
 * HTML generation for ScreenBody widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ScreenBodyHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ScreenBody tag = (ScreenBody) genericTag;

        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getStyleAttr(tag) + " ");
        //out.print(getTitleAttr(tag) + " ");
        //out.print(getTabindexAttr(tag) + " ");
        out.println(" >");
        
        //tag.initFieldsToRegister();
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //ScreenBody tag = (ScreenBody) genericTag ;
        out.println( "</div>");
        registerFields(out, genericTag);
        //tag.clearFieldsToRegister();
    }
    //----------------------------------------------------------------
    private void registerFields(JspWriter out, GenericTag genericTag) throws IOException
    {
        //ScreenBody tag = (ScreenBody) genericTag ;
        //tag.getFieldsToRegister();
        
        LinkedList lines = Page.getJavascriptLines(genericTag.getPageContext());
        if ( lines != null )
        {
            out.println( "");
            out.println( "<!-- Javascript bloc generated -->");
            out.println( "<script type=\"text/javascript\">");
            out.println( "function TelosysRegisterFields( theScreen )");
            out.println( "{");
            Iterator it = lines.iterator();
            if ( it != null )
            {
                String sLine = null ;
                while ( it.hasNext() )
                {
                    sLine = (String) it.next() ;
                    if ( sLine != null )
                    {
                        String s = sLine.trim() ;
                        if ( s.startsWith("Register") )
                        {                        
                            //--- Screen method
                            out.println( "  theScreen." + s + ";" );                                                    
                        }
                        else
                        {
                            //--- Othe Javascript line => print as is
                            out.println( "  " + s );                                                                                
                        }
                    }
                }
            }
            out.println( "}");
            out.println( "try {" );
            out.println( "  TelosysRegisterFields( telosys.getCurrentScreen() );" ) ;
            out.println( "} catch ( ex ) { " );
            out.println( "    alert('Runtime ERROR - RegisterFields : \\n' + ex.message ); " );
            out.println( "}");            
            out.println( "</script>");            
        }
        else
        {
            out.println( "");
            out.println( "<!-- No fields to register (no dynamic Javascript lines) -->");            
        }
    }
    //----------------------------------------------------------------
}