package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.uil.taglib.JSLines;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.TabBox;

/**
 * Widget HTML generator 
 * 
 * @author Laurent GUERIN
 *  
 */
public class TabBoxHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TabBox tag = (TabBox) genericTag ;
        /**
        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getStyleAttr(tag) + " ");
        //out.print(getTitleAttr(tag) + " ");
        //out.print(getTabindexAttr(tag) + " ");
        String sAlign =  tag.getAlign() ;
        if ( sAlign != null )
        {
            out.print(" align=\"" + sAlign + "\" ");            
        }
        out.println(" >");
        **/        
        out.print( "<table " ); 
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getSpecificStyleAttr(tag) + " ");
        out.println(" >");
        //class="telosys_layout" style="position:absolute; top:100px; left:100px " >

    }    
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TabBox tag = (TabBox) genericTag ;
        
        /**
        out.println( "</div>" );
        String sSelectedTabId = tag.getSelectedTabId();
        if ( sSelectedTabId != null )
        {
            sSelectedTabId = sSelectedTabId.trim() ;
            out.println( "<script type=\"text/javascript\"> fwkSelectTab(\"" + sSelectedTabId + "\");  </script>" );            
        }
        else
        {
            out.println( "<!-- No selected tab -->" );                        
        }
        **/
        out.println( "</table>" );
        
        //--- Javascript
        String sJS = "/* No selected tab */" ;
        String sSelectedTabId = tag.getSelectedTabId();
        if ( sSelectedTabId != null )
        {
            sSelectedTabId = sSelectedTabId.trim() ;
            //out.println( "<script type=\"text/javascript\"> fwkSelectTab(\"" + sSelectedTabId + "\");  </script>" );            
            sJS = "fwkSelectTab(\"" + sSelectedTabId + "\"); " ;
        }
        JSLines.addLine(tag.getPageContext(), JSLines.TABBOX, sJS);
        
        //--- Generate the JavaScript bloc for TABBOX initialization
        generateJavascript(out, tag.getPageContext());
    }
    //----------------------------------------------------------------
    protected String getSpecificStyleAttr(GenericTag tag)
    {
        String s = "";
        if (tag.isPositionAbsolute())
        {
            s = getStyleFragUserStyle(tag) + getStyleFragPosition(tag) + TagConst.CSS_STYLE_LAYOUT ;
        }
        else
        {
            s = getStyleFragUserStyle(tag) + TagConst.CSS_STYLE_LAYOUT ;
        }
        s = s.trim() ;
        if ( s.length() > 0 )
        {
            return "style=\"" + s + "\"";                    
        }
        else
        {
            return "";                                
        }
    }
    
    //----------------------------------------------------------------
    private void generateJavascript(JspWriter out, PageContext pageContext) throws IOException
    {
        LinkedList lines = JSLines.getJSLines(pageContext, JSLines.TABBOX );
        if ( lines != null )
        {
            out.println( "");
            out.println( "<!-- Javascript bloc generated -->");
            out.println( "<script type=\"text/javascript\">");
            //out.println( "function TelosysRegisterFields( theScreen )");
            out.println( "try {" );
            Iterator it = lines.iterator();
            if ( it != null )
            {
                String sLine = null ;
                while ( it.hasNext() )
                {
                    sLine = (String) it.next() ;
                    if ( sLine != null )
                    {
                        out.println( "  " + sLine );                                                                                
                    }
                }
            }
            out.println( "} catch ( ex ) { " );
            out.println( "    alert('Runtime ERROR - <tabbox> initialization : \\n' + ex.message ); " );
            out.println( "}");            
            out.println( "</script>");            
        }
        else
        {
            out.println( "");
            out.println( "<!-- No dynamic Javascript lines to generate -->");            
        }
    }
    //----------------------------------------------------------------

}
