package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.TabPanels;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class TabPanelsHTML extends GenericHTML implements IWidget
{
    private final static String DIV_STYLE = "border-width:0px; border-spacing:0px; position:relative; " ;
        
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TabPanels tag = (TabPanels) genericTag;

        //--- Tag <tr ... >
        out.println("<tr>");
        
        //--- Tag <td ... >
        out.print(" <td ");        
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(" style=\"" + getStyleFragUserStyle(tag) + "\" ");            
        out.println(" >");

        //--- Tag <div ... >
        out.print("  <div ");
        out.print(getSpecificStyleAttr(tag) + " ");        
        //out.print(" style=\"" + DIV_STYLE + "\" ");            
        out.println(" >");
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println("  </div>");
        out.println(" </td>");
        out.println("</tr>");        
    }
    //----------------------------------------------------------------
    private String getSpecificStyleAttr(TabPanels tag)
    {
        //--- Style set by user + Standard DIV style 
        //String sStyle = getStyleFragUserStyle(tag) + DIV_STYLE ;
        String sStyle = DIV_STYLE ;
        //--- DIV width
        String sWidthVal = tag.getTabBoxWidth() ;
        if ( sWidthVal != null )
        {
            sStyle = sStyle + "; width:" + sWidthVal + "px;"; 
        }
        //--- DIV height
        String sHeightVal = tag.getHeight() ;
        if ( sHeightVal != null )
        {
            sStyle = sStyle + "; height:" + sHeightVal + "px;"; 
        }
        return " style=\"" + sStyle + "\" " ;            
    }
}