package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.TextArea;

/**
 * HTML generation for TextArea widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class TextAreaHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TextArea tag = (TextArea) genericTag;

        out.print("<textarea ");
        //--- Generic widget attributes
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getStyleAttr(tag) + " ");
        out.print(getTitleAttr(tag) + " ");
        out.print(getTabindexAttr(tag) + " ");
        out.print(getNameAttr(tag) + " ");
        out.print(getDisabledAttr(tag) + " ");
        out.print(getReadonlyAttr(tag) + " ");

        //--- Specific widget attributes
        if (tag.getCols() != null)
        {
            out.print("cols=\"" + tag.getCols() + "\" ");
        }
        if (tag.getRows() != null)
        {
            out.print("rows=\"" + tag.getRows() + "\" ");
        }

        //--- Events set by user
        tag.printEvents(out);

        //--- End of OPENING tag
        out.print(">");

        String sValue = tag.getValue(); // use postback value if necessary
		if (sValue != null)
		{
		    out.print(sValue);
		}
        
        //--- CLOSING tag
        out.println("</textarea>");

    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TextArea tag = (TextArea) genericTag;
        //--- Register the current field via Javascript ...
        if (needRegister(tag))
        {
            String sFirstArgs = firstArgsToRegister(tag);
            String sJavascript = "RegisterTextArea(" + sFirstArgs + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }
    //----------------------------------------------------------------
}