package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.Button;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * XUL imlementation for Button widget
 * 
 * @author Laurent GUERIN
 *  
 */
//public class ButtonXUL extends GenericXUL implements IWidget
public class ButtonXUL implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Button tag = (Button) genericTag ;

        //Rcuperation des attributs
//      String sTxt = getAttributeValue(TAG_NAME, "txt", _sTxt);
//      String sImgSrc = getAttributeValue(TAG_NAME, "imgsrc", _sImgSrc);
//      String sImgPos = getAttributeValue(TAG_NAME, "imgpos", _sImgPos);
//      String sSpacer = getAttributeValue(TAG_NAME, "spacer", _sSpacer);

      String sTxt = tag.getTxt();
      //String sImgSrc = tag.getImgsrc();
      String sImgSrc = tag.getFullImageSrc();
      String sImgPos = tag.getImgpos();
      String sSpacer = tag.getSpacer();

      //--- Open the tag <button ... />
      out.print("<button " );
//      + getIdAttr(tag)+ " "
//      + getClassAttr(tag)+" "
//      + getStyleAttr(tag)+" "
//      + getTitleAttr(tag)+" " 
//      + getTabindexAttr(tag)+" " );
      
      out.print(" id=\"" + tag.getId() + "\"");
      //String sStyleXY = tag.stylePosition(GenericTag.XUL_OUTPUT);
      // TODO
      String sStyleXY = "" ;
      if (sStyleXY.trim().length() > 0)
      {
          out.print(" style=\"" + sStyleXY + "\"");
      }

      String sClass = tag.getCl();
      if ( sClass != null)
          out.print(" class=\"" + sClass + "\"");

//      if (sOnClick != null)
//          out.print(" onclick=\"" + sOnClick + "\"");
      tag.printEvents(out);
      //-- Gestion du positionnement de l'image

      if (sImgSrc != null)
      {
          out.print(" image=\"" + sImgSrc + "\"");
          if ("right".equals(sImgPos))
              out.print(" orient=\"horizontal\" dir=\"normal\"");
          else if ("left".equals(sImgPos))
              out.print(" orient=\"horizontal\" dir=\"reverse\"");
          else if ("top".equals(sImgPos))
              out.print(" orient=\"vertical\" dir=\"normal\"");
          else if ("bottom".equals(sImgPos))
              out.print(" orient=\"vertical\" dir=\"reverse\"");

          out.print(">");

          //--- Ajout de l'image et du texte
          out.print("<image src=\"" + sImgSrc + "\" ");
          //--- Ajout du spacer de l'image
          if ("right".equals(sImgPos))
              out.print(" style=\"margin-right:" + sSpacer + "px;\"");
          if ("left".equals(sImgPos))
              out.print("style=\"margin-left:" + sSpacer + "px;\"");
          if ("top".equals(sImgPos))
              out.print("style=\"margin-bottom:" + sSpacer + "px;\"");
          if ("bottom".equals(sImgPos))
              out.print("style=\"margin-top:" + sSpacer + "px;\"");

          out.print("/>");
          out.print("<label value=\"" + sTxt + "\"/>");
          out.print("</button>");
      }
      else
      {
          out.print(" label=\"" + sTxt + "\"/>");          
      }
    }    
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
    //----------------------------------------------------------------
}
