package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Link;

/**
 * XUL generation for Link widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class LinkXUL extends GenericXUL implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Link tag = (Link) genericTag ;

        String sTxt = tag.getTxtOrRef() ;
        String sHref = tag.getHref() ;
        String sCres = tag.getCres() ;
        String sRef = "" ;
        //String sTarget = tag.getTarget() ;

        //--- Define specific style for XUL to render as HTML link
        tag.defineStyle("text-decoration","underline");
        tag.defineStyle("cursor",         "pointer");
        tag.defineStyle("-moz-user-focus","normal");
        tag.defineStyle("color",          "#0000EE");
        
        out.print("<label ");
        out.print( getIdAttr(tag)+ " " );
//        out.print( getClassAttr(tag)+" " );
//        out.print( getStyleAttr(tag)+" " );
//        out.print( getTitleAttr(tag)+" " );
//        out.print( getTabindexAttr(tag)+" " );
        if ( sHref != null )
        {
            sRef = sHref ; // Standard HyperText Reference 
        }
        else
        {
            if ( sCres != null ) // Context Reference
            {
                sRef = tag.getFullContextRef();
            }            
        }        
        out.print(" onclick=\"window.location='" + sRef + "'\" ");
        
        out.print(" value=\"" + sTxt + "\" ");  

// TODO ???
//        if ( sTarget != null )
//        {
//            out.print(" target=\"" + sTarget + "\"");  
//            // ie: _blank, _self, _top, _parent
//        }

        out.print(" />");
        
        out.println("");
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
}