package org.objectweb.telosys.upload;

/**
 * 
 * All the http parameters provided by an upload request 
 * ( parameters set by the widget ) 
 * 
 * @author Laurent GUERIN
 * 
 *  
 */
public class UploadParameters
{

    //--- Limited data size
    private long   _lMaxSize          = -1;

    //--- Parameters for FileSystem storage
    private String _sDestDir          = null;

    //--- Parameters for ScreenContext storage
    private int    _iContextId        = -1;

    private String _sContextAttribute = null;

    //--- Parameters for Session storage
    private String _sSessionKey       = null;

    public UploadParameters()
    {
        super();
    }

    public int getContextId()
    {
        return _iContextId;
    }
    public void setContextId(int paramContextId)
    {
        _iContextId = paramContextId;
    }
    
    public long getMaxSize()
    {
        return _lMaxSize;
    }
    public void setMaxSize(long paramMaxSize)
    {
        _lMaxSize = paramMaxSize;
    }
    
    public String getContextAttribute()
    {
        return _sContextAttribute;
    }
    public void setContextAttribute(String paramContextAttribute)
    {
        _sContextAttribute = paramContextAttribute;
    }
    
    public String getDestDir()
    {
        return _sDestDir;
    }
    public void setDestDir(String paramDestDir)
    {
        _sDestDir = paramDestDir;
    }
    
    public String getSessionKey()
    {
        return _sSessionKey;
    }
    public void setSessionKey(String paramSessionKey)
    {
        _sSessionKey = paramSessionKey;
    }
}