package org.objectweb.telosys.util.serial;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.objectweb.telosys.common.TelosysException;

/**
 * @author L. GUERIN
 *
 */
public class FileSerializer
{

    private String _sFilePath = null ;
    
    public FileSerializer( String sFileName )
    {
        _sFilePath = sFileName ;
    }
    
    public void write ( Object obj ) throws TelosysException
    {
        FileOutputStream  fos = null ;
        ObjectOutputStream oos = null ;
        if ( _sFilePath == null )
        {
            throw new TelosysException("File path is null");
        }
        
        try
        {
            fos = new FileOutputStream ( _sFilePath );
        } catch (FileNotFoundException e1)
        {
            throw new TelosysException("Cannot create FileOutputStream", e1);
        }
        
        try
        {
            oos = new ObjectOutputStream(fos);
        } catch (IOException e2)
        {
            throw new TelosysException("Cannot create ObjectOutputStream", e2);
        }

        try
        {
            //--- WRITE THE OBJECT
            oos.writeObject( obj );
            //--- Close ALL
            oos.close();
            fos.close();
        } catch (IOException e3)
        {
            throw new TelosysException("ObjectOutputStream cannot write object ", e3);
        }
    }
    
    public Object read () throws TelosysException
    {
        FileInputStream   fis = null ;
        ObjectInputStream  ois = null ;
        Object obj = null ;
        if ( _sFilePath == null )
        {
            throw new TelosysException("File path is null");
        }
        
        try
        {
            fis = new FileInputStream ( _sFilePath );
        } catch (FileNotFoundException e1)
        {
            throw new TelosysException("Cannot create FileInputStream", e1);
        }
        
        try
        {
            ois = new ObjectInputStream(fis);
        } catch (IOException e2)
        {
            throw new TelosysException("Cannot create ObjectInputStream", e2);
        }

        try
        {
            //--- READ THE OBJECT
            obj = ois.readObject();
            //--- Close ALL
            ois.close();
            fis.close();
            
        } catch (IOException e3)
        {
            throw new TelosysException("ObjectOutputStream cannot read object (IOException)", e3);
        } catch (ClassNotFoundException e4)
        {
            throw new TelosysException("ObjectOutputStream cannot read object (ClassNotFoundException)", e4);
        }
        
        return obj;
    }
    
}
